@page RN10 Release notes for SCIP 10

@section RN1001 SCIP 10.0.1
***************************

Fixed bugs
----------

- fixed that parameters passed on as variadic arguments to SCIPsolveNLP() and SCIPsolveNlpi() were ignored when compiling with MS compilers without -Zc:preprocessor
- make more CONOPT output available when verbosity level is set to 2
- turn off detection of definitional constraints in CONOPT for now, to work around a related issue in CONOPT 4.39.0
- fixed call of SCIPcreateConsBasicSOCNonlinear() with coefs being NULL, and fixed check for offsets being finite
- avoid crash when initial IIS solve fails while reporting errors explicitly
- fixed that variable removal in IIS cleanup tried to delete variables that were marked as not deletable
- fixed that some IIS info messages were not using a user's message handler
- fixed use of interactive option (-i) of AMPL interface
- fixed failure in nl writing on big endian machines
- correct memory reallocation in storeSubproblemMasterVar() of benders.c to avoid errors when freeing memory
- also set real solution in SCIPsolSetValExact() to maintain approximation
- handle exact solutions in SCIPsolCheckOrig(), SCIPcheckSolOrig(), and SCIPrecomputeSolObj() to correctly check exact initial solutions in SCIPtransformProb()
- fixed calculation of Euclidean norm in calcEfficacyDenseStorage() for use in exact solving
- removed unnecessary explicit linking of GMP library for exact solving mode unittests
- fixed bug with changing the type of the slack variable in indicator constraints while copying
- signal extreme estimations in timeSeriesEstimate() and skip pruning estimations in eventExecEstim() to avoid unstable restarting
- fixed parallelism computation of dynamic cut selector to use Euclidean norm instead of unsupported argument
- fixed that non-efficacious cuts were not filtered out before checking dynamic parallelism in dynamic cut selector
- fixes in nauty.h for 32bit systems
- fixed SCIPgetDualSolVal() for a linear constraint with a single variable
- adjust conflictAnalyzeLP() to inability of row aggregation to handle a change in the number of variables
- propagate child lower bounds back to focus node to ensure consistent lower bound tracking

Miscellaneous
-------------

- updated ampl/mp to version 4.0.4
- switch from GetTempPath2A to GetTempPathA in nl writer for Windows for broader compatibility

@section RN1000 SCIP 10.0.0
***************************

Features and Performance Improvements
-------------------------------------

### Exact Solving
- added numerically exact solving mode for mixed-integer linear programs to the core framework including certification of branch-and-bound phase
- core extensions:
  - new wrapper struct SCIP_RATIONAL for rational arithmetic currently based on Boost, GMP, and MPFR
  - new data structure SCIP_LPEXACT for handling rational LP relaxation and computing safe dual bounds
  - new interfaces to exact LP solvers SoPlex and QSopt_ex
  - safe dualproof version of conflict analysis
  - new data structure SCIP_CERTIFICATE for certificate printing/proof logging
- new plugins:
  - new constraint handler "exactlinear" for handling linear constraints with rational data
  - new constraint handler "exactsol" to post-process and repair solutions from floating-point heuristics
- plugins revised for numerically exact solving mode:
  - adjusted readers for MPS, LP, CIP, OPB/WBO, and ZIMPL files
  - extended presolver "milp" to perform rational presolving with PaPILO
  - adjusted constraint handler "integral" and default reliability pseudo-cost branching rule "relpscost"
  - extended Gomory cut separator to separate and certify numerically safe MIR cuts
  - adjusted all primal heuristics (except for five dedicated MINLP heuristics)
- new interfaces to exact LP solvers SoPlex and QSopt_ex

### Symmetry Handling
- added more techniques to handle reflection symmetries, in particular, for orbitopes with column reflections and matrices whose rows and columns can be permuted by a symmetry
- Dejavu can be used to compute symmetries; the source code is shipped with SCIP and incorporates sassy
- implemented symmetry detection callbacks for disjunction and superindicator constraint handlers
- detailed information about applied symmetry handling techniques can be printed to the terminal
- improve memory usage by introducing different constraint handlers for full orbitopes and packing/partitioning orbitopes
- symmetry detection no longer treats implicit integer variables separately, but computes symmetries based on the variable type inferred from variable bounds and implied integrality
- extended the statistics to also include information about the number of variables (per type) affected by symmetry
- implemented method to compute new permutations from a given list of symmetry group generators
- cons_orbisack, cons_orbitope_full, cons_orbitope_pp, and cons_symresack now try to replace the stored aggregated variables by active ones at the end of presolving;
  this should reduce the size of copies of the presolved problem
- simplified symmetry detection graphs in case all edges have the same color

### Presolve
- distinguish implicit integrality of variables into strong and weak type, depending on whether integrality is implied for all feasible or only at least one optimal solution
- added a new presolver "implint", which detects implied integral variables by detecting (transposed) network submatrices in the problem; for now, this plugin is disabled by default
- added support for (transposed) network matrix detection
- allow multi-aggregation of unbounded slack variables, which may enable more bound tightening due to a reduction in the number of unbounded variables
- resolve all fixings in xor constraints also for an available integer variable

### Conflict Analysis
- added generalized resolution conflict analysis that operates directly on linear constraints instead of conflict graphs
- disabled dualsol and dualray conflict upgrades to maintain conflict store
- apply general conflict upgrades in conflict store

### Cutting Planes
- added a new separator "flower" to generate flower cuts from AND constraints and nonlinear product expressions
- added functionality to deal with hypergraphs by means of efficient access to vertices, edges, and intersections edges

### Primal Heuristics
- added decomposition kernel search (DKS) heuristic (disabled by default), which implements a kernel search framework;
  it can be used both as a construction heuristic as well as an improvement heuristic; existing decomposition information can be utilized
- reduced maximal fraction of diving LP iterations relative to total node LP iterations

### Branching
- added a dynamic max-lookahead criterion for strong branching; a probability distribution is fitted to the observed candidate gains and
  evaluating further candidates stops when the expected tree-size reduction no longer justifies the LP evaluation cost
- added new fields in history to store ancestral pseudo cost updates, used in the pseudo costs branching rule to compute discounted pseudo costs

### Nonlinearity
- added an interface to the NLP solver CONOPT
- implemented columnwise Jacobian sparsity computation in the NLP oracle
- extended SOC detection to simple bilinear constraints, e.g., x*y >= 1

### Infeasibility Analysis
- added the possibility to search for irreducible infeasible subsystems (IIS)
- added new plugin type for finding irreducible infeasible subsystems (IIS)
- new iisfinder plugin "greedy", which implements a greedy addition and deletion based algorithm with dynamic batch sizing

### Benders' Decomposition
- when solving a problem with additional decomposition information (for example, when reading a DEC file) and enabling decomposition/applybenders,
  the problem is now solved in a Benders' decomposition relaxator; instead of decomposing the original SCIP instance, the relaxator builds the decomposed problem in
  sub-SCIPs and solves it via default Benders' Decomposition; a solution to the original (undecomposed) problem is now made available by the relaxator;
  the SCIP shell dialog "display statistics" now also prints the statistics from solving the Benders' decomposition in the relaxator
- adds objective types for Benders' decomposition; the choices are to sum the subproblems objectives (classical approach) and to use the maximum of the subproblems objectives
- the linking master variables for each Benders' decomposition subproblem are now stored; these can be accessed for the generation of cuts and setting up the subproblems

### Reading and Writing
- added a new data structure SCIP_DATATREE that holds serializable data and a function to export to a JSON file
- added ability to collect statistics from tables in a SCIP_DATATREE and write out as JSON file;
  dialog write statistics now writes a JSON file if name of file to write ends with .json
- added writing support for AMPL NL writer: currently only general and specialized linear and nonlinear constraints can be written
- added support for AND-constraints to GAMS writer
- simplify expressions of nonlinear constraints in MPS and LP writing to increase chance that they are recognized as quadratic

### Applications
- New application "PBSolver" to solve pseudoboolean instances in OPB and WBO format while complying with PB competition rules
- Coloring: new parameter branching/coloring/strategy to choose the least/most fractional variable for branching

### Miscellaneous
- do not allow non-root restarts when no global fixings were found
- reimplemented SCIPvarGetActiveRepresentatives() by using dense arrays to avoid repeated resorting
- avoid unnecessary calls of constraint handlers components, benders, benderslp, propagator genvbounds, and heuristics ofins, subnlp, nlpdiving, indicator
- inlined SCIPgetStatus() to reduce computational overhead
- variable data pointer are now copied if no copy routine was supplied
- add check that parameter value pointers are unique, i.e., no two are the same

Interface changes
-----------------

### Deprecations

- The variable type \ref SCIP_VARTYPE_IMPLINT is deprecated in favor of a new enum \ref SCIP_IMPLINTTYPE that indicates if a
  variable is implied integral, independent of the variable type.
  The problem variable arrays is still sorted as:
  ```
   (0) | binary | integer | implied integral | continuous | (nvars),
  ```
  where the implied integral subsection is now subdivided into 3 parts (left to right):
  ```
  | binary implied integral | integer implied integral | continuous implied integral |
  ```
  SCIP 10 still supports using `SCIP_VARTYPE_IMPLINT` for backward compatibility, see SCIPcreateVar() and SCIPchgVarType() for more details.
  SCIP 11 will remove `SCIP_VARTYPE_IMPLINT`.
- SCIPsubversion() is deprecated and will be removed

### New and changed callbacks

- added SCIP_DECL_IISFINDERCOPY(), SCIP_DECL_IISFINDERFREE(), and SCIP_DECL_IISFINDEREXEC() for iisfinder implementations
- added a new callback SCIP_DECL_TABLECOLLECT() for the table plugin that collects the data for the specific statistics table in a SCIP_DATATREE object
- for a table plugin, only one of the callbacks SCIP_DECL_TABLECOLLECT() or SCIP_DECL_TABLEOUTPUT() needs to be implemented, but implementing both is preferred;
  if SCIP_DECL_TABLEOUTPUT() is omitted, then SCIP tries to print a table from the data given by SCIP_DECL_TABLECOLLECT()
- the callback SCIP_DECL_EXPRINTEGRALITY(), which returns the integrality of an expression, had its fourth argument changed from `SCIP_Bool*` to `SCIP_IMPLINTTYPE*` to represent implied integrality in nonlinear expressions,
  that is, an implied integral type of an auxiliary variable if the expression were assigned to it
- added argument `filename` to the SCIP_DECL_READERWRITE() callback in the 4th position
- the callback SCIP_DECL_READERWRITE() is equipped with `objoffset`, `objscale`, `objoffsetexact`, and `objscaleexact` as arguments 9 through 12 to write the exact objective offset and scale in exact mode

### Deleted and changed API functions

- SCIPgetProbvarLinearSum(): remove parameter `mergemultiples`, which is now automatically true with the new implementation of SCIPvarGetActiveRepresentatives()
- `SCIPcreateRow*()`, SCIPaddVarToRow(), SCIPaddVarsToRow(), SCIPaddVarsToRowSameCoef() can now only be called in the solving stage, because otherwise the LP is not yet available and the row data is invalid
- SCIPcreateConsPseudobooleanWithConss(), SCIPcreateConsPseudoboolean(), and SCIPcreateConsBasicPseudoboolean(): removed `intvar` from arguments because the non-linear objective reformulation with pseudoboolean constraints did not work
- SCIPcleanupConssLinear() and SCIPcleanupConssKnapsack(): added argument `ndelconss` to directly delete empty redundant constraints before creating problem matrix
- SCIPcopyPlugins(): added argument `copyiisfinders` (16th position)
- SCIPcreateConsOrbitope(): deleted two arguments and changed position of another argument
- SCIPvarCalcDistributionParameters(): argument `impltype` added (5th position)
- SCIPpermuteProb(): argument `permuteimplvars` has been replaced by new arguments `permutebinimplvars`, `permuteintimplvars`, and `permutecontimplvars`
- SCIPgetLPBranchCands(): implied integral variables with integrality constraints are included in `nlpcands` count and stored at the end of `lpcands`
- SCIPgetNLPBranchCands(): implied integral variables with integrality constraints are included
- SCIPgetSolVarsData(): argument `nimplvars` has been replaced by new arguments `nbinimplvars`, `nintimplvars`, and `ncontimplvars`
- SCIPexprSetIntegrality(): replaced argument `SCIP_Bool integral` by `SCIP_IMPLINTTYPE integrality` (4th position)
- SCIPcreateVar() (temporarily for SCIP 10 only): attempting to create a variable with type \ref SCIP_VARTYPE_IMPLINT creates a variable of type \ref SCIP_VARTYPE_CONTINUOUS and implied integral type \ref SCIP_IMPLINTTYPE_WEAK
- SCIPchgVarType() (temporarily for SCIP 10 only): attempting to change a variable type to \ref SCIP_VARTYPE_IMPLINT leads to a call of SCIPchgVarImplType() with type \ref SCIP_IMPLINTTYPE_WEAK
- `SCIPapplyBendersDecomposition()` has been removed; this was originally used to apply Benders' decomposition from a supplied decomposition structure; the application of Benders' decomposition now occurs in relax_benders
- SCIPcalcMIR(), SCIPcutGenerationHeuristicCMIR(), SCIPcalcStrongCG(): replaced boolean argument `usevbds` by an integer argument `vartypeusevbds`, which indicates for which variables variable bound substitution should be performed
- `SCIPchgAndConsCheckFlagWhenUpgr()`, `SCIPchgAndConsRemovableFlagWhenUpgr()`: removed to keep upgrade flags consistent; use SCIPconsAddUpgradeLocks() to control upgrades instead
- SCIPaddConflict(): argument `cons` changed to type `SCIP_CONS**` to release the conflict constraint in a clean way
- SCIPprintOrigProblem() and SCIPprintTransProblem(): moved declaration moved from scip_solvingstats.h to scip_prob.h
- `SCIPnlpiOracleGetJacobianSparsity()`: renamed to SCIPnlpiOracleGetJacobianRowSparsity() and added arguments `colnlflags` and `nnlnz`
- SCIPnlpiOracleGetHessianLagSparsity(), SCIPnlpiOracleEvalHessianLag(): added argument `colwise`
- SCIPxmlProcess(), SCIPxmlNewNode(), SCIPxmlNewAttr(), SCIPxmlAddAttr(), SCIPxmlAppendChild(), SCIPxmlFreeNode(), SCIPxmlShowNode(), SCIPxmlGetAttrval(), SCIPxmlFirstNode(), SCIPxmlNextNode(), SCIPxmlFindNode(), SCIPxmlFindNodeMaxdepth(), SCIPxmlNextSibl(), SCIPxmlPrevSibl(), SCIPxmlFirstChild(), SCIPxmlLastChild(), SCIPxmlGetName(), SCIPxmlGetLine(), SCIPxmlGetData(), SCIPxmlFindPcdata(): renamed XML functions by adding `SCIP` prefix to avoid name clash with libxml2
- `SCIPhashtableClear()`, `SCIPcomputeArraysIntersection()`, `SCIPcomputeArraysSetminus()`,
  `SCIPgetRandomInt()`, `SCIPgetRandomReal()`, `SCIPgetRandomSubset()`, `SCIPpermuteIntArray()`, `SCIPpermuteArray()`,
  `SCIPvarGetLbAtIndex()`, `SCIPvarGetUbAtIndex()`, `SCIPvarGetBdAtIndex()`, `SCIPvarWasFixedAtIndex()`,
  `SCIPaddCut()`, `SCIPcreateRow()`, `SCIPcreateEmptyRow()`, `SCIPlpfeastol()`, `SCIPchgLpfeastol()`,
  `SCIPsolveParallel()`, `SCIPwriteImplicationConflictGraph()`, `SCIPallowDualReds()`, `SCIPallowObjProp()`,
  `SCIPcreateConsQuadratic()`, `SCIPcreateConsBasicQuadratic()`, `SCIPaddConstantQuadratic()`, `SCIPaddLinearVarQuadratic()`, `SCIPaddQuadVarQuadratic()`, `SCIPaddQuadVarLinearCoefQuadratic()`, `SCIPaddSquareCoefQuadratic()`, `SCIPaddBilinTermQuadratic()`, `SCIPgetNlRowQuadratic()`, `SCIPchgLhsQuadratic()`, `SCIPchgRhsQuadratic()`,
  `SCIPcreateConsAbspower()`, `SCIPcreateConsBasicAbspower()`, `SCIPgetNlRowAbspower()`,
  `SCIPcreateConsSOC()`, `SCIPcreateConsBasicSOC()`, `SCIPgetNlRowSOC()`: removed, previously deprecated
- `SCIP_NLPTERMSTAT_TILIM`, `SCIP_NLPTERMSTAT_ITLIM`, `SCIP_NLPTERMSTAT_LOBJLIM`, `SCIP_NLPTERMSTAT_NUMERR`, `SCIP_NLPTERMSTAT_EVALERR`, `SCIP_NLPTERMSTAT_MEMERR`, `SCIP_NLPTERMSTAT_LICERR`: removed, these NLP termination status codes were previously deprecated
- `SCIPselectPtrRealReal()`, `SCIPselectWeightedPtrRealReal()`, `SCIPsortPtrRealReal()`, `SCIPreoptAddGlbCons()`, `SCIPreoptnodeGetSplitCons()`, `SCIPcomprInitsol()`, `SCIPcomprExitsol()`,
  `SCIPcertificatePrintSolExact()`, `SCIPincludeExLinconsUpgrade()`, `SCIPupgradeConsExactLinear()`, `SCIPgetRunningErrorStatsExactLinear()`, `SCIPcolExactGetMinPrimsol()`, `SCIPrationalarrayClear()`, `SCIPgetRowActivityExact()`, `SCIPgetRowFeasibilityExact()`, `SCIPvalsExactFree()`,
  `SCIPbendersApplyDecomposition()`, `SCIPgetExprsdataBilinear()`, `SCIPgetVarCoefChg()`, `SCIPvarGetOrigIndex()`, `SCIPallocateSymgraphConsnodeperm()`, `SCIPwriteSto()`: removed the declaration because there was no implementation

### New API functions

Exact Solving:
- SCIPenableExactSolving(): enable and disable exact solving mode; see below for a list of many new API functions added to support exact solving
- `SCIPrational*()`: create and compute with rational numbers
- SCIPintervalSetRational(): compute interval of rational number
- SCIPstrToRationalValue(), SCIPrationalStrLen(), SCIPrationalToString(): handle string conversion of a rational number
- SCIPrationalChgInfinity(), SCIPrationalGetInfinity(): handle infinity threshold of rational numbers
- `SCIPrationalarray*()`: create and handle rational arrays
- SCIPisExact(): query whether exact solving is enabled
- SCIPisCertified(): query whether certification is enabled
- `SCIPcertify*()`, `SCIP*Certificate()`: support proof logging/certificate generation
- `SCIP*MarkExact()`: mark plugins as safe to use in exact solving mode
- `SCIP*IsExact()` : query whether objects are ready for exact solving
- SCIPincludeConshdlrExactLinear(): include the constraint handler for exact linear constraints
- `SCIP*ExactLinear()`: create, query, and modify an exact linear constraint
- SCIPconsGetLhsExact()`, SCIPconsGetRhsExact(), SCIPgetConsValsExact(): query exact sides and coefficients of a linear constraint
- `SCIPmatrix*Exact()`: query matrix information in rational arithmetic
- SCIPaddVarExactData(): add exact data to an existing variable
- `SCIPvarGet*Exact()`: query variable information in rational arithmetic
- `SCIP*Var*Exact*()`: handle variables exactly
- SCIPchgVarLbExactDive(), SCIPchgVarUbExactDive(), SCIPisExactDivePossible(), SCIPinExactDive(), SCIPstartExactDive(), SCIPendExactDive(), SCIPsolveExactDiveLP(): handle exact LP diving
- SCIPlpExactDiving(): query whether exact LP is in diving mode
- SCIPlpExactIsSolved(): query whether the exact LP is solved
- SCIPwriteLPexact(): write the exact LP
- `SCIPcolExact*()`, `SCIProwExact*()`: handle the exact LP columns and rows
- `SCIPlpiExact*()`: handle the exact LP interface
- SCIPgetNExactLPs(): query the number of exact LP solves
- SCIPgetLPExactSolstat(), SCIPgetLPExactObjval(): query solution status and objective value of the exact LP
- SCIPaddOrigObjoffsetExact(), SCIPgetOrigObjoffsetExact(): add and query exact objective offset of the original problem
- `SCIP*Sol*Exact()`: create and handle exact solutions
- SCIPsolOrigAddObjvalExact(): add to exact objective of original solution
- SCIPincludeConshdlrExactSol(): include the exact post-processing for solutions
- `SCIP*Row*Exact*()`: create and handle exact LP rows
- `SCIPaggrRow*Safely()`: compute safe real row aggregation
- SCIPallowNegSlack(): query whether negative slacks are allowed
- SCIPbranchLPExact(): branch exactly on the LP solution
- SCIPeventGetOldboundExact(): query exact old bound for a bound change event
- SCIPcalcIntegralScalarExact(): compute a scalar so that all given values become exactly integral
- SCIPnodeGetLowerboundExact(): query the exact lower bound of a node
- SCIPgetCutoffboundExact(), SCIPgetLowerboundExact(), SCIPgetUpperboundExact(), SCIPgetDualboundExact(), SCIPgetPrimalboundExact(): query exact best bounds on optimal value
- SCIPvalidateSolveExact(): validate the exact solve

Implicit Integrality:
- SCIPincludePresolImplint(): include the new implied integral presolver
- SCIPcreateVarImpl(), SCIPcreateObjVarImpl(): behave identically to SCIPcreateVar() and SCIPcreateObjVar(), respectively, but have an additional argument for the new implied integral type flag (8th position)
- SCIPchgVarImplType(), SCIPvarGetImplType(), SCIPvarIsImpliedIntegral(), SCIPcolIsImpliedIntegral(): control and query implied integrality
- SCIPvarIsNonimpliedIntegral(): query whether a variable is integral but not implied integral
- SCIPgetNOrigBinImplVars(), SCIPgetNOrigIntImplVars(), SCIPgetNOrigContImplVars(): query the number of implied integral variables of each type in original problem;
  note that SCIPgetNOrigBinVars(), SCIPgetNOrigIntVars(), and SCIPgetNOrigContVars() no longer include the implied integral variables in their counts
- SCIPgetNBinImplVars(), SCIPgetNIntImplVars(), SCIPgetNContImplVars(): query the number of implied integral variables of each type in current problem;
  note that SCIPgetNBinVars(), SCIPgetNIntVars(), and SCIPgetNContVars() no longer include the implied integral variables in their counts
- SCIProwGetNumImpliedIntCols(): query number of implied integer columns in a row
- SCIPvarsCountTypes(): determine the variable type count distribution for an array of variables
- SCIPeventGetOldImplType(), SCIPeventGetNewImplType(): query implication type change for the new event \ref SCIP_EVENTTYPE_IMPLTYPECHANGED
- SCIPexprGetIntegrality(): provides information about the presence of weakly implied integral variables, in addition to the existing function SCIPexprIsIntegral()

Symmetry Handling:
- SCIPincludeConshdlrOrbitopePP(), SCIPcreateConsOrbitopePP(), SCIPcreateConsBasicOrbitopePP(), SCIPincludeConshdlrOrbitopeFull(), SCIPcreateConsOrbitopeFull(), SCIPcreateConsBasicOrbitopeFull()
- SCIPdisplaySymmetryGenerators(), SCIPdialogExecDisplaySymmetry(): display generators of symmetry group
- SCIPclearSymgraph(), SCIPcopySymgraphAsSubgraph(): clear and copy a symmetry detection graph, respectively

Conflict Analysis:
- SCIPgetNResConflictConssApplied(): return the number of generalized resolution conflict constraints added to the problem
- SCIPaddConsUpgrade(): add constraint upgrades while informing the conflict store

Branching:
- SCIPhistoryUpdateAncPseudocost(), SCIPvarUpdateAncPseudocost(): update the ancestral pseudo cost fields in variable history
- SCIPhistoryGetAncPseudocost(), SCIPhistoryGetAncPseudocostCount(), SCIPhistoryIsAncPseudocostEmpty(), SCIPgetVarAncPseudocostVal(), SCIPvarGetAncPseudocost(): retrieve values related to ancestral pseudo cost fields in variable history
- SCIPgetAvgDPseudocostScore(), SCIPgetVarDPseudocostScore(): compute discounted pseudo cost scores using ancestral pseudo costs
- SCIPboundchgGetLPSolVal(): access LP solution value in the branching data of a bound change

Cutting Planes:
- SCIPincludeSepaFlower(): include the new flower cut separator
- SCIPconsCreateRow(): to create and return the row of a linearly representable constraint
- SCIPcreateRowKnapsack(), SCIPcreateRowLinear(), SCIPcreateRowLogicor(), SCIPcreateRowSetppc(), SCIPcreateRowVarbound(): create and get the row of linearly representable constraints

Benders' Decomposition:
- SCIPincludeRelaxBenders(): include the Benders' decomposition relaxator
- SCIPgetMasterProblemRelaxBenders(): retrieve master problem SCIP instance from the Benders' decomposition relaxator
- SCIPbendersGetSubproblemMasterVars(), SCIPbendersGetNSubproblemMasterVars(), SCIPbendersGetSubproblemMasterVarsData(): get the linking master variables for each subproblem and details about the number of binary and integer variables
- SCIPsetBendersObjectiveType(), SCIPbendersGetObjectiveType(): set and get the objective type for the aggregation of the Benders' decompostion subproblems
- SCIPbenderGetMasterAuxiliaryVar(): get master auxiliary variable
- SCIPfreeReaderdataCor(), SCIPfreeReaderdataTim(), SCIPfreeReaderdataSto(): free the data for the COR, TIM, and STO readers, respectively; these readers are all used when reading an SMPS instance

IIS:
- SCIPincludeIISfinder(), SCIPincludeIISfinderBasic(), SCIPsetIISfinderCopy(), SCIPsetIISfinderFree(), SCIPgenerateIIS(), SCIPfindIISfinder(), SCIPgetIISfinders(), SCIPgetNIISfinders(), SCIPsetIISfinderPriority(), SCIPgetIIS()
- SCIPiisfinderGetName(), SCIPiisfinderGetData(), SCIPiisfinderGetDesc(), SCIPiisfinderGetPriority(), SCIPiisfinderSetData(), SCIPiisfinderGetTime(), SCIPiisfinderInfoMessage(), SCIPiisGetTime(), SCIPiisIsSubscipInfeasible(), SCIPiisIsSubscipIrreducible(), SCIPiisGetNNodes(), SCIPiisSetSubscipInfeasible(), SCIPiisSetSubscipIrreducible(), SCIPiisAddNNodes(), SCIPiisGetRandnumgen(), SCIPiisGetSubscip(), SCIPiisGreedyMakeIrreducible()

Hypergraphs:
- SCIPhypergraphCreate(), SCIPhypergraphClear(), SCIPhypergraphFree(), SCIPhypergraphAddVertex(), SCIPhypergraphAddEdge(), SCIPhypergraphIsValid(), SCIPhypergraphComputeVerticesEdges(): build and delete hypergraphs
- SCIPhypergraphComputeOverlaps(), SCIPhypergraphOverlapFind(), SCIPhypergraphIntersectEdges(), SCIPhypergraphComputeOverlapsEdges(), SCIPhypergraphComputeVerticesOverlaps(), SCIPhypergraphOverlapsDisjoint(): handle pair-wise intersections of hyperedges
- SCIPhypergraphIterInit(), SCIPhypergraphIterClear(), SCIPhypergraphIterStart(), SCIPhypergraphIterValid(), SCIPhypergraphIterNext(), SCIPhypergraphIterBase(), SCIPhypergraphIterAdjacent(), SCIPhypergraphIterMinVertex(), SCIPhypergraphIterOverlap(): iterate over adjacent edges
- SCIPhypergraphHasVertexEdges(), SCIPhypergraphHasOverlaps(), SCIPhypergraphHasOverlapsEdges(), SCIPhypergraphHasVertexOverlaps(), SCIPhypergraphGetNVertices(), SCIPhypergraphGetNEdges(), SCIPhypergraphBlkmem(), SCIPhypergraphGetNOverlaps(),
  SCIPhypergraphVertexData(), SCIPhypergraphEdgeData(), SCIPhypergraphEdgeSize(), SCIPhypergraphEdgeVertices(), SCIPhypergraphVertexEdgesFirst(), SCIPhypergraphVertexEdgesBeyond(), SCIPhypergraphVertexEdgesGetAtIndex(), SCIPhypergraphOverlapData(),
  SCIPhypergraphOverlapSize(), SCIPhypergraphOverlapVertices(), SCIPhypergraphEdgesOverlapsFirst(), SCIPhypergraphEdgesOverlapsBeyond(), SCIPhypergraphEdgesOverlapsGetAtIndex(), SCIPhypergraphOverlapsEdgesFirst(), SCIPhypergraphOverlapsEdgesBeyond(),
  SCIPhypergraphOverlapsEdgesGetAtIndex(), SCIPhypergraphVertexOverlapsFirst(), SCIPhypergraphVertexOverlapsBeyond(), SCIPhypergraphVertexOverlapsGetAtIndex(): query information about vertices, edges, and overlaps as well as their incidences

Network Matrix:
- SCIPnetmatdecCreate(), SCIPnetmatdecFree(): create and delete a network matrix decomposition
- SCIPnetmatdecTryAddCol(), SCIPnetmatdecTryAddRow(): add columns and rows to a matrix decomposition
- SCIPnetmatdecContainsRow(), SCIPnetmatdecContainsColumn(): check if a matrix decomposition contains the given row or columns
- SCIPnetmatdecRemoveComponent(): remove connected components from a matrix decomposition
- SCIPnetmatdecCreateDiGraph(): expose underlying digraph of matrix decomposition
- SCIPnetmatdecIsMinimal(), SCIPnetmatdecVerifyCycle(): check whether certain invariants of a matrix decomposition are satisfied and used in tests

Solve Statistics:
- functions to create, modify, and free SCIP_DATATREE objects and to print as JSON or table (see pub_datatree.h and scip_datatree.h)
- `SCIPcollect*Statistics()`: for every `SCIPprint*Statistics()` in scip_solvingstats.h
- SCIPprintStatisticsJson(): output a JSON string of the table statistics data

Nonlinearity:
- SCIPincludeNlpSolverConopt(), SCIPsetLicenseConopt(), SCIPgetSolverNameConopt(), SCIPgetSolverDescConopt(), SCIPisConoptAvailableConopt(): interact with the new CONOPT interface
- SCIPnlpiOracleGetConstraintLinearCoef(): get a linear coefficient of a variable in a given constraint in the NLP oracle
- SCIPnlpiOracleGetJacobianColSparsity(): get the column-wise sparsity pattern of the Jacobian from the NLP oracle
- SCIPnlpiOracleGetObjGradientNnz(): get indices of nonzeroes in the objective gradient
- `src/objscip/objexprhdlr.h`: C++ interface for expression handlers

Miscellaneous:
- SCIPsortRealPtrPtr(), ..., SCIPsortDownIntIntIntReal(): new sorting functions
- `SCIPdebugClearSol()`: clear the debug solution
- SCIPdialogIsHidden(), SCIPdialogSetHidden(): determine whether a dialog should be hidden in help list
- SCIPstatusName() to get a string representation of SCIP_STATUS
- SCIPconshdlrSetNeedsCons(): set whether constraint handler callbacks should also be called if there are no constraints
- SCIPpropSetTimingmask(): set timing mask of a propagator
- SCIPhashmapInsertLong(), SCIPhashmapGetImageLong()
- SCIPvarGetMinAggrCoef(), SCIPvarGetMaxAggrCoef(): get bounds on absolute aggregation coefficients for a loose variable
- SCIPisVarAggrCoefAcceptable(): check whether bounds on aggregation coefficients would exceed thresholds when using a loose variable in another aggregation
- SCIPgetNRootIntFixings(): retrieve the number of integer fixings at the root node
- SCIPcollectMemoryGarbage(): explicitly trigger garbage collection on block memory; before SCIP 10, this was done in SCIPtransformProb()

### Data Structures

- added struct \ref SCIP_RATIONAL for rational number arithmetic
- added struct \ref SCIP_LPEXACT and many further data structures to support exact solving mode
- added structs \ref SCIP_IISFINDER, \ref SCIP_IISFINDERDATA, \ref SCIP_IIS
- added struct \ref SCIP_DATATREE to model generic serializable data; new enum \ref SCIP_DATATREE_VALUETYPE

### Changes in Preprocessor Macros

- `SCIP_EVENTTYPE_TYPECHANGED`: no longer generated if a variable becomes implied integral
- `SCIP_EVENTTYPE_IMPLTYPECHANGED`: new event that is generated if a variable is declared implied integral, this event is included in the set \ref SCIP_EVENTTYPE_VARCHANGED
- `SCIP_EVENTTYPE_DUALBOUNDIMPROVED`: new event that is generated whenever the global dual bound is improved
- `SCIP_EVENTTYPE_GAPUPDATED`: new event mask for catching updates in primal or dual bound
- `SCIP_PROPTIMING_NONE`: new propagator timing for never calling a propagator
- `SCIP_HEURTIMING_NONE`: new heuristic timing for never call a primal heuristic
- `strcasecmp`, `strncasecmp` (Windows builds): removed `#define` from scip/def.h; use SCIPstrcasecmp() and SCIPstrncasecmp() instead
- \ref SCIP_VERSION_SUB, `SCIP_SUBVERSION`: deprecated
- `SCIP_VARTYPE_IMPLINT_CHAR`: removed
- `NO_RAND_R`: removed its use

### SCIP Shell

- `help <command>` now allows to display information on specific command
- allow to hide certain commands in the help list
- added the (hidden) command "exit" to exit the shell
- added command `iis` to create an infeasible subsystem
- added `write/iis` dialog to write out the infeasible subsystem to file
- added `display/iis` dialog to write out the infeasible subsystem to console

### Changed parameters

- `heuristics/scheduler/heurtimelimit` removed to avoid indeterministic behavior of scheduler heuristic, uses main time limit instead
- removed parameters `constraints/orbitope/checkpporbitope`, `constraints/orbitope/sepafullorbitope`, `constraints/orbitope/forceconscopy`, which became superfluous
- removed `reading/gmsreader/signpower`
- removed `benders/default/numthreads`: multi-threading support for Benders' decomposition has been temporarily disabled
- restricted range of parameter `propagating/symmetry/sstleadervartype` to [1,7]; its new default value is 6
- `propagating/*/timingmask` extended by setting 0 to disable propagators completely
- changed defaults of `constraints/components/propfreq` and `constraints/components/maxdepth` to -1 and 2147483647, respectively, to avoid unnecessary calls of components propagator by default
- changed frequencies for the following heuristics: shifting, gins, crossover, rins, randrounding
- changed default `maxlpiterquot` to 0.05 for all LP diving heuristics and feaspump, whereas adaptivediving uses 0.15 and rootsoldiving remains at 0.01
- changed default of `presolving/restartminred` to 0.05
- changed default of `presolving/immrestartfac` to 0.05
- removed parameters `propagating/symmetry/{nautymaxncells,nautymaxnnodes}`
- updated description of parameter `misc/usesymmetry`

### New parameters

- `exact/enable`: enable exact solving mode
- `exact/improvingsols`: whether only improving exact solutions should be considered
- `exact/safedbmethod`: method of safe dual bounding
- `exact/interleavedbstrat`: interleaving strategy between safe dual bounding and exact LP solving
- `exact/psdualcolselection`: project-and-shift strategy of dual column selection
- `exact/cutapproxmaxboundval`: maximal absolute bound for which coefficients in exact cuts should be approximated
- `exact/cutmaxdenom`: maximal denominator of coefficients in approximating exact cuts
- `exact/allownegslack`: whether negative slack variables in exact Gomory cuts should be used
- `exact/lpinfo`: whether the exact LP solver should display status messages
- `constraints/exact{linear,sol}/{sepafreq,propfreq,proptiming,eagerfreq,maxprerounds,delaysepa,delayprop,presoltiming}`: functionality of constraint handlers exactlinear and exactsol
- `constraints/exactlinear/sortvars`: whether binary variable coefficients should be sorted with decreasing absolute value in exactlinear constraints
- `constraints/exactlinear/{tightenboundsfreq,propcont,limitdenom,boundmaxdenom}`: propagation of exactlinear constraints
- `constraints/exactlinear/{maxrounds,maxroundsroot,maxsepacuts,maxsepacutsroot}`: separation of exactlinear constraints
- `constraints/exactsol/solbufsize`: size of solution buffer in exactsol handler
- `constraints/exactsol/{minimprove,checkfpfeasibility,checkcontimplint,abortfrac,unfixfrac}`: solution processing in exactsol handler
- `constraints/exactsol/maxstalls`: maximal number of consecutive unsuccessful reparations in exactsol handler
- `certificate/filename`, `certificate/maxfilesize`: certificate file
- `branching/pscost/discountfactor`, `branching/relpscost/discountfactor`: discount factor for ancestral pseudo costs in pscost and relpscost branching rules
- `branching/collectancpscost`: enable/disable recording of ancestral pseudo costs
- `branching/relpscost/dynamiclookahead`, `branching/relpscost/dynamiclookaheadquot`, `branching/relpscost/dynamiclookdistribution`, `branching/relpscost/minsamplesize`:
  configure the dynamic max-lookahead criterion for strong branching: enable flag, fraction threshold, distribution choice, and minimum sample size
- `constraints/cumulative/maxtime`: limit the time horizon and avoid integer overflow for unbounded variables
- `constraints/orbitope_full/forceconscopy`, `constraints/orbitope_pp/forceconscopy`: whether non-model constraints of type full orbitope and packing/partitioning orbitope are copied to sub-SCIPs, respectively
- `propagating/symmetry/handlesignedorbitopes`: whether to apply special symmetry handling techniques for orbitopes whose columns can be (partially) reflected
- `propagating/symmetry/usesimplesgncomp:` whether symmetry components all of whose variables are simultaneously reflected by a symmetry shall be handled by a special inequality
- `propagating/symmetry/dispsyminfo`: whether to print information about applied symmetry handling methods
- `propagating/symmetry/nautymaxlevel`: limit on depth level of Nauty's search tree
- `presolving/implint/convertintegers`: whether implied integrality should also be detected for enforced integral variables
- `presolving/implint/columnrowratio`: ratio of rows/columns where the row-wise network matrix detection algorithm is used instead of the column-wise network matrix detection algorithm
- `presolving/implint/numericslimit`: limit for absolute integral coefficients beyond which the corresponding rows and variables are excluded from implied integrality detection
- `write/implintlevel`: whether integrality constraints should be written for implied integral variables (regarded by cip, mps, lp, rlp, pip, fzn, and gms writers)
- `iis/*`
- `presolving/milp/enablecliquemerging`: whether to enable clique merging in PaPILO
- `presolving/milp/maxedgesparallel`: maximal number of edges in the parallel clique merging graph
- `presolving/milp/maxedgessequential`: maximal number of edges in the sequential clique merging graph
- `presolving/milp/maxcliquesize`: maximal size of cliques considered for clique merging
- `presolving/milp/maxgreedycalls`: maximal number of greedy max clique calls in a single thread
- `heuristics/dks/*`: heuristic decomposition kernel search
- `relaxing/benders/continueorig`: whether original problem should continue solving after the completion of the Benders' decomposition algorithm in the Benders' relaxator, if the problem is not solved to optimality
- `relaxing/benders/nodelimit`: node limit for the Benders' decomposition master problem in the Benders' relaxator; by default the limits from the original SCIP instance are copied
- `conflict/usegenres`, `conflict/reduction`, `conflict/mbreduction`, `conflict/maxvarsfracres`, `conflict/resfuiplevels`, `conflict/fixandcontinue`, `conflict/maxcoefquot`: control generalized resolution conflict analysis
- `lp/minsolvedepth`: lower bound on the depth at which LPs are solved
- `reading/opbreader/maxintsize`: maximal intsize above which an OPB instance is rejected
- `reading/nlreader/binary`, `reading/nlreader/comments`: adjust writing of `nl` files
- `nlpi/conopt/priority`: priority of the CONOPT NLP solver
- `randomization/randomseedshiftmultiplier`: multiplier for the shift set by `randomization/randomseedshift`;
  the shift is multiplied by (6*`randomseedshiftmultiplier`+1), with the default value for `randomseedshiftmultiplier` set to 10 now;
  this default value is expected to change with every major release; setting the parameter to 0 restores SCIP 9 behavior

### Other Changes

- removed LP solver interface `lpi_spx1`, which used the old SoPlex interface; renamed `lpi_spx2` to `lpi_spx`
- removed `cons_abspower.{h,c}`, `cons_quadratic.{h,c}`, and `cons_soc.{h,c}`

Build system
------------

- new option `SYM=dejavu` to choose Dejavu for computing symmetries
- changed the default for `TPI` to `tny`
- added build flag `CHECKSTAGE=auto` to control stage checks in API function calls
- removed `LPS` options `spx1` and `spx2`, only `LPS=spx` is available to select SoPlex now
- removed previously deprecated `PARASCIP` option, use `THREADSAFE=false` instead to disable thread-safety

### Makefile

- added build flag `EXACTSOLVE=<true|false|auto>` to turn exact solving mode on, off, or turn it on if all necessary dependencies are available
- added build flag `MPFR` (default: false) to link with the multiprecision floating-point library, needed when SoPlex is also built with `MPFR=true` for precision boosting in rational solving mode
- added build flag `CONOPT` (default: false) to link to the CONOPT NLP solver
- link-time-optimization can be enabled on Linux and macOS with gcc and clang by setting `LTO=true`, default is false
- revised `SANITIZE` options: removed `SANITIZE=full`, added `SANITIZE=thread`, `SANITIZE=address`, and `SANITIZE=memory` to enable thread, address, and memory sanitizers, respectively, in addition to undefined behavior sanitizer;
  changed default to `SANITIZE=false`
- default settings for makefile variables in `make.project` are now only used if variable hasn't been set already
- the symlink `$(LIBDIR)/include/papilo` should now point to the `src` subdirectory of a PaPILO repository or the headers directory of a PaPILO installation without TBB; pointing to the directory of a PaPILO repository still works, but is deprecated
- removed option to link TBB library, as this is not used by default when PaPILO has not been built via cmake (use `USRCXXFLAGS=-DPAPILO_TBB USRLDFLAGS=-ltbb` to enable TBB for PaPILO)
- `LPS=spx` is no longer mapped to `LPS=spx2`, which changes the name of the generated LPI libraries and binaries when using SoPlex
- removed `OPENSOURCE` flag

### Cmake

- added build flag `EXACTSOLVE=<on|off|auto>` to turn exact solving mode on, off, or turn it on if all necessary dependencies are available
- added build flag CONOPT (default: off) to link to the CONOPT NLP solver and variable `CONOPT_DIR` to specify the path to CONOPT
- link-time-optimization can be enabled if supported by compiler by using `-DLTO=on`, default is `off`
- replaced `SANITIZE_XYZ=(on|off)` options by `SANITIZE=(on|off|thread|address|memory)`;
  undefined behavior sanitizer is always enabled if not `SANITIZE=off` (the default)
- increased minimal required cmake version to 3.11
- scip-config.cmake now defines a variable `SCIP_COMPILE_FLAGS`, which could be used to compile code that builds against SCIP via cmake;
  currently, this only passes on the sanitizer flags that were used to build `libscip`
- removed automatic download and build of Bliss during cmake configuration when `-DSYM=(s)bliss`;
  a Bliss installation from https://github.com/scipopt/bliss can be specified with `-DBLISS_DIR`
- removed option `LEGACY`

Fixed bugs
----------

- fixed bug related to unreleased data for the Benders' decomposition framework; when reading an SMPS file and applying
  Benders' decomposition, data is created that was not correctly released; also, data within the Benders' decomposition
  framework was not appropriately reset; the data is now released/reset as expected
- to fix a bug where duplicate cuts from different constraint handlers were not recognized, `SCIPrealHash()` was changed
  to be stable around shortly representable numbers, and a numerical tolerance for comparing cutting plane efficacy for the aggregation
  separator is introduced
- accept fractional continuous implied integral variables in heuristic "completesol"
- invalidate activity with contradicting infinity contributions
- avoid integer overflow in cumulative constraints triggered by unbounded variables, see new parameter `constraints/cumulative/maxtime`
- allow negative update in SCIPconsAddUpgradeLocks() to unlock constraint upgrade
- fixed memory leaks when LP, MPS, and OPB/WBO readers abort unsuccessfully
- removed erroneous catching of objective-changed events in intobj separator; instead, the separator no longer executes within probing with changed objective function
- propagator dualfix no longer fixes variables to infinity to avoid issues when transferring the solution to the original problem
- track and check bounds on the coefficients that is used for a variable in aggregations of other variables to improve numerical stability
- corrected the upgrade of full orbitopes to packing/partitioning orbitopes in case the orbitopal symmetries form a proper subgroup of a component's symmetry group
- aggregate integer variable to not in clique variable in cliquePresolve() of xor constraints to avoid infeasible solutions
- fixed memory leak in dynamic partition search primal heuristic
- fixed issue with file existence check in XML parser when SCIP was build with ZLIB support on Windows
- fixed thread-safety issue when using CppAD and user-defined expression handler
- fixed typo in `#pragma` directive of redistributed nauty.h

Miscellaneous
-------------

- removed 4th number in SCIP version; the new format is major.minor.patch
- changed sassy to the version included in Dejavu
- updated ampl/mp to v4.0.3
- the CIP reader now sets an objective offset instead of adding a variable fixed to the objective offset
- the solchecker tool has been extended for rational values
- SCIPclassifyConstraintTypesLinear() classify a varbound only when a binary variable is present
- the internal limit `MAXGENNUMERATOR` has been increased to allow more generators of symmetry groups, especially for problems with many variables

@page RN9 Release notes for SCIP 9

@section RN924 SCIP 9.2.4
*************************

Fixed bugs
----------

- fixed bugs with counting changes in presolving of nonlinear and setppc constraints, which resulted in negative values
- cut off dead end node to correctly track dual bound update during solving
- no longer construct and flush the LP in SCIPwriteLP() and SCIPwriteMIP() to avoid unexpected side effects
- apply multi-aggregations before detecting redundancy in propagation of varbound constraints to keep bound implications
- skip bound changes when cutting off a branch-and-bound subtree
- correct detection of doublelex matrices and their handling via orbitope constraints
- skip attempting to free transformed problem if SCIPtransformProb() failed with an error in SCIPpresolve(), since freeing
  the transformed problem is likely to fail as well
- fixed memory leak in primal heuristic "scheduler" when there is a restart
- fixed stopping when there is a candidate with a change in the LP bound for both children in strong branching of branch_fullstrong
- fixed detection of sinks in varbound detection from cumulative constraints
- fixed memory allocation when adding strong SBCs for enclosing orbit of symmetric subgroups (disabled by default)
- free paths of branch-and-bound tree iteratively instead of recursively to avoid stack overflow
- fixed rare invalid memory access when collecting symmetry information for indicator constraints
- recompute activity bounds before checking infeasibility and redundancy in linear constraint presolving
- skip integer variables with fractional value in reference solution when finding additional variable fixings in ALNS heuristic
- fix call of SCIPaddExprsViolScoreNonlinear() with constant expressions (no variables)
- fixed bug with concurrent solve w.r.t. variable indices that led to segmentation faults and fix termination test
- adjust further bounds before checking feasibility in SCIPvarAddVlb() and SCIPvarAddVub() to detect integrality cutoff
- fixed that the last fixed binary variable was not set after binary variables were created for linking constraints
- fixed that when a linking constraint with only one binary variable was added during solving, it was not disabled
- fixed set_search_limits call when using SYM=sbliss with an old patched Bliss version

Build system
------------

### CMake

- added workaround for recent ctest versions rejecting -R -default as arguments

### Makefile

- added experimental target to run cppcheck


@section RN923 SCIP 9.2.3
*************************

Fixed bugs
----------

- avoid hashmap key error in removal of doubletons and singletons in dual presolve of setppc constraints by skipping tripleton locks
- when upgrading to xor constraint require parity variable to be enforced integral
- provide the depth of the applied effective root with SCIPtreeGetEffectiveRootDepth() to avert invalid globalization of constraint set changes
- disable objective limit during lexicographic dual minimization to preserve feasibility status
- declare infinite bound inference infeasible in SCIPinferVarLbCons() and SCIPinferVarUbCons() to maintain correct loose LP values
- fixed update of consssorted flags in a variable expressions data when adding an additional constraint using this variable
- corrected computation of number of variables affected by symmetry
- fixed computation of symmetry group size
- correct comparison conditions in checkRedundancySide() of cons_varbound.c to ensure pair redundancy
- also for the initial LP solve force acceptance of Farkas row in SCIPlpGetDualfarkas() if all other means for obtaining a reliable Farkas proof have failed
- avoid overwriting the cutoff flag in tightenCoefs(), preprocessConstraintPairs(), and applyFixings() of cons_varbound.c to reject infeasible solutions
- fix memory leak in CppAD interface w.r.t. user expressions
- adjust bound before checking feasibility in SCIPvarAddVlb() and SCIPvarAddVub() to detect integrality cutoff
- choose incumbent solution as reference in varFixingsRins() and varFixingsDins() of ALNS heuristic to ensure integrality
- consider variable type in selectInitialVariableRandomly() of GINS heuristic to count integral variables
- correct fractionality sign when standardizing bounds in simplifyInequalities() of cons_linear.c

Build system
------------

### CMake

- disable setting the boolean variable MACOSX_RPATH to a string value to actually enable @rpath usage
- define SOPLEX_NEEDED and ZIMPL_NEEDED to avoid syntax error in configuration file

Miscellaneous
-------------

- when writing a problem with non-generic names, warnings are printed if variable or constraint names are not unique

@section RN922 SCIP 9.2.2
*************************

Fixed bugs
----------

- fixed definition of slack variables of >= constraints and ranged rows in LP interface to Gurobi
- free memory leaking singleton arrays for ignored variables in SCIPapplyHeurDualval()
- use epsilon tolerance for bound implications of dual substitutions in dualPresolve() of cons_linear
- fixed timeouts due to race conditions when using TPI=omp
- fixed issues with indexing of concurrent solvers when a solver finishes (because SCIP is too fast) before others have been created when using TPI=tny
- respect fixing if variable is declared binary in bounds section of mps file
- fixed reading mps files with short row and column names and some fixed-form mps files with spaces in row names
- force local bounds to adjusted value when fixing variable
- adds missing NULL check for Benders' subproblems in feasalt cut
- apply objective scale to pseudoboolean non-linear terms
- impose pseudoboolean cost bound without intermediate casting
- flatten aggregation graph before finishing presolve to accelerate evaluating an empty solution
- respect fixed resultants in binvarGetActiveProbindex() of branch_relpscost
- drop fixed resultants when copying pseudoboolean constraint
- correct matrix entry when resolving aggregated variables in checkSystemGF2() of cons_xor
- corrected symmetry detection graph of cons_and, cons_or, cons_xor, and cons_indicator
- correct redundancy filter in consdataCreateRedundant() of cons_bounddisjunction
- replaced unreliable comparison of node pointers by node numbers in prop_genvbounds
- allocate memory for all integral variables in applyCliqueFixings() of heur_clique
- fix conflict resolution for one particular case in cons_indicator
- make interface to nauty thread safe
- use relative epsilon tolerance to check Farkas row in SCIPlpGetDualfarkas() to avoid invalid cutoff
- fixed bug with SOS2 constraints of size that avoided a correct enforcing

Build system
------------

### Cmake

- allow to set HIGHS_DIR via -D flag as well
- reenable building and testing of SCFLP example
- fixed that compiler flags for sanitizers were not used for compiling objects of SCIP library
- prioritize local includes for unittests, examples, and applications to link the intended SCIP version
- fix detection of Gurobi 11 and 12 libs on Linux

### Makefile

- fix use of SANITIZE=full for debug builds with GCC on Linux: removed -fsanitize=leak because it cannot be used together with -fsanitize=address
- fix that make install SHARED=true missed to install libscipbase

@section RN921 SCIP 9.2.1
*************************

Fixed bugs
----------

- apply same feasibility definition in PaPILO as in SCIP to avoid numerical inconsistencies
- check variable cancellation in SCIPvarAddVlb() and SCIPvarAddVub() to avert wrong infeasibility
- SCIPfreeReoptSolve() now also clears partial solutions
- fixed bug in calculation of "fractionality score" for spatial branching candidates in cons_nonlinear
- fixed bug with installing symmetry dialog in sub-SCIPs
- added copy callbacks for presolvers dualagg and redvub, branching rules lookahead and cloud, primal heuristics dualval and repair, propagator nlobbt, and separators gauge and convexproj
- respect maximal separation rounds setting by running remaining delayed separators in last round
- replace terms consistently in applyFixings() of cons_linear to handle infinite aggregations

Build system
------------

### Cmake

- fix SCIP Optimization Suite build with -DSYM=(s)bliss and bliss being downloaded and built during configuration by cmake
- fix use of a bliss cmake installation (from https://github.com/scipopt/bliss) specified via BLISS_DIR if -DSYM=(s)bliss

### Makefile

- the check/solchecker build can now use also GMP installations by Homebrew on macOS/arm64

Miscellaneous
-------------

- the output precision for writing CIP/OPB files has been increased at several places for nonlinear constraints
- the solchecker tool now also supports SCIP solutions without unknown or infinite values
- generate an error if the same linear constraint is used by several indicator constraints

@section RN920 SCIP 9.2.0
*************************

Features
--------

- added check for absolute and relative gap limits at end of synchronization in concurrent solving mode, in order to terminate earlier;
  note that if the concurrent solve is stopped due to a gap limit, the "winner" solver will have an interrupted solution status and
  its primal and dual bounds may not be the best possible ones (use SCIPgetConcurrentPrimalbound() and SCIPgetConcurrentDualbound() instead)
- parse pseudoboolean constraint from CIP format (and add linear-"and"-reformulation)


Performance improvements
------------------------

- reoptimization now also stores propagations from propagators if reoptimization/saveconsprop is enabled;
  the parameter will be renamed to reoptimization/saveprop in a next major release
- imposed stricter limits on the size of disconnected components which may be solved separately during presolve
- use individual slack variables also for constraints indicated by a common binary variable to use tighter formulation by default
- when computing symmetries using Nauty, iteration limits are now available to terminate Nauty early

Fixed bugs
----------

- Benders' decomposition subproblems that are always infeasible are correctly handled and the complete problem is declared infeasible
- skip linear constraint propagation if the residual activity bound cancels the side precision
- correct bound tracking to make the evaluation of primal-dual-integrals work
- skip aggregations on fixed variables in milp presolver to avoid errors for earlier versions of PaPILO
- use indices of negation counterparts and accept fixings when ordering and-resultants of pseudoboolean constraints
- update locks on model variables before removing pseudoboolean constraints in presolve
- reformulate soft pseudoboolean constraints with linear constraints if the indicator decomposition is disabled
- add workaround for recent HiGHS versions resetting the model status when changing the presolve option after a solve
- avoid hashmap key error in removal of doubletons and singletons in dual presolve of setppc constraints by updating constraints and corresponding hashmaps after each multi-aggregation

Interface changes
-----------------

### New API functions

- added SCIPtpiIsAvailable() to check whether a working task processing interface is available (TPI != none)
- added SCIPtpiGetLibraryName() and SCIPtpiGetLibraryDesc()
- SCIPdelCons() can now also be called in SCIP_STAGE_TRANSFORMED
- added SCIPstrcasecmp() and SCIPstrncasecmp() for case-insensitive string comparison
- added SCIPbendersSubproblemsAreInfeasible() to return if at least one subproblem has been identified as being
  infeasible prior to performing any variable fixing

### New parameters

- presolving/milp/abortfacexhaustive to control the abort threshold for exhaustive presolving in PAPILO
- presolving/milp/abortfacmedium to control the abort threshold for medium presolving in PAPILO
- presolving/milp/abortfacfast to control the abort threshold for fast presolving in PAPILO
- constraints/components/maxcompweight to determine the maximum weight for a disconnected component that is solved during presolve
- constraints/components/contfactor counts the contributing factor of a single continuous variables with respect to the weight limit specified by constraints/components/maxcompweight
- constraints/indicator/usesameslackvar to decide whether the same slack variable should be used for indicators constraints with common binary variable
- propagating/symmetry/nautymaxncells and propagating/symmetry/nautymaxnnodes to set iteration limits in Nauty (only available if build with SYM=nauty or SYM=snauty)

### Changed parameters

- presolving/milp/threads is now only available if PaPILO is built with TBB
- changed default of numerics/recomputefac to 1e+6 to aim at relative epsilon precision

Build system
------------

### Cmake

- attempted to fix detection of CPLEX library on macOS and Windows systems

Testing
-------

- added parameter FILTER for tests/Makefile to run only tests with a specific pattern (ctest with -R FILTER)

Miscellaneous
-------------

- adjusted Gurobi interface for Gurobi 12
- reordered events: BESTSOLFOUND/NODE_FEASIBLE are now processed before the nodes are cut off and before NODE_DELETE events are processed
- removed `#define` of `getcwd` (in case of Windows builds) in scip/def.h
- the `#define` of `strcasecmp` and `strncasecmp` (in case of Windows builds) in scip/def.h will be removed with SCIP 10;
  use `SCIPstr(n)casecmp()` (scip/pub_misc.h) instead

@section RN911 SCIP 9.1.1
*************************

Fixed bugs
----------

- fix bug in separator aggregation that caused incorrect terminations when for an integral objective the objective limit was set to a fractional value
- fix bug in memory management of doublelex matrices where indices were set beyond array bounds
- store relevance flags in consdataTightenCoefs() of cons_linear.c to avoid dropping variables unintentionally due to numerical changes
- fix possible segmentation fault when resetting local and global bounds of original variables after abnormal termination
- compare coefficient scales to detect parallelism to avoid integral relaxations in detectRedundantConstraints() of cons_linear.c
- remove coefficient information from linear constraint hashes in order to compare keys with tolerances
- fixed NULL pointer dereference in SCIPtpiGetNumThreads() of TinyCThread interface if called before SCIPtpiInit(); now returns 0 in this case
- calling SCIPsolveConcurrent() when SCIP was compiled without a TPI now results in a plugin-not-found error
- fixed LPI status functions of lpi_cpx if the barrier is called
- check cuts for redundancy after scaling in cutTightenCoefs() and cutTightenCoefsQuad() of cuts.c
- maintain definition of artificial integral variables in xor constraints to avoid invalidation of conflict constraints
- free childless nodes only after the deactivation of the old focus path in treeSwitchPath() of tree.c
- only normalize rows for column norm evaluations in shift-and-propagate heuristic to avoid unscaled violations
- expression handler for absolute value computes now also a cut when one of the bounds is infinite as long as the sign of the argument is known
- check for more data to be freed before modifying nonlinear constraints in SCIPaddExprNonlinear()
- allow for terms with zero coefficients when checking sum in SCIPexprCheckQuadratic()
- do not abort writing of constraints to lp/pip files (and forget to free buffer memory) when encountering unsupported nonlinear constraint
- fixed that strings with names and descriptions of the LPI's were not null-terminated
- fixed decision on when to enforce nonlinear constraints on relaxation solutions if integer variables are present
- fixed reading of very long lines (>78000 characters) in FlatZinc reader
- fixed write of strings with at least 1024 characters when compiling with MSVS 2015 (14.0) or later (still an issue with earlier MSVS, which will not be fixed)
- keep epsilon coefficients in applyFixings() of cons_linear.c until multiples are merged to avoid loss of relevant contributions
- fixed that some variable type changes were not accounted correctly in presolve of linear constraints
- fix constraint sorting in setpp-orbitope upgrade in symmetry code
- fixed that SCIPnodeGetConsProps() also counted bound changes from propagators
- use original and-constraints of an untransformed pseudoboolean constraint when copying original problems to avert segmentation faults
- sort and-constraints of a pseudoboolean constraint with respect to the resultant problem indices to avoid shuffled copies
- treat pseudoboolean constraints as nonlinear constraints in OPB reader to prevent duplication mistakes

Examples and applications
-------------------------

- in example Binpacking implement Farkas pricing for packings because branching can actually lead to infeasible restricted master LPs

Testing
-------

- allow unknown parameters to let tests pass if only optional dependencies are missing

Build system
------------

### Cmake

- fixed compilation and linking with HiGHS; to use HiGHS, cmake now requires to specify the directory containing the `highs-config.cmake` file via `-DHIGHS_DIR`
- extended identification of Ipopt library on Windows to also look for ipopt.dll.lib, as this is used since Ipopt 3.13.0 (2019)


@section RN910 SCIP 9.1.0
*************************

Features
--------

- added constraint handler that checks and enforces bounds on original variables which have been fixed or aggregated in the transformed problem
- allow for implicit integer variables in xor constraints
- implemented symmetry detection callbacks for pseudoboolean constraints
- added option to consider enforcement of nonlinear constraints (including spatial branching) before integrality has been enforced

Fixed bugs
----------

- make sure that, in dual proof analysis, upgraded constraints can report their number of variables
- check knapsack constraints as linear constraints to avoid violations based on implicit integrality
- make sure that symmetry detection callbacks report success
- make arithmetics in cuts.c more robust to avoid invalid scg cuts due to numerical rounding sensitivity
- allow to copy pseudoboolean constraints even if no AND constraints are present in order to avoid a warning
- set value for variable that is introduced to reformulate nonlinear objective function when reading .nl files with initial solution
- fixed that multi-aggregations from PaPILO were accepted without ensuring that their bounds hold

Examples and applications
-------------------------

- TSP: removed `gzstream.h/hpp` and parse gzipped files differently

Interface changes
-----------------

### New callbacks

- SCIP_DECL_NLHDLRENFO takes additional parameter branchcandonly to indicate whether only branching candidates should be registered,
  without looking for cuts or boundchanges

### New API functions

- new function SCIPgetExprActivityNonlinear() to get activity of nonlinear constraint
- new function SCIPincludeConshdlrFixedvar() to include new constraint handler that checks bounds on fixed original variables

### New parameters

- limits/primal to terminate the solve as soon as the primal bound is at least as good as this value, same as limits/objectivestop (deprecated)
- limits/dual to terminate the solve as soon as the dual bound is at least as good as this value
- presolving/milp/internalmaxrounds to control the maximal rounds for each call of the milp presolver (PaPILO)
- constraints/fixedvar/* to control the new constraint handler that checks bounds on fixed original variables
- constraints/nonlinear/branching/mixfractional to specify minimal average pseudo cost count for discrete variables
  at which to start considering spatial branching before branching on fractional integer variables
  (default infinity means that integrality is always enforced before nonlinear constraints)
- constraints/nonlinear/branching/fracweight to specify weight of fractionality of integer variables in spatial branching

### New data structures

- enum SCIP_Status has been extended by SCIP_STATUS_PRIMALLIMIT and SCIP_STATUS_DUALLIMIT to indicate termination at limits/primal and limits/dual respectively

Build system
------------
- changed the default symmetry computation package from sassy+bliss to sassy+nauty
- bliss source is no longer included in the source tree, but can be linked as external library (https://github.com/ds4dm/Bliss)
- cmake now automatically downloads and installs the latest release version of SoPlex from GitHub if it is not found directly

Miscellaneous
-------------

- updated nauty to version 2.8.8


@section RN901 SCIP 9.0.1
*************************

Fixed bugs
----------

- fixed bug in detection of double lex matrices due to wrong memory allocation
- fixed bug where parameter `limits/objectivestop` was copied to subscips in plugins which have different objectives
- in count mode respect empty solution when problem is solved in presolving
- fixed that SCIP may have tried to pass a negative random seed to an LP solver
- fixed bug where conflict analysis in strong branching tried to analyze an unsuccessful LP solve
- enable parameter limits/restarts by allowing to reach the restart limit in restartAllowed()
- handle normalizing linear constraints in presolving with more caution to avoid numerical difficulties for integer variables with large coefficients
- use quad precision to calculate residual activity bounds to reduce numerical errors for large variable bounds in cons_linear.c
- in SCIPsolveProbingLP() when objective has been changed do not return cutoff due to exceeding the cutoff bound
- set probing LP to be a relaxation only when objective has not been changed
- declare contradicting infinities in getMinActivity() and getMaxActivity() as non-tight
- reject farkas solution with large values to bound magnification of errors in SCIPgetFarkasProof()
- if all variables are fixed, apply relative feasibility tolerance to avoid invalid infeasibility in applyFixings() of cons_linear.c
- delete empty redundant knapsack and linear constraints after cleanup in SCIPmatrixCreate()
- cleanup first constraints in SCIPcleanupConssVarbound(), SCIPcleanupConssSetppc(), and SCIPcleanupConssLogicor()
- symmetry handling methods have not been added immediately after computing symmetries, which has been fixed
- delay checking node limits after presolving to correctly continue up to the exceeding main node
- simplified the objective sense assumption for the subproblems in the Lagromory separator
- update effective root depth iteratively to avoid trapping it at a single child node
- fixed that dualsparsify presolver did not always check do-not-multiaggregate variable flag
- fixed bug in computing elements of orbits in orbital reduction

Miscellaneous
-------------

- redefine isrelax to istight in cons_linear.c

Build system
------------

### Cmake

- A file cmake.log containing the changed options is written to the cmake build directory.
- removed replacement of the settings of RelWithDebInfo
- add compile option -ffp-contract=off or /fp:precise to enhance reproducibility across different systems

### Makefile

- add flags -ffp-contract=off and /fp:precise to enhance reproducibility across different systems

Interface changes
-----------------

### New parameters

- added parameter "propagating/symmetry/symtiming" to determine when symmetries are computed and handled

### Changed parameters

- Disabled "propagating/symmetry/addconsstiming" since it is not used anymore.
- Disabled "propagating/symmetry/ofsymcomptiming" since it is not used anymore.

@section RN900 SCIP 9.0.0
*************************

Features
--------

- added simplification of abs(x)^n to x^n when n is even (simplify rule POW12)
- in expression simplification, added possibility to expand power of sum with exponents larger than 2 (simplify rule POW7)
- in expression simplification, added possibility to expand products with sums as factor when there are more than two factors (simplify rule SP12b)
- in expression simplification, added possibility to allow expanding power of products with fractional exponent (simplify rule POW5a)
- can now build with Lapack (used for solving nonlinear problems) explicitly; if IPOPT is used, then Lapack is accessed through it;
  an interface to Lapack is available in lapack_calls.h
- added support for logical constraints in binary variables and basic logical operators (and, or, not, equal) to AMPL .nl reader
- indicator constraints now use the same slack variable for the linear constraints if binary variables are used multiple times
  for indicator constraints
- new diving heuristic indicatordiving that focuses on indicator variables which control semicontinuous variables
- updated statistics on NLP relaxation; information on convexity of NLP has been added
- added new bandit method (EXP.3-IX) that is the new default of the ALNS heuristic
- added dialog to display recognized permutation symmetries ("display symmetry")
- The symmetry detection code has been completely restructured. Instead of completely encoding symmetry information in
  prop_symmetry.c, there is a new callback for constraint handlers, which returns symmetry relevant information by
  encoding a constraint as a node and edge colored graph. This way, also custom constraint handlers can provide
  symmetry information.
- added special presolving step for logicor and set covering/packing for constraints with two variables and one independent variable
- increased the depth field of the tree structure from 16 to 30 bits and the max depth of the search tree from 65534 to 1073741822
- added new cut selector plugin called cutsel_ensemble. Performs a superset of hybrid cutsel. Implements new filtering methods and scoring options.
- added new branching rule based on Gomory mixed-integer cuts
- added new branching score to the reliability pseudo-cost branching rule
- added new cut selector plugin called cutsel_dynamic. Performs a superset of hybrid cutsel. Implements new filtering methods and scoring options.
- added monoidal strengthening to intersection cut generation of nlhdlr_quadratic
- extended heuristic dps to run after processing the node and to use strict limits for the reoptimization step
- extended obbt propagator to handle variables of the linear constraints corresponding to indicator constraints
- added new heuristic heur_scheduler that models the selection of LNS and diving heuristics as a multi-armed bandit problem
- added nonlinear handler for signomial expressions: adds cuts based on a difference of convex functions representation
- Delayed separators are now called if no other cuts have been found. Previously, such separators were only called near stalling or when the separation rounds limit was reached.
- added a new separator sepa_lagromory to generate Lagromory cuts in a relax-and-cut framework, i.e., GMI cuts generated
  at different bases that are explored in the process of solving the Lagrangian dual problem at a node. This separator
  is OFF by default.
- when parsing nonlinear constraints from CIP files, the * after the number in a term is now optional if followed by a variable,
  i.e., instead of 3*<x>*<y>, now also 3<x>*<y> can be read, but 3<x><y> is not supported;
  this allows to read some CIP files that were written with SCIP < 8
- when running bliss, we now limit the number of actually created generators and not the ones considered by bliss

Performance improvements
------------------------

- Variable conflict-based addition of Schreier-Sims cuts for symmetry handling in prop_symmetry.c does no longer use
  an expensive explicit conflict graph construction.
- Only run propagation of indicator constraints if relevant variables have changed.
- Propagation of indicator constraints propagates maximal activity of linear constraint to upper bound of slack variable.
- Added initialization of LP relaxation for SOC constraints.
- Avoided some numerical issues when separating SOC constraints.
- If differentation of convex expression fails in convex nlhdlr, then a perturbed point is tried.
- Use sassy/bliss as default symmetry computation package.
- No longer linearize indicator constraints in undercover heuristic by default.
- Deactivate pre-root heuristic zeroobj in undercover heuristic.
- Added new branching score tiebreaker for reliability pseudo-cost branching rule
- Try nearest bound if zero solution value is out of bounds in heuristic trivial.

Interface changes
-----------------

### New and changed callbacks

- Added solution linearization callback for nonlinear handlers.
  The nonlinear handler may use this callback to add tight cuts that use the given solution as reference point to the cutpool.
  The callback is called if option constraints/nonlinear/linearizeheursol is enabled.
- The callback for copying problem data SCIP_DECL_PROBCOPY() now has a parameter "original" indicating whether the original
  or transformed problem should be copied. Similarly, SCIPprobCopy() in prob.h/c has such a parameter.
- Added CONSGETPERMSYMGRAPH and CONSGETSIGNEDPERMSYMGRAPH callback for constraint handlers, which provides symmetry information about constraints to SCIP.

### Deleted and changed API functions

- SCIPtpiInitLock(), SCIPtpiDestroyLock(), SCIPtpiInitCondition(), SCIPtpiDestroyCondition() now take a double
  pointer to SCIP_LOCK/SCIP_CONDITION, respectively.
- Renamed SCIPtpiSumbitJob() to SCIPtpiSubmitJob().
- SCIPcreateConsIndicatorLinCons(), SCIPcreateConsIndicatorGenericLinCons() do not allow binvar to be NULL anymore
- Replaced SCIPnlrowSetCurvature() by SCIPsetNlRowCurvature().
- SCIPsnprintf() now returns the required string length in case reallocation is necessary.
- SCIPcomputeCoverUndercover() receives three more arguments which nonlinearities to cover
- removed definition of SQRT
- SCIPincludeObjConshdlr(), SCIPincludeConshdlr(), SCIPconshdlrCreate() receive two more arguments for the
  conshdlr callbacks CONSGETPERMSYMGRAPH and CONSGETSIGNEDPERMSYMGRAPH
- removed SYM_VARTYPE, SYM_OPTYPE, SYM_CONSTTYPE, SYM_RHSTYPE, SYM_MATRIXDATA
- new parameter issigned for SCIPcomputeOrbitsSym()
- new parameter symtype for SCIPcomputeComponentsSym()
- new parameter symtype and permvardomaincenter for SCIPlexicographicReductionAddPermutation()
- replaced parameters matrixdata and exprdata of SYMcomputeSymmetryGenerators() by graph

### New API functions

- new functions for interfacing with Lapack: SCIPlapackIsAvailable(), SCIPlapackIsAvailable(), SCIPlapackComputeEigenvalues(), and SCIPlapackSolveLinearEquations
  These functions should be used instead of SCIPisIpoptAvailableIpopt(), SCIPcallLapackDsyevIpopt(), and
  SCIPsolveLinearEquationsIpopt() in the context of computing eigenvalues or solving linear equations.
  If IPOPT is available, the calls will be passed on to Ipopt's interface to Lapack.
- SCIPmultiplyBySumExprSum(), SCIPpowerExprSum()
- SCIPsetParam()
- SCIPgetPrimalDualIntegral() returns the primal dual integral stored in the statistics
- new functions SCIPcreateConsIndicatorLinConsPure() and SCIPcreateConsIndicatorGenericLinConsPure() that
  create indicator constraints from a linear constraint without a slack variable
- SCIPgetNLPNlRowsStat() to retrieve counts on linear, convex, and nonconvex rows in NLP
- SCIPnlhdlrSetSollinearize(), SCIPnlhdlrHasSollinearize()
- SCIPbendersGetNLPParam()
- new API functions SCIPlexicographicReductionGetStatistics(), SCIPlexicographicReductionPrintStatistics(),
  SCIPlexicographicReductionPropagate(), SCIPlexicographicReductionAddPermutation(), SCIPlexicographicReductionReset(),
  SCIPlexicographicReductionFree(), SCIPincludeLexicographicReduction(), for lexicographic reduction.
- new API functions SCIPorbitopalReductionGetStatistics(), SCIPorbitopalReductionPrintStatistics(),
  SCIPorbitopalReductionPropagate(), SCIPorbitopalReductionAddOrbitope(), SCIPorbitopalReductionReset(),
  SCIPorbitopalReductionFree(), SCIPincludeOrbitopalReduction(), SCIPorbitopalReductionGetDefaultColumnOrdering(),
  for orbitopal fixing.
- new API functions SCIPorbitalReductionGetStatistics(), SCIPorbitalReductionPrintStatistics(),
  SCIPorbitalReductionPropagate(), SCIPorbitalReductionAddComponent(), SCIPorbitalReductionReset(),
  SCIPorbitalReductionFree(), SCIPincludeOrbitalReduction(), for orbital fixing.
- new API functions SCIPgetShadowTreeEventHandlerExecutionTime(), SCIPshadowTreeGetShadowNodeFromNodeNumber(),
  SCIPshadowTreeGetShadowNode(), SCIPgetShadowTree(), SCIPactivateShadowTree(), SCIPincludeEventHdlrShadowTree(),
  for managing a copy of the branch-and-bound tree for symmetry handling purposes.
- SCIPdotWriteOpening(), SCIPdotWriteNode(), SCIPdotWriteArc(), SCIPdotWriteClosing()
- SCIPincludeCutselEnsemble(), SCIPselectCutsEnsemble() to include cutsel_ensemble or use the selection algorithm
- SCIPincludeBranchruleGomory() includes new gomory cut based branching rule
- SCIPgetVarAvgGMIScore(), SCIPincVarGMISumScore(), SCIPgetVarLastGMIScore(), SCIPsetVarLastGMIScore() set historical values used by SCIP's default branching rule
- SCIPincludeNlhdlrSignomial() includes the signomial nonlinear handler
- SCIPgetExprMonomialData() returns a monomial representation of a product expression
- SCIPestimateRoot() computes estimators for roots with exponent in [0,1]
- SCIPincludeCutselDynamic(), SCIPselectCutsDynamic() to include cutsel_dynamic or use the selection algorithm
- SCIPincludeSepaLagromory() to include the new Lagromory separator
- SCIPconsCompCheck() to compare two constraints based on their check priority
- SCIPgetConsPermsymGraph() and SCIPgetConsSignedPermsymGraph() to access the (signed) permutation symmetry detection graph of a constraint
- SCIPsetConshdlrGetPermsymGraph() and SCIPsetConshdlrGetSignedPermsymGraph() to set the (signed) permutation symmetry detection graph of a constraint
- SCIPconshdlrSupportsPermsymDetection() and SCIPconshdlrSupportsSignedPermsymDetection() to access whether a conshdlr supports detection of (signed) permutation symmetries
- new API functions for creating and manipulating a symmetry detection graph: SCIPcreateSymgraph(), SCIPfreeSymgraph(), SCIPcopySymgraph(), SCIPextendPermsymDetectionGraphLinear(),
  SCIPaddSymgraphVarAggregation(), SCIPaddSymgraphOpnode(), SCIPaddSymgraphValnode(), SCIPaddSymgraphConsnode(), SCIPgetSymgraphVarnodeidx(), SCIPgetSymgraphNegatedVarnodeidx(),
  SCIPupdateSymgraphLhs(), SCIPupdateSymgraphRhs(), SCIPfixSymgraphVarnode(), SCIPaddSymgraphEdge(), SCIPcomputeSymgraphColors(), SCIPgetSymgraphSymtype(), SCIPgetSymgraphVars(),
  SCIPgetSymgraphNVars(), SCIPgetSymgraphNConsnodes(), SCIPgetSymgraphNNodes(), SCIPgetSymgraphNEdges(), SCIPgetSymgraphEdgeFirst(), SCIPgetSymgraphEdgeSecond(),
  SCIPgetSymgraphVarnodeColor(), SCIPgetSymgraphNodeType(), SCIPgetSymgraphNodeColor(), SCIPisSymgraphEdgeColored(), SCIPgetSymgraphEdgeColor(), SCIPgetSymgraphNVarcolors(),
  SCIPhasGraphUniqueEdgetype(), SCIPcreateSymgraphConsnodeperm(), SCIPgetSymgraphConsnodeperm(), SCIPfreeSymgraphConsnodeperm(),
  SCIPgetSymActiveVariables(), SCIPfreeSymDataExpr(), SCIPgetSymExprdataNConstants(), SCIPgetSymExprdataConstants(), SCIPgetCoefSymData(),
  SCIPcreateSymOpNodeType(), SCIPgetSymOpNodeType()
- SCIPexprhdlrSetGetSymdata(), SCIPexprhdlrHasGetSymData(), SCIPgetSymDataExpr(), SCIPcallExprGetSymData() to access symmetry data of expressions
- SYMcheckGraphsAreIdentical() to check whether two symmetry detection graphs are identical
- new functions SYMbuildSassyGraph(), SYMbuildSassyGraphCheck()
- new type SYM_GRAPH
- new definitions SCIP_DECL_CONSGETPERMSYMGRAPH, SCIP_DECL_EXPRGETSYMDATA
- new member SYM_NODETYPE_CONS in SYM_NODETYPE enum
- new members SYM_CONSOPTYPE_SUM, SYM_CONSOPTYPE_SLACK, SYM_CONSOPTYPE_COEF, SYM_CONSOPTYPE_RHS, SYM_CONSOPTYPE_LAST in SYM_CONSOPTYPE enum
- new defintion SCIP_DECL_EXPRGETSYMDATA
- new function SCIPdetectSingleOrDoubleLexMatrices()

### Command line interface

- Added optional parameter -i when calling SCIP in AMPL-mode (-AMPL parameter).
  If -i is specified, a SCIP shell is started where normally SCIPsolve() would be called.

### Interfaces to external software

- added interface to nauty/traces for symmetry computation
- added interface to sassy, a preprocessor for symmetry computation
- The directory src/sassy contains the source code of sassy.
- Added interface to Lapack (used for solving nonlinear problems).
- The AMPL interface now supports parameters specified in AMPL command scripts via option scip_options.
  The value of scip_options is expected to be a sequence of parameter names and values, separated by a space, e.g.,
    `option scip_options 'limits/time 10 display/verblevel 1';`.
  String values should not be quoted and spaces in string values are not supported.
- sassy can be used now as preprocessor for nauty/traces
- The solution status codes written to AMPL solution files now match those from https://mp.ampl.com/details.html#_CPPv4N2mp3sol6StatusE.

### Changed parameters

- change default value of parameter separating/filtercutpoolrel to FALSE
- Shrunk range of parameter "propagating/symmetry/sstleaderrule" from [0,3] to [0,2], removed "MAXCONFLICTS"-option.
- Removed reading/gmsreader/freeints. A default upper bound of +inf is now assumed for integer variables in GAMS (which is the case since GAMS 23.1).
- Disabled "propagating/symmetry/symfixnonbinaryvars" since it is not used in the new symmetry code.
- Replaced "propagating/symmetry/onlybinarysymmetry" with "propagating/symmetry/enforcecomputesymmetry" and set to FALSE by default.
- Disabled "propagating/symmetry/performpresolving" since running orbital reduction during presolving is not effective.
- Repurposed "propagating/symmetry/usedynamicprop" since it now also applies to lexicographic reduction.
- Changed default value of parameter "propagating/symmetry/addsymresacks" from FALSE to TRUE.

### New parameters

- separating/maxcutsgenfactor and separating/maxcutsrootgenfactor as factors (w.r.t. separating/maxcuts and
  separating/maxcutsroot) for limits on the number of cuts generated (which used to be constants '2')
- expr/pow/expandmaxexponent to specify limit on exponent when to expand power of sum
- expr/pow/distribfracexponent to enable expanding power of products with fractional exponents
- expr/product/expandalways to enable expanding any product with sums as factor (that is, also when more than two factors)
- nlhdlr/convex/maxperturb to specify maximal perturbation of non-differential reference points
- benders/default/nlpiterlimit to adjust iteration limit for NLP solver for Benders' decomposition NLP subproblems
- limits/objectivestop to interrupt the solve as soon as a primal solution is found
  that is at least as good as the given value
- heuristics/undercover/{coverand,coverind,covernl} to control which nonlinearities to consider (by default only "and" and nonlinear constraints)
- cutselection/ensemble/* all parameters for new ensemble cut selector
- cutselection/dynamic/* all parameters for new dynamic cut selector
- branching/relpscost/gmiavgeffweight specifies the weight in the relpscost branching score of the normalized  efficacy of all generated GMI cuts (for a variable)
  branching/relpscost/gmilasteffweight specifies the weight in the elpscost branching score of the normalized efficacy of the last generated GMI cut (for a variable)
- nlhdlr/quadratic/usemonoidal to enable monoidal strengthening when separating quadratics with intersection cuts
- nlhdlr/quadratic/trackmore to collect more statistics for monoidal strengthening when separating quadratics with intersection cuts
- nlhdlr/quadratic/useminrep to use the minimal representation to compute cut coefficients when separating quadratics with intersection cuts
- nlhdlr/quadratic/sparsifycuts to enable sparsification of intersection cuts for quadratics
- heuristics/dps/reoptlimits to set strict limits for the reoptimization step in dps
- heuristics/dps/timing to run dps after processing the node
- heuristics/scheduler/* all parameters for new scheduler heuristic
- nlhdlr/signomial/enabled, nlhdlr/signomial/maxnundervars, nlhdlr/signomial/mincutscale: parameters for the signomial nonlinear handler
- separating/lagromory/freq to denote the frequency for calling Lagromory separator
- separating/lagromory/away to denote the minimal integrality violation of a basis variable to try separation
- separating/lagromory/dynamiccuts to denote whether the generated cuts be removed from LP if they are no longer tight
- separating/lagromory/maxroundsroot to denote the maximal number of separation rounds in the root node
- separating/lagromory/maxrounds to denote the maximal number of separation rounds in a non-root node
- separating/lagromory/nmaxcutsperlproot to denote, in the root node, the maximal number of Lagromory cuts that can be
  separated per explored basis of the Lagrangian dual
- separating/lagromory/nmaxcutsperlp to denote, in a non-root node, the maximal number of Lagromory cuts that can be
  separated per explored basis of the Lagrangian dual
- separating/lagromory/perroundnmaxlpiters to denote the maximal number of separating LP iterations that are allowed per
  separation round
- separating/lagromory/dualdegeneracyratethreshold to denote the minimum dual degeneracy rate for the separator execution
- separating/lagromory/varconsratiothreshold to denote the minimum variable-constraint ratio on the optimal face for the
  separator execution
- many other advanced parameters for the Lagromory separator, which are also mentioned under separating/lagromory/*

### Data structures

- new data structure SYM_GRAPH to encode symmetry information from a constraint
- new data structure SYM_EXPRDATA to encode symmetry information from expressions
- replaced enum SYM_SYMTYPE by a complete new one; removed SYM_RHSSENSE, added SYM_NODETYPE and SYM_CONSOPTYPE

Deleted files
-------------

- deleted the now unused files: tpi_none.h, tpi_openmp.h, tpi_tnycthrd.h, type_tpi_none.h, type_tpi_openmp.h, type_tpi_tnycthrd.h

Unit tests
----------

- new unittests for nlhdlr_quadratic that test monoidal strengthening and the use of the minimal representation to compute cut coefficients
- unittests for nlhdlr_signomial

Testing
-------

- changed `set lim obj` to `set lim objective` in ctest since `obj` is no longer unambiguous

Build system
------------

### Cmake

- New flag -DLAPACK=on for linking with Lapack (must be available in the system)
- added flag option "SYM=sbliss" for using sassy/bliss as a graph automorphism package
- use SYM=sbliss by default, since sassy and bliss are now shipped with SCIP.
- added flag option "SYM=snauty" for using sassy/nauty as a graph automorphism package

### Makefile

- added flag option "nauty" for SYM variable to specify which graph automorphism package should be used
- added flag option "sbliss" (sassy/bliss) for SYM variable to specify which graph automorphism package should be used
- added flag option "snauty" (sassy/nauty) for SYM variable to specify which graph automorphism package should be used
- use SYM=sbliss by default, since sassy and bliss are now shipped with SCIP
- New flag LAPACK for linking with Lapack (must be available in the system)
- A file scip/config.h is created in the build directory ($(OBJDIR)/include) now.
  Defining NO_CONFIG_HEADER is no longer necessary and has no effect anymore.

Fixed bugs
----------

- Number of runs in which separation is enabled will now be correct as per "separating/maxruns" parameter. Earlier,
  separation was enabled for "maxruns + 1" number of runs, i.e., separation was enabled even when "maxruns = 0" was set.
- add safeguard for number of selected cuts
- use double double precision for delta in activity updates of cons_linear.c
- sort constraints in checkSolOrig() to keep the logic of constraint handlers intact
- fixed make install when SHARED=no and make uninstall
- check absolute coefficients relative to extremal average to avoid invalid unifications in normalizeCons()
- enforce and check symmetry-based constraints to take their locks (in dual reductions) into account
- flush changes at the end of SCIPlpiSetBase() in lpi_grb.c to apply the newly set basis correctly

Miscellaneous
-------------

- The TPI has been changed to become mostly independent from the actual parallel interface during compile time.
  For this, the locks and conditions are now pointers to abstract structs.
- fixed that scip/def.h, the header for C preprocessor definition (`#define`'s), included headers for some SCIP type and function definitions
  (scip/type_retcode.h, scip/type_message.h, scip/pub_message.h)


@page RN8 Release notes for SCIP 8

@section RN810 SCIP 8.1.0
*************************

Fixed bugs
----------

- fixed that scaling of rows in Gurobi interface (SCIPlpiScaleRow()) changed infinite sides to large finite ones (1e20) when scale factor is negative
- check whether objective limit is truly reached in SCIPlpiIsStable()
- if an objective limit is set and Mosek claims that it is exceeded, check that this is indeed the case in SCIPlpiIsStable()
- the .mps file reader was extended to additionally accept .mps files with the objective sense section on one line
- ensure that delayed cutpool separation does not happen if enough cuts have been found already
- fixed that a Gurobi or Mosek interface (LPI) could not be freed from a thread different than the one it was created in, which lead to problems when, e.g., using the concurrent optimizer
- in cons_varbound if both variables are fixed, instead of propagating the constraint check the feasibility of the constraint since propagating can lead to unnecessary numerical troubles
- fixed memory leak in branching rule "distribution"
- fixed that undercover did not enforce that sufficiently many variables in an and-constraints were fixed to have it linearized in the generated sub-scip
- fixed two bugs in cons_varbound: avoid adding variable bounds if vbdcoef is infinite and unlock/lock variables if lhs/rhs/vbdcoef are changed
- globalize constraint changes before bound changes during the effective root shift in treeSwitchPath() to correctly update variable locks by avoiding global bounds with outstanding bound change events when deleting constraints
- fixed error when attempting to copy SCIP with activated pricers
- remove integrality check for implicit integral variables in cons_integral.c, updated the definition for variable type implicit integer to be more explicit that these variables can take fractional values, and updated FAQ entry
- updated and, or, and pseudoboolean constraint handlers to better handle fractional implicit integer variables in enforcement
- avoid invalid strong Chvatal-Gomory cuts by ceiling with tolerance in the calculation of parameter k and flooring slack coefficients with standard epsilon tolerance as well as quad precision
- add missing row links to columns in SCIPflushRowExtensions() required to maintain correct row norms
- restrict separator intobj to solutions for which there can be no better feasible integral objective values to avoid cutting them off
- delay removal of clique lists from SCIPvarRemoveCliquesImplicsVbs() into cliqueCleanup() to avoid segmentation faults by incomplete cleanups after variable conversions
- reject sub-solutions with invalid objectives in SCIPtranslateSubSols() due to contradicting infinite contributions
- correct column index in getMinMaxActivityResiduals() to make presolver dualinfer work
- copy quiet flag from main scip's message handler to the one of solverscip in concurrent optimization
- avoid bound tightening cycles towards huge redundancy bounds in fullDualPresolve() to avert fatal numerical trouble in representing vertices of linear relaxations with unbounded domains
- fix problem where debug solution did not work if branching constraints are present
- update index of dominating variable on coefficient deletion in dualPresolving() of constraint handler logicor
- pass on flags from a redundant to the implying varbound constraint in preprocessConstraintPairs() to avoid suboptimal fixings by model relaxations
- apply reductions of dualinfer only if a dual solution exists (primal is bounded)
- before presolving is finished check solutions before retransforming them including tiny values to keep check flags consistent
- disable heuristics before and during presolving in benders decomposition to avoid messing up the objective structure in the solution store by dropping auxiliary variables in the required retransformations
- correct local flag of singleton conflict constraints in tightenSingleVar() against invalid bound globalization
- respect unboundedness in the computation of activity bounds in conflict.c to avoid invalid huge bounds due to small coefficients on unbounded variables
- ensure positive sides of a linear constraint when recognizing a set partition in rangedRowSimplify() to account for redundancy issues
- relax numerical conditions for variable aggregations to avert invalid variable fixings
- fixed harmless read of uninitialized data when creating parameters
- fix call of SCIPnlpiOraclePrintProblem in nlpi_worhp

Performance improvements
------------------------

- Use sassy/bliss as default symmetry computation package.

Interface changes
-----------------

### Interfaces to external software

- added interface to nauty/traces for symmetry computation
- added interface to sassy, a preprocessor for symmetry computation
- The directory src/sassy contains the source code of sassy.

Build system
------------

### Cmake

- added flag option "SYM=sbliss" for using sassy/bliss as a graph automorphism package

### Makefile

- added flag option "nauty" for SYM variable to specify which graph automorphism package should be used
- added flag option "sbliss" for SYM variable to specify which graph automorphism package should be used
- use SYM=sbliss by default, since sassy and bliss are now shipped with SCIP

Miscellaneous
-------------

- the parameter change callback is no longer called at the moment a parameter is created

@section RN804 SCIP 8.0.4
*************************

Features
--------

- use quad precision in cutsSubstituteMIR() for substituting slack variables into CMIR cuts
- use quad precision for activity computations in cons_linear.c

### Deleted and changed API functions

- SCIPshrinkDisjunctiveVarSet() no longer attempts to cutoff the current node if it finds the
  given disjunction to be infeasible; it is now in the responsibility of the caller to act accordingly

### New API functions

- added SCIPskipSpace
- added XML parser routines from src/xml/xml.h

### Interfaces to external software

- updated XPRESS interface to work with XPRESS 41 as well
- new interface to LP solver HiGHS (lpi_highs.cpp)

### Changed parameters

- changed integer parameter "propagating/symmetry/recomputrestart" from range {0, 1, 2} to being fixed at value 0

Unit tests
----------

- added new checks for objective, bounds and sides inside the scaling tests in lpi/change.c

Fixed bugs
----------

- relax condition of assert in lpSolve to hold only if lp/checkstability is true
- OPB reader: dynamically increase the size of the line buffer for reading in getMaxAndConsDim()
- Enabled the solution limit checks in SCIPsolveIsStopped in solve.c when in SCIP_STAGE_PRESOLVING
- fix quad precision comparison for the calculation of knapsackcover constraints.
- force copying of symmetry constraints for concurrent solve
- increase the precision of double multiplications in quad precision environments
- corrected handling of different variable types in symmetry
- orbitope detection: refine computation of overlap structure and fixed bug in finding orbitope generators
- ensure that winner is always determined in concurrent mode
- when a row with invalid index range is added to the global cutpool, update the indices instead of failing with an assert
- update of watched literals in cons_xor.c and ensure that fixed variables are counted in propacateCons()
- avoid some numerical issue in check for redundant variables in linear constraints (introduced with version 8.0.2)
- more rows are treated as being integral in cutsSubstituteMIR() for CMIR cuts
- fixed several relaxations of the rhs of cuts to 0 in cuts.c
- avoid aggregation into a single linear constraint if they should not be upgraded (needed for indicator constraints)
- apply effective root changes before fork is repropagated during treeSwitchPath() in tree.c
- avoid invalid objective value for solutions generated from an unbounded LP relaxation in case of a nonlinear objective function
- disable recomputing symmetries after a restart (constraint removal is not permitted)
- avoid cutting off optimal solutions for small feasibility tolerances in conflict analysis
- initialize variable in presol_dualsparsify.c
- fix in presolving of variable bound constraints to use absolute instead of relative difference
- free variable histories in reoptimization mode
- handle whitespaces in interactive shell history consistently
- check and enforce equalities on which the objective is projected in cons_linear.c
- ensure row feasibilities of solution shiftings in heur_oneopt.c and heur_twoopt.c
- remove rounded row check blocking tolerable primal solutions in cons_varbound.c
- fixed that presolve of logicor-constraints may have attempted to cutoff a root of the not yet existing branch-and-bound tree
- only consider positive slack variables as active in benders.c
- in the feasibility check of and/or constraints, allow for fractional values in operands
- fixed linear outer-approximation for some composite absolute-value expressions

Miscellaneous
-------------

- Extended documentation of the parameter limits/solutions to point out that the limit is first checked in presolving
- Added more information about using SCIPcache- and SCIPflushRowExtensions() to documentation and comments
- Extended the `how to add' sections of the documentation by adding information on how to include default plugins into SCIP

@section RN803 SCIP 8.0.3
*************************

Examples and applications
-------------------------

- Externalize STP and PolySCIP applications

Interface changes
-----------------

### Command line interface

- When running the AMPL interface, the .nl filename extension does not need to be omitted for the input file anymore.

Build system
------------

### Cmake

- Forbid CMAKE_BUILD_TYPE nonstandard values
- Move -I/path/to/src/amplmp/include to front of compiler flags for include directories

### Makefile

Fixed bugs
----------

- fixed an incorrect handling of xor constraints
- the feasibility checker for integrality constraints now uses checkintegrality even for implied integers
- skip integrality check in cons_integral for relaxation-only implicit-integer variables
- fixed an issue caused by aggregated variables not added to a hashmap in the xor constraint handler
- changed function solveRowEchelonGF2 in cons_xor.c to avoid errors if rank is 0
- fixed that the implication presolver tried to aggregate or tighten bounds of multiaggregated variables
- fixed a sign check in detection of linear constraints that are parallel to the objective
- fixed bug in Clp and lpi_clp with missing basis information when calling the barrier with crossover; needs new Clp version
- do not assume aggregation is successful in cons_setppc.c

Miscellaneous
-------------

- Changed license to Apache 2.0, see https://www.apache.org/licenses/LICENSE-2.0.
- When an LP could not be solved accurately, scaling is now turned off as a last fall-back method.
- Functions for using the debug solution mechanism SCIPdebugAddSolVal, SCIPdebugGetSol, SCIPdebugGetSolVal,
  SCIPdebugSolIsValidInSubtree, SCIPdebugIsMainscip, SCIPdebugSolEnable, SCIPdebugSolDisable, SCIPdebugSolIsEnabled,
  SCIPwithDebugSol are now exported

@section RN802 SCIP 8.0.2
*************************

Interface changes
-----------------

### Deleted and changed API functions

- added input parameter SCIP_Bool initiallp to SCIPcutselsSelect
- changed function type int to SCIP_Longint for SCIPcutpoolGetMaxNCuts
- replaced SCIPsepastoreGetNCutsFound with SCIPsepastoreGetNCutsAdded following the naming convention for the new statistics
- replaced SCIPsepaIncNAppliedCuts with SCIPsepaIncNCutsApplied

### New API functions

- added SCIPsepastoreGetNCutsAdded, SCIPsepastoreGetNCutsAddedViaPool, SCIPsepastoreGetNCutsAddedDirect
- added SCIPsepaIncNCutsAdded, SCIPsepaDecNCutsAdded, SCIPsepaIncNCutsApplied, SCIPsepaGetNRootCalls, SCIPsepaGetNCutsAdded, SCIPsepaGetNCutsAddedViaPool, SCIPsepaGetNCutsAddedDirect, SCIPsepaGetNCutsAppliedViaPool, SCIPsepaGetNCutsAppliedDirect
- added SCIPcutpoolGetNRootCalls, SCIPcutpoolGetNCutsAdded, SCIPcutpoolAddMaxNCuts, SCIPcutpoolSetTime, SCIPcutpoolAddNCalls, SCIPcutpoolAddNRootCalls, SCIPcutpoolAddNCutsFound, SCIPcutpoolAddNCutsAdded,
- added SCIPcutselGetNCalls, SCIPcutselGetNRootCalls, SCIPcutselGetNRootCuts, SCIPcutselGetNRootForcedCuts, SCIPcutselGetNRootCutsFiltered, SCIPcutselGetNLocalCuts, SCIPcutselGetNLocalForcedCuts, SCIPcutselGetNLocalCutsFiltered,

### Interfaces to external software

- Added compatibility with Mosek 10.0.18.

### New parameters

- new parameters to turn on more statistics: misc/showdivingstats (diving heuristics), heuristics/alns/shownbstats (ALNS), estimation/showstats (tree size estimation)

### Data structures

- added nrootcalls and ncutsadded to SCIP_Cutpool
- added fromcutpool flag to SCIP_Row and fixed 33 bit allocation
- added ncalls, nrootcalls, nrootcutsselected, nrootcutsforced, nrootcutsfiltered, nlocalcutsselected, nlocalcutsforced, nlocalcutsfiltered to SCIP_Cutsel
- added ncutsadded, ncutsaddedviapool, ncutsaddeddirect, ncutsappliedviapool, ncutsapplieddirect, nrootcalls to SCIP_Sepa
- added ncutsadded, ncutsaddedviapool, ncutsaddeddirect to SCIP_Sepastore
- fixed statistics of relaxators w.r.t. number of times conss/cuts were added

Build system
------------

### Cmake

- new option `-DAUTOBUILD` that configures scip with dependencies on availability.
  Packages like Ipopt, PaPILO, Readline, Zimpl, ZLIB, GMP, Worhp are automatically found and linked, otherwise ignored.
  The individual flags for these packages are ignored. This makes a quick build easier. It is by default set to off.

Fixed bugs
----------

- read objective offset from ZIMPL files
- Make sure that objective limit is disabled if not all variables are in the LP. If we would run into
  an objective limit in this case, the results of the LP solver are unclear.
- fixed bug in reopt.c, which occured for bounds outside of current valid bounds
- fixed problem with recomputing symmetries after a restart
- fixed bug in SCIPcalcMIR() with wrong order of arguments for removeZerosQuad()
- fixed segmentation fault in update of cut statistic
- fixed bug in presolving of and constraints by merging variables with multiple occurrences before cliquePresolve()
- fixed bug in dual presolving of linear constraints by setting implicit integers to integers in multi-aggregation
- fixed update of presolve statistics on added constraints and changed coefficients in constraint handler for nonlinear constraints
- fixed bug with reading CIP files with large constraints split over several lines
- fixed bug with infinite bounds in the computation of conflict cuts
- fixed check for unbounded solution constructed by SCIPlpGetUnboundedSol(): The constructed solution is very likely infeasible
  since scaling increases small numerical feasibility violations. Therefore, the solution is now always accepted. However, the
  feasibility of the ray is now checked. This fix now might lead to several rounds of separation in order to resolve unbounded solutions,
  whereas previously SCIP started to branch immediately.
- changed to absolute tolerances in all redundancy checks for linear constraints

Miscellaneous
-------------

- Added extended cutselector statistics splitting between root node specific and general statistics
- Added extended and refined cutpool statistics showing the number of cuts added from the cutpool to the sepastore
- Added extended and refined separator statistics to get a better view of the individual generators performance
- turned off output of statistics for the following information by default:
  diving heuristics, ALNS neighborhood information and tree size estimation statistics;
  they can be turned on using the following new parameters:
  misc/showdivingstats (diving heuristics), heuristics/alns/shownbstats (ALNS), estimation/showstats (tree size estimation)

@section RN801 SCIP 8.0.1
*************************

Features
--------

- clique lifting in cons_setppc (parameter enablecliquelifting) is only disabled if it has been applied
- avoid warning if Mosek has reached/exceeded the objective limit
- improved curvature check for quadratic expressions when extended formulations are disabled

Examples and applications
-------------------------

- Fixed handling of enforcing in the TSP example.

Interface changes
-----------------

### Interfaces to external software

- Added compatibility with Mosek 10.0.13.

Build system
------------

- BLISS is now built from the vendored version from https://github.com/ds4dm/Bliss

### Cmake

- avoid warnings about unrecognized compiler warning silencing options when compilation with GCC fails
- adjust mosek find module to version 9.3
- added cmake compatibility for ipopt versions 3.14.x

### Makefile

- avoid warnings about unrecognized compiler warning silencing options when compilation with GCC fails
- fixed that compilation with MS/Intel compilers on Windows and Cray compilers was broken when enabling PAPILO

Fixed bugs
----------

- fixed uninitialized array in detection of suborbitopes
- Fixed problem with reading long lines in LP/FZN/OPB/Diff-files. The buffer is now reallocated,
  which also should be much faster.
- fixed that recursive products in expressions were sometimes not flattened
- fixed that expressions in original variables could not be simplified
- fixed handling of objective limit with Mosek
- made SCIPlpiGetSolverName()/SCIPlpiGetSolverDesc() thread-safe for LP Solvers (Cplex,Gurobi,Glop,Mosek,SoPlex,Xpress)
- made SYMsymmetryGetName() thread-safe for Bliss
- fixed memory allocation issue in detection of SOC nlhdlr
- fixed that reaching the walltime limit in Ipopt was not handled properly
- Deactivated dual fixing of unlocked variables with zero objective in presol_milp that SCIP is unable to postsolve.
- set the column flag kImplInt for implicit integers in the papilo problem
- fixed bug in propagation of indicator constraints (one case always reported a change through propagation)

@section RN800 SCIP 8.0.0
*************************

Features
--------

- Variables that were marked as relaxation-only and that were not used in any solution (SCIP_SOL)
  are now deleted when during a restart.
- New symmetry handling method, symmetry handling inequalities based on the Schreier Sims table,
  which is able to handle symmetries of arbitrary kinds of variables.
- Revise way in which external memory (e.g., of LP-solver) is estimated.
- The symmetry code can now heuristically search for orbitopes that do not completely handle
  a symmetry component and add certain Schreier Sims cuts to such components.
- The LPIs for Gurobi and Mosek are thread-safe now.
- The complete code is now thread-safe by default.
- New separator to generate mixing cuts (works well for stochastic programming with probabilistic constraint).
- New parsing routines for cons_orbisack and cons_symresack.
- Variables can now be marked to forbid aggregation.
- Heuristic PADM can now reoptimize found solution with original objective function.
- Added code to support debugging of catching or releasing of variables to var.c (prints backtrace
  when catching and releasing).
- SCIPintervalSin() and SCIPintervalCos() are now rounding-safe.
- Removed special handling of second-order cones in undercover heuristic for now.
- Removed use of Hessian sparsity pattern for nonquadratic nonlinear constraints in undercover heuristic.
- Added reader for AMPL .nl files.
- New separator sepa_rlt to compute cuts via the reformulation-linearization technique (RLT).
- New separator sepa_minor to compute cuts from 2x2 minors of a violated semidefiniteness constraint that is
  implied by the extended formulation for bilinear products.
- New separator sepa_interminor to compute intersection cuts from 2x2 (not only principle) minors of a violated
  rank-one constraint that is implied by the extended formulation for bilinear products.
- Symmetry handling has been extended to detect also symmetries between variables that also appear in nonlinear constraints.
- Improved OBBT propagator by only considering variables that are contained in at least one nonconvex expression that has an auxiliary variable.
- Default parameter settings for NLP solves are now defined independently of the NLP solver.
- Added table to print statistics on NLP solvers.
- Knapsack, linear, logicor, setppc, and varbound constraints now add themselves to the NLP relaxation, if enabled.
  And, linking constraints and bounddisjunctions in one variable are added to the NLP relaxation now.
- Ipopt interface now supports warmstarts from a full primal/dual solution pair.
- Extended data structure SCIP_ROWPREP and routines to assemble a linear inequality before it is turned into a SCIP row and
  made it available via the API.
- MIR procedure is now available for strengthening the Benders' optimality cut
- SCIPbranchcandCalcLPCands() now also returns fractional variables in unbounded solutions.
- New emphasis "benchmark" to avoid different solving paths that may come from checking remaining memory.
- New plugin type for cut selection: users can now include their own cut selection rules, default rule moved to cutsel_hybrid.
- New construction heuristic DPS which additionally needs a user-provided decomposition and splits the problem into several sub-SCIPs
  according to this decomposition. The sub-SCIPs are solved and updated repeatedly until a feasible solution of the original problem is found.

Expressions:
- Removed support for expression types min and max for now. Removed support for expression type sign.
  Removed complex expression types sum, product, linear, quadratic, polynomial.
  Removed support for parameterized expressions.
- Added support for expression types sin, cos, and entropy. Added an expression type that stores a SCIP variable.
- Added handling of sin and cos expressions in OSiL reader.
- Added handling of sin, cos, and tan expressions in ZIMPL reader.
- Added expression handler plugin type, removed user expression type.
- Replaced expressions, expression trees, and expression graphs by a new implementation of expressions.
- Added differentiation methods (Gradients and Hessian directions) to expressions.
- Added integrality information to expressions.
- Added comparison and hashing of expressions.
- Improved simplification of expressions and identification of common subexpressions, in particular terms that appear
  equally in several quadratic functions are now identified.
- Expression simplification now expands powers also when the resulting exponents will be larger than 2.
- Added table to print statistics on expression handlers.
- Removed interval-arithmetic evaluation from expression interpreter (interfaces to automatic differentiation codes).
- Hessians for user-provided expression handlers are not available in the NLP solver interfaces for now.
- Sparse Hessians are now returned by expression interpreter. Removed dense Hessians.

Constraint handlers for NLP:
- cons_nonlinear has been completely rewritten and now handles constraints of the form lhs <= expr <= rhs, where
  expr is an expression using the new expression type. A linear part of a nonlinear constraint is no longer distinguished.
- Methods that work on a particular nonlinear structure are now implemented via nonlinear handlers (nlhdlr).
  These handlers are plugins of cons_nonlinear and interact with cons_nonlinear by detecting structures in expressions and
  providing propagation and separation mechanisms.
- Added nlhdlr "default" as a mandatory nlhdlr: this is a nlhdlr that gets active on expressions that no other nlhdlr handles.
  It then uses the callbacks implemented in expression handlers to provide domain propagation and linear under/overestimates.
- Added nlhdlr for quadratic expressions: domain propagation that was previously part of cons_quadratic; separation via intersection cuts (currently disabled).
- Added nlhdlr for bilinear expressions: collects bilinear products and provides under/overestimation of a product over a 2D-projection of the LP.
- Added nlhdlr for convex and concave expressions: detection of convex/concave subexpressions and linear under/overestimation.
- Added nlhdlr for quotients: detects quotients, provides specialized linear under/overestimation and domain propagation for univariate quotients.
- Added nlhdlr for perspective reformulations: detects expressions in semi-continuous variables and tightens linear
  under/overestimates of these expressions by applying a perspective transformation.
- Added nlhdlr for second-order cones: detects second-order cone constraints (as ||x|| <= t or a quadratic that can written like that) and
  separates on a disaggregated reformulation (similar to cons_soc previously).
- Removed constraint handlers abspower, bivariate, quadratic, and soc.
- Removed simplification of duplicate abspower constraints for now.
  Removed simplification of abspower constraints with loose variables.
  Removed resolving of domain propagation (ConsResProp callback) and conflict analysis for abspower constraints.
  Removed propagation of varbounds for variables of abspower constraints.
  Removed reformulation of abs(x)^p * x into signpower expression for now.
- Removed reformulation of SOC constraints when adding to the NLP.
  Removed possibility to add linearizations a la Glineur or BenTal&Nemirovski for SOC constraints.
- Removed possibility to disaggregate quadratic constraints.
  Removed lifted tangent inequalities for bilinear terms in quadratic constraints.
  Removed option to project LP solution onto feasible region of a quadratic constraint via interior point or gauge function.
  Removed handling of unbounded LPs when enforcing quadratic constraints.
- Removed construction of cuts from interval gradients for nonlinear constraints.
  Removed possibility to pretend that all nonlinear constraints are convex.
  Removed possibility to create local or non-initial nonlinear constraints for now.
- Removed explicit reformulation of nonlinear constraints in presolve.
  An extended formulation is now generated implicitly and used to construct the LP relaxation,
  but the original formulation is used to check feasibility, propagate variable domains, etc.
  Variables that are added for the extended formulation are now marked as relaxation-only.
- Improved locking of nonlinear variables in nonlinear constraints by taking monotonicity into account.
- Improved mechanisms to detect and handle structures in nonlinear constraints, which allows for several algorithms
  to work simultaneously on equal or overlapping expressions.
- Improved linearization of (sums of) products of binary variables, e.g., clique information is now taken into account.
  Removed option to linearize products between a binary and a non-binary variable.
- Nonlinear constraints with the same function (but possibly different left- or right-hand-side) are now merged.
- When a variable appears in only one concave less-or-equal constraint, it will be fixed to one of its bounds in more cases now.
- New branching rule for variables in nonlinear constraints (implemented in cons_nonlinear) that scores candidates
  based on constraint violation, variable type, and pseudo-costs simultaneously.
- Added tables to print statistics of nonlinear constraint handler and nonlinear handlers.

Performance improvements
------------------------

- Use the objective cutoff row as base row for separation in sepa_aggregation.c.
- Separate lifted cover cuts based on newer lifting function of Letchford and Souli (2019) in sepa_aggregation.c.
- In-tree restarts due to tree size estimation have been made compatible with orbital fixing.
- Improved upgrade of orbisacks to packing/partitioning orbitopes.
- Improved running time of symresack cover separation.
- Improved propagation algorithm for orbisack and symresack.
- Improved handling for expressions of type signpower in CppAD interface by making use of CppADs conditional expressions.
- Faster reevaluation of Hessian for quadratic expressions in CppAD interface.
- Enabled optimization of taped expressions in the CppAD interface.
- Sparse Hessian evaluation for expressions with sparse Hessian in the CppAD interface.
- Disabled branching on variables that are added for the extended formulation of a nonlinear constraint.
- Prefer branching on variables in nonconvex terms of nonlinear constraints also if a cut could be generated but would yield a small reduction in the convexification gap only.
- When violations of nonlinear constraints are tiny, the feasibility tolerance for the LP relaxation may now be reduced temporarily to allow for cuts to have an effect.
- Improved under/overestimation of multidimensional vertex-polyhedral (e.g., multilinear or concave) functions by use of scaling and keeping the cut-generating LP around.
- Products in nonlinear constraints are no longer disaggregated for the extended formulation.
- No longer relax bounds of integral variables when computing bounds on activity in nonlinear constraints.
- Revised and improved Ipopt interface.
- Revised and improved subNLP primal heuristic, in particular choice of iteration limit and starting condition and reuse of subSCIP.
- Merge strongcg into the gomory separator to avoid computing the same base equality twice. The files
  sepa_strongcg.{h|c} have been removed.
- The RENS neighborhood in ALNS now fixes fractional variables if necessary for reaching its target fixing rate.
- Use cpsolver emphasis in sepa_rapidlearning.
- If decomposition/maxgraphedge = 0, the computation of the block graph is completely turned off.
- Fixed a performance bug in cons_integral.c where rounding information was passed incorrectly to the generic diving algorithm.

Examples and applications
-------------------------

- Add c++ Sudoku example
- Removed circle.c and renamed string.c to spring.c in CallableLibrary example.
- SCIP-Jack (Steiner tree application):
  Most files have been modified and many new ones have been added (code base more than doubled).
  Two new problem classes are supported: maximum-weight connected subgraph problem with budget constraints, partial-terminal node-weighted Steiner tree problem.
  Major performance improvements accross all problem classes that are supported.

Interface changes
-----------------

### New and changed callbacks

- extend SEPAEXEC{LP,SOL} callbacks by parameter "depth", which should be used within separation instead of SCIPgetCurrentDepth()
- extend SCIPseparateSolCutpool() by parameter "pretendroot", which is passed to SCIPcutpoolSeparate() instead of SCIPtreeGetCurrentDepth(scip->tree) == 0
- removed SCIP_DECL_EXPRGRAPHVARADDED, SCIP_DECL_EXPRGRAPHVARREMOVE, SCIP_DECL_EXPRGRAPHVARCHGIDX
- removed SCIP_DECL_USEREXPRESTIMATE, SCIP_DECL_USEREXPREVAL, SCIP_DECL_USEREXPRINTEVAL, SCIP_DECL_USEREXPRCURV, SCIP_DECL_USEREXPRPROP, SCIP_DECL_USEREXPRCOPYDATA, SCIP_DECL_USEREXPRFREEDATA, SCIP_DECL_USEREXPRPRINT
- added SCIP_DECL_EXPR_OWNERFREE, SCIP_DECL_EXPR_OWNERPRINT, SCIP_DECL_EXPR_OWNEREVALACTIVITY, SCIP_DECL_EXPR_OWNERCREATE
- added SCIP_DECL_EXPR_INTEVALVAR, SCIP_DECL_EXPR_MAPEXPR
- added SCIP_DECL_EXPRCOPYHDLR, SCIP_DECL_EXPRFREEHDLR, SCIP_DECL_EXPRCOPYDATA, SCIP_DECL_EXPRFREEDATA, SCIP_DECL_EXPRPRINT, SCIP_DECL_EXPRPARSE, SCIP_DECL_EXPRCURVATURE, SCIP_DECL_EXPRMONOTONICITY, SCIP_DECL_EXPRINTEGRALITY, SCIP_DECL_EXPRHASH, SCIP_DECL_EXPRCOMPARE, SCIP_DECL_EXPREVAL, SCIP_DECL_EXPRBWDIFF, SCIP_DECL_EXPRFWDIFF, SCIP_DECL_EXPRBWFWDIFF, SCIP_DECL_EXPRINTEVAL, SCIP_DECL_EXPRESTIMATE, SCIP_DECL_EXPRINITESTIMATES, SCIP_DECL_EXPRSIMPLIFY, SCIP_DECL_EXPRREVERSEPROP
- removed SCIP_DECL_QUADCONSUPGD
- added SCIP_DECL_VERTEXPOLYFUN
- added argument nvarexprs to SCIP_DECL_NONLINCONSUPGD to inform upgrade method about number of variables in constraint
- removed SCIP_DECL_EXPRGRAPHNODEREFORM
- added SCIP_DECL_NLHDLRCOPYHDLR, SCIP_DECL_NLHDLRFREEHDLRDATA, SCIP_DECL_NLHDLRFREEEXPRDATA, SCIP_DECL_NLHDLRINIT, SCIP_DECL_NLHDLREXIT, SCIP_DECL_NLHDLRDETECT, SCIP_DECL_NLHDLREVALAUX, SCIP_DECL_NLHDLRINTEVAL, SCIP_DECL_NLHDLRREVERSEPROP, SCIP_DECL_NLHDLRINITSEPA, SCIP_DECL_NLHDLREXITSEPA, SCIP_DECL_NLHDLRENFO, SCIP_DECL_NLHDLRESTIMATE
- replaced BMS_BLKMEM* blkmem argument of SCIP_DECL_NLPICOPY by SCIP* scip, removed targetnlpi argument
- added SCIP* scip and SCIP_NLPIDATA** nlpidata arguments to SCIP_DECL_NLPIFREE
- added SCIP* scip to SCIP_DECL_NLPIGETSOLVERPOINTER, SCIP_DECL_NLPICREATEPROBLEM, SCIP_DECL_NLPIFREEPROBLEM, SCIP_DECL_NLPIGETPROBLEMPOINTER, SCIP_DECL_NLPIADDVARS, SCIP_DECL_NLPIADDCONSTRAINTS, SCIP_DECL_NLPISETOBJECTIVE, SCIP_DECL_NLPICHGVARBOUNDS, SCIP_DECL_NLPICHGCONSSIDES, SCIP_DECL_NLPIDELVARSET, SCIP_DECL_NLPIDELCONSSET, SCIP_DECL_NLPICHGLINEARCOEFS, SCIP_DECL_NLPICHGOBJCONSTANT, SCIP_DECL_NLPISETINITIALGUESS, SCIP_DECL_NLPISOLVE, SCIP_DECL_NLPIGETSOLSTAT, SCIP_DECL_NLPIGETTERMSTAT, SCIP_DECL_NLPIGETSOLUTION, SCIP_DECL_NLPIGETSTATISTICS
- replaced SCIP_DECL_NLPICHGEXPRTREE by SCIP_DECL_NLPICHGEXPR
- removed nquadelems, quadelems, exprvaridxs arguments from SCIP_DECL_NLPIADDCONSTRAINTS, changed exprtrees argument to exprs
- removed nquadelems, quadelems, exprvaridxs arguments from SCIP_DECL_NLPISETOBJECTIVE, changed exprtree argument to expr
- removed SCIP_DECL_NLPICHGQUADCOEFS, SCIP_DECL_NLPICHGNONLINCOEF, SCIP_DECL_NLPISETMESSAGEHDLR
- added SCIP_NLPIPROBLEM* problem to SCIP_DECL_NLPIGETSOLVERPOINTER

### Deleted and changed API functions

- When calling SCIPdelVar() in the SCIP_STAGE_PROBLEM stage, it is now documented as the user's responsibility to ensure
  the variable is not present in any constraints. Otherwise, SCIPsolve() now returns SCIP_INVALIDDATA.
- removed SCIPselectCuts(), replaced by SCIPselectCutsHybrid() of the hybrid cut selector plugin
- If SCIPvarMarkRelaxationOnly() is called for a variable, then this now need to happen before the
  variable is added to the transformed problem (SCIPaddVar()).
  SCIPvarMarkRelaxationOnly() will automatically call SCIPvarMarkDeletable().
- SCIPcomputeOrbitsFilterSym() and SCIPcomputeComponentsSym(): Type of argument componentblocked
  changed from SCIP_Shortbool* to unsigned*.
- removed SCIPsetParam()
- SCIPcreateConsOrbitope() and SCIPcreateConsBasicOrbitope() have two new arguments "usedynamicprop"
  and "mayinteract" to encode whether a dynamic reordering of the orbitope rows shall be used in
  full orbitope propagation and whether the orbitope might interact with other symmetry handling
  methods, respectively.
- internal function SCIPgetPropertiesPerm() has been replaced by SCIPisInvolutionPerm()
- internal function SCIPgenerateOrbitopeVarsMatrix() has new arguments "storelexorder", "lexorder",
  "nvarsorder", "maxnvarsorder" to compute and store the lexicographic order defined by an orbitope
- renamed SCIPcomputeArraysIntersection() and SCIPcomputeArraysSetminus() to
  SCIPcomputeArraysIntersectionInt() and SCIPcomputeArraysSetminusInt(), respectively, and changed
  their return type from SCIP_RETCODE (which _always_ was SCIP_OKAY) to void
- removed SCIPincludeDialogDefault(), use SCIPincludeDialogDefaultBasic() instead and check whether you also need SCIPincludeDialogDefaultSet() and SCIPincludeDialogDefaultFix()
- removed exprint argument from SCIPaddNlRowGradientBenderscutOpt()
- added copyexprhdlrs argument to SCIPcopyPlugins() (19th position)
- added copycutselectors argument to SCIPcopyPlugins() (10th position)
- removed refpoint argument from SCIPaddSquareSecant()
- added argument exprdata to SYMcomputeSymmetryGenerators()
- removed SCIPconsNonlinearGetRhs(), SCIPconsNonlinearGetLhs(), SCIPconsNonlinearAddLinearCoef()
- removed arguments timelimit, minimprove, itercontingent, and iterused from SCIPapplyHeurSubNlp()
- removed SCIPresolveSolHeurSubNlp(), SCIPgetSubScipHeurSubNlp(), SCIPgetVarMappingScip2SubScipHeurSubNlp(), SCIPgetVarMappingSubScip2ScipHeurSubNlp()
- SCIPlockVarCons() and SCIPunlockVarCons() are now allowed in stage TRANSFORMED as well
- Added functions SCIPsetSepaIsParentsepa(), SCIPsetSepaParentsepa() [in scip_sepa.h], SCIPsepaSetIsParentsepa(), SCIPsepaSetParentsepa() [in sepa.h],
  SCIPsepaIsParentsepa(), SCIPsepaGetParentsepa() [in pub_sepa.h]
- Added function SCIPpruneTree() to immediately delete nodes that were marked to be deleted with SCIPcutoffNode

NLP:
- SCIPhasNLPContinuousNonlinearity() now returns SCIP_RETCODE and has additional argument result
- removed SCIPnlrowGetNQuadVars(), SCIPnlrowGetQuadVars(), SCIPnlrowSearchQuadVar(), SCIPnlrowGetNQuadElems(), SCIPnlrowGetQuadElems(), SCIPnlrowGetQuadData()
- renamed SCIPnlrowGetExprtree() to SCIPnlrowGetExpr() and changed return type to SCIP_EXPR*
- removed arguments nquadvars, quadvars, nquadelems, quadelems from SCIPcreateNlRow(); argument expr(ession) is now of type SCIP_EXPR*
- removed SCIPaddQuadVarToNlRow(), SCIPaddQuadVarsToNlRow(), SCIPaddQuadElementToNlRow(), SCIPaddQuadElementsToNlRow(), SCIPchgNlRowQuadElement(), SCIPsetNlRowExprtreeParam(), SCIPsetNlRowExprtreeParams()
- renamed SCIPsetNlRowExprtree() to SCIPsetNlRowExpr() and changed type of expr(tree) argument to SCIP_EXPR*
- SCIPenableNLP() is no longer allowed in stages INITSOLVE and SOLVING
- removed SCIPaddLinearConsToNlpHeurSubNlp()
- SCIPhasNLPSolution() now returns true also if a infeasible solution to the NLP exists; SCIPcreateNLPSol() can now also be used when only an infeasible solution to the NLP exists
- renamed SCIPsolveNLP() to SCIPsolveNLPParam() and added parameter SCIP_NLPPARAM param
- removed SCIPsolveDiveNLP(), use SCIPsolveNLPParam() instead

NLPI:
- removed SCIPnlpiCopy(), SCIPnlpiFree(), SCIPnlpiChgQuadCoefs(), SCIPnlpiChgNonlinCoef(), SCIPnlpiSetMessageHdlr()
- removed SCIPnlpiCreate() from public API, use SCIPincludeNlpi() instead
- removed SCIPnlpiGetSolverPointer() from public API, use SCIPgetNlpiSolverPointer() instead
- removed SCIPnlpiCreateProblem() from public API, use SCIPcreateNlpiProblem() instead
- removed SCIPnlpiFreeProblem() from public API, use SCIPfreeNlpiProblem() instead
- removed SCIPnlpiGetProblemPointer() from public API, use SCIPgetNlpiProblemPointer() instead
- removed SCIPnlpiAddVars() from public API, use SCIPaddNlpiVars() instead
- removed SCIPnlpiAddConstraints() from public API, use SCIPaddNlpiConstraints() instead
- removed SCIPnlpiSetObjective() from public API, use SCIPsetNlpiObjective() instead
- removed SCIPnlpiChgVarBounds() from public API, use SCIPchgNlpiVarBounds() instead
- removed SCIPnlpiChgConsSides() from public API, use SCIPchgNlpiConsSides() instead
- removed SCIPnlpiDelVarSet() from public API, use SCIPdelNlpiVarSet() instead
- removed SCIPnlpiDelConsSet() from public API, use SCIPdelNlpiConsSet() instead
- removed SCIPnlpiChgLinearCoefs() from public API, use SCIPchgNlpiLinearCoefs() instead
- removed SCIPnlpiChgExprtree() from public API, use SCIPchgNlpiExpr() instead
- removed SCIPnlpiChgObjConstant() from public API, use SCIPchgNlpiObjConstant() instead
- removed SCIPnlpiSetInitialGuess() from public API, use SCIPsetNlpiInitialGuess() instead
- removed SCIPnlpiSolve() from public API, use SCIPsolveNlpiParam() instead
- removed SCIPnlpiGetSolstat() from public API, use SCIPgetNlpiSolstat() instead
- removed SCIPnlpiGetTermstat() from public API, use SCIPgetNlpiTermstat() instead
- removed SCIPnlpiGetSolution() from public API, use SCIPgetNlpiSolution() instead
- removed SCIPnlpiGetStatistics() from public API, use SCIPgetNlpiStatistics() instead
- removed SCIPnlpiGetWarmstartSize()
- removed SCIPnlpiGetWarmstartMemo()
- removed SCIPnlpiSetWarmstartMemo()
- removed SCIPnlpiGetIntPar()
- removed SCIPnlpiSetIntPar()
- removed SCIPnlpiGetRealPar()
- removed SCIPnlpiSetRealPar()
- removed SCIPnlpiGetStringPar(),
- removed SCIPnlpiSetStringPar()
- removed SCIPnlpiSetPriority() from public API, use SCIPsetNlpiPriority() instead
- removed argument nlpi from SCIPincludeNlpi() and added name, description, priority,
  nlpicopy, nlpifree, nlpigetsolverpointer, nlpicreateproblem, nlpifreeproblem, nlpigetproblempointer, nlpiaddvars, nlpiaddconstraints, nlpisetobjective, nlpichgvarbounds, nlpichgconssides, nlpidelvarset, nlpidelconsset, nlpichglinearcoefs, nlpichgexpr, nlpichgobjconstant, nlpisetinitialguess, nlpisolve, nlpigetsolstat, nlpigettermstat, nlpigetsolution, nlpigetstatistics, nlpidata
- removed SCIPcreateNlpSolverAll(), use SCIPincludeNlpSolverAll() instead
- removed SCIPcreateNlpSolverFilterSQP(), use SCIPincludeNlpSolverFilterSQP() instead
- removed SCIPcreateNlpSolverIpopt(), use SCIPincludeNlpSolverIpopt() instead
- removed SCIPcreateNlpSolverWorhp(), use SCIPincludeNlpSolverWorhp() instead
- replaced argument BMS_BLKMEM* blkmem of SCIPnlpiOracleCreate() by SCIP* scip
- added argument SCIP* scip to SCIPnlpiOracleFree(), SCIPnlpiOracleSetProblemName(), SCIPnlpiOracleAddVars(), SCIPnlpiOracleAddConstraints(), SCIPnlpiOracleSetObjective(), SCIPnlpiOracleChgVarBounds(), SCIPnlpiOracleChgConsSides(), SCIPnlpiOracleDelVarSet(), SCIPnlpiOracleDelConsSet(), SCIPnlpiOracleChgLinearCoefs(), SCIPnlpiOracleChgObjConstant(), SCIPnlpiOracleGetEvalCapability(), SCIPnlpiOracleEvalObjectiveValue(), SCIPnlpiOracleEvalConstraintValue(), SCIPnlpiOracleEvalConstraintValues(), SCIPnlpiOracleEvalObjectiveGradient(), SCIPnlpiOracleEvalConstraintGradient(), SCIPnlpiOracleGetJacobianSparsity(), SCIPnlpiOracleEvalJacobian(), SCIPnlpiOracleGetHessianLagSparsity(), SCIPnlpiOracleEvalHessianLag(), SCIPnlpiOraclePrintProblem(), SCIPnlpiOraclePrintProblemGams()
- removed arguments nquadelems, quadelems, exprvaridxs, exprtrees from SCIPnlpiOracleAddConstraints(), added argument SCIP_EXPR** exprs
- removed arguments nquadelems, quadelems, exprvaridxs, exprtree from SCIPnlpiOracleSetObjective(), added argument SCIP_EXPR* expr
- replaced arguments isnewx of SCIPnlpiOracleEvalHessianLag() by two arguments isnewx_obj and isnewx_cons
- removed SCIPnlpiOracleChgExprtree(), use SCIPnlpiOracleChgExpr() instead
- removed SCIPnlpiOracleSetInfinity(), SCIPnlpiOracleGetInfinity(), SCIPnlpiOracleChgQuadCoefs(), SCIPnlpiOracleChgExprParam(), SCIPnlpiOracleGetMaxDegree()
- removed SCIPnlpiOracleGetVarDegree() and SCIPnlpiOracleGetVarDegrees(), use SCIPnlpiOracleIsVarNonlinear() and SCIPnlpiOracleGetVarCounts(), respectively, instead
- removed SCIPnlpiOracleGetConstraintDegree(), use SCIPnlpiOracleIsConstraintNonlinear() instead
- removed argument messagehdlr from SCIPnlpiOraclePrintProblem() and SCIPnlpiOraclePrintProblemGams()
- removed SCIPcreateNlpiProb(), use SCIPcreateNlpiProblemFromNlRows() instead
- renamed SCIPupdateNlpiProb() to SCIPupdateNlpiProblem() and moved into scip_nlpi.{h,c}
- renamed SCIPaddNlpiProbRows() to SCIPaddNlpiProblemRows() and moved into scip_nlpi.{h,c}
- removed SCIPsetModifiedDefaultSettingsIpopt()
- removed SCIPgetIpoptApplicationPointerIpopt(), use SCIPgetNlpiSolverPointer() instead
- removed SCIPnlpStatisticsCreate(), SCIPnlpStatisticsFree(), SCIPnlpStatisticsGetNIterations(), SCIPnlpStatisticsGetTotalTime(), SCIPnlpStatisticsSetNIterations(), SCIPnlpStatisticsSetTotalTime(), the struct is public now
- renamed LapackDsyev() to SCIPcallLapackDsyevIpopt()
- renamed SCIPsolveLinearProb() to SCIPsolveLinearEquationsIpopt()

Expression interpreter:
- removed functions that operated with SCIPInterval
- changed first argument of SCIPexprintCreate() to SCIP*
- added SCIP* as first argument to SCIPexprintFree()
- added SCIP* as first argument to SCIPexprintCompile(), changed third argument to SCIP_EXPR*, added fourth argument SCIP_EXPRINTDATA**
- added arguments SCIP*, SCIP_EXPRINT*, and SCIP_EXPR* as first arguments to SCIPexprintFreeData()
- renamed SCIPexprintGetExprtreeCapability() to SCIPexprintGetExprCapability();
  added SCIP* as first argument, changed third argument to SCIP_EXPR*, added fourth argument SCIP_EXPRINTDATA*
- removed SCIPexprintNewParametrization()
- SCIPexprintEval(): added SCIP* as first argument, changed third argument to SCIP_EXPR*, added fourth argument SCIP_EXPRINTDATA*
- removed SCIPexprintEvalInt()
- SCIPexprintGrad(): added SCIP* as first argument, changed third argument to SCIP_EXPR*, added fourth argument SCIP_EXPRINTDATA*
- removed SCIPexprintGradInt()
- removed SCIPexprintHessianSparsityDense() and SCIPexprintHessianDense, use SCIPexprintHessianSparsity() and SCIPexprintHessian() instead

Expressions:
- removed SCIPexpropGetName(), use SCIPexprhdlrGetName() instead
- removed SCIPexpropGetNChildren()
- removed SCIPexprGetOperator(), use SCIPexprGetHdlr() instead
- removed SCIPexprGetOpIndex(), SCIPexprGetOpReal(), SCIPexprGetOpData(), use SCIPexprGetData() instead
- removed SCIPexprGetRealPowerExponent(), SCIPexprGetIntPowerExponent(), SCIPexprGetSignPowerExponent(), use SCIPgetExponentExprPow() instead
- removed SCIPexprGetLinearCoefs(), SCIPexprGetLinearConstant(), use SCIPgetCoefsExprSum() and SCIPgetConstantExprSum() instead
- removed SCIPexprGetQuadElements(), SCIPexprGetQuadConstant(), SCIPexprGetQuadLinearCoefs(), SCIPexprGetNQuadElements(), use SCIPexprGetQuadraticData(), SCIPexprGetQuadraticQuadTerm(), SCIPexprGetQuadraticBilinTerm() instead
- removed SCIPexprGetMonomials(), SCIPexprGetNMonomials, SCIPexprGetPolynomialConstant(), SCIPexprGetMonomialCoef(), SCIPexprGetMonomialNFactors(), SCIPexprGetMonomialChildIndices(), SCIPexprGetMonomialExponents()
- removed SCIPexprGetUserData(), SCIPexprHasUserEstimator(), SCIPexprGetUserEvalCapability()
- removed SCIPexprCreate(), use SCIPcreateExpr() instead
- removed SCIPexprCopyDeep(), use SCIPduplicateExpr() instead
- removed SCIPexprFreeDeep(), use SCIPreleaseExpr() instead
- removed SCIPexprFreeShallow()
- removed SCIPexprAdd(), SCIPexprMulConstant()
- removed SCIPexprCreateLinear(), use SCIPcreateExprSum() instead
- replaced SCIPexprAddToLinear() by SCIPappendExprSumExpr()
- replaced SCIPexprCreateQuadratic() by SCIPcreateExprQuadratic()
- removed SCIPexprSortQuadElems()
- removed SCIPexprCreatePolynomial(), SCIPexprAddMonomials(), SCIPexprChgPolynomialConstant(), SCIPexprMultiplyPolynomialByConstant(), SCIPexprMultiplyPolynomialByMonomial(), SCIPexprMultiplyPolynomialByPolynomial(), SCIPexprPolynomialPower()
- removed SCIPexprMergeMonomials(), SCIPexprFreeMonomial(), SCIPexprSortMonomialFactors(), SCIPexprFindMonomialFactor(), SCIPexprAreMonomialsEqual(), SCIPexprAddMonomialFactors(), SCIPexprChgMonomialCoef(), SCIPexprMultiplyMonomialByMonomial(), SCIPexprMonomialPower(), SCIPexprMergeMonomialFactors(), SCIPexprSortMonomials()
- replaced SCIPexprCreateMonomial() by SCIPcreateExprMonomial()
- removed SCIPexprCreateUser(), use SCIPincludeExprhdlr() instead
- removed SCIPexprHasParam(), SCIPexprGetMaxDegree(), SCIPexprGetVarsUsage()
- replaced SCIPexprAreEqual() by SCIPcompareExpr()
- replaced SCIPexprSimplify() by SCIPsimplifyExpr()
- replaced SCIPexprEvalShallow() by SCIPcallExprEval()
- replaced SCIPexprEval() by SCIPevalExpr()
- replaced SCIPexprEvalIntShallow() by SCIPcallExprInteval()
- replaced SCIPexprEvalInt() by SCIPevalExprActivity()
- removed SCIPexprEvalUser(), SCIPexprEvalIntUser(), SCIPexprEstimateUser()
- replaced SCIPexprCheckCurvature() by SCIPcomputeExprCurvature()
- removed SCIPexprSubstituteVars(), use SCIPcopyExpr() instead
- removed SCIPexprReindexVars(), SCIPexprReindexParams()
- replaced SCIPexprPrint() by SCIPprintExpr()
- replaced SCIPexprParse() by SCIPparseExpr()

Expression tree:
- removed SCIPexprtreeGetVars(), SCIPexprtreeSetVars(), SCIPexprtreeAddVars(), SCIPexprtreePrintWithNames(), SCIPexprtreeFindVar()
- removed SCIPexprtreeGetRoot(), SCIPexprtreeGetNVars(), SCIPexprtreeGetNParams(), SCIPexprtreeGetParamVals(), SCIPexprtreeSetParamVal(), SCIPexprtreeHasParam()
- removed SCIPexprtreeGetInterpreterData(), SCIPexprtreeSetInterpreterData(), SCIPexprtreeFreeInterpreterData()
- removed SCIPexprtreeGetMaxDegree()
- removed SCIPexprtreeEval(), use SCIPevalExpr() instead
- removed SCIPexprtreeEvalInt(), use SCIPevalExprActivity() instead
- removed SCIPexprtreePrint(), use SCIPprintExpr() instead
- removed SCIPexprtreeCreate()
- removed SCIPexprtreeCopy(), use SCIPduplicateExpr() instead
- removed SCIPexprtreeFree(), use SCIPreleaseExpr() instead
- removed SCIPexprtreeSetParams(), SCIPexprtreeGetVarsUsage()
- removed SCIPexprtreeSimplify(), use SCIPsimplifyExpr() instead
- removed SCIPexprtreeAddExpr()
- removed SCIPexprtreeCheckCurvature(), use SCIPcomputeExprCurvature() instead
- removed SCIPexprtreeSubstituteVars(), use SCIPcopyExpr() instead
- removed SCIPquadelemSort(), SCIPquadelemSortedFind(), SCIPquadelemSqueeze()

Expression graph:
- removed SCIPexprgraphCaptureNode(), use SCIPcaptureExpr() instead
- removed SCIPexprgraphIsNodeEnabled()
- removed SCIPexprgraphGetNodeNChildren(), use SCIPexprGetNChildren() instead
- removed SCIPexprgraphGetNodeChildren(), use SCIPexprGetChildren() instead
- removed SCIPexprgraphGetNodeNParents(), SCIPexprgraphGetNodeParents(), SCIPexprgraphGetNodeDepth(), SCIPexprgraphGetNodePosition()
- removed SCIPexprgraphGetNodeOperator(), use SCIPexprGetHdlr() instead
- removed SCIPexprgraphGetNodeOperatorIndex(), SCIPexprgraphGetNodeOperatorReal(), use SCIPexprGetData() instead
- removed SCIPexprgraphGetNodeVar(), use SCIPgetVarExprVar() instead
- removed SCIPexprgraphGetNodeRealPowerExponent(), SCIPexprgraphGetNodeIntPowerExponent(), SCIPexprgraphGetNodeSignPowerExponent(), use SCIPgetExponentExprPow() instead
- removed SCIPexprgraphGetNodeLinearCoefs(), SCIPexprgraphGetNodeLinearConstant(), use SCIPgetCoefsExprSum(), SCIPgetConstantExprSum() instead
- removed SCIPexprgraphGetNodeQuadraticConstant(), SCIPexprgraphGetNodeQuadraticLinearCoefs(), SCIPexprgraphGetNodeQuadraticQuadElements(), SCIPexprgraphGetNodeQuadraticNQuadElements(), use SCIPexprGetQuadraticData(), SCIPexprGetQuadraticQuadTerm(), SCIPexprGetQuadraticBilinTerm() instead
- removed SCIPexprgraphGetNodePolynomialMonomials(), SCIPexprgraphGetNodePolynomialNMonomials(), SCIPexprgraphGetNodePolynomialConstant(), SCIPexprgraphGetNodePolynomialMonomialCurvature()
- removed SCIPexprgraphGetNodeUserData(), SCIPexprgraphHasNodeUserEstimator()
- removed SCIPexprgraphGetNodeBounds(), use SCIPexprGetActivity() instead
- removed SCIPexprgraphGetNodeVal(), use SCIPexprGetEvalValue() instead
- removed SCIPexprgraphGetNodeCurvature(), use SCIPexprGetCurvature() instead
- removed SCIPexprgraphCreateNode()
- removed SCIPexprgraphCreateNodeLinear(), use SCIPcreateExprSum() instead
- removed SCIPexprgraphCreateNodeQuadratic(), use SCIPcreateExprQuadratic() instead
- removed SCIPexprgraphCreateNodePolynomial(), SCIPexprgraphNodePolynomialAddMonomials()
- removed SCIPexprgraphCreateNodeUser(), removed SCIPexprgraphNodeSplitOffLinear(), SCIPexprgraphMoveNodeParents()
- removed SCIPexprgraphReleaseNode(), use SCIPreleaseExpr() instead
- removed SCIPexprgraphFreeNode(), use SCIPreleaseExpr() instead
- removed SCIPexprgraphEnableNode(), SCIPexprgraphDisableNode()
- removed SCIPexprgraphHasNodeSibling(), SCIPexprgraphAreAllNodeChildrenVars(), SCIPexprgraphHasNodeNonlinearAncestor()
- removed SCIPexprgraphPrintNode(), SCIPprintExpr() instead
- removed SCIPexprgraphTightenNodeBounds()
- removed SCIPexprgraphUpdateNodeBoundsCurvature(), use SCIPevalExprActivity() and SCIPcomputeExprCurvature() instead
- removed SCIPexprgraphGetDepth(), SCIPexprgraphGetNNodes(), SCIPexprgraphGetNodes(), SCIPexprgraphGetNVars(), SCIPexprgraphGetVars()
- removed SCIPexprgraphGetVarNodes(), SCIPexprgraphSetVarNodeValue(), SCIPexprgraphSetVarsBounds(), SCIPexprgraphSetVarBounds(), SCIPexprgraphSetVarNodeBounds(), SCIPexprgraphSetVarNodeLb(), SCIPexprgraphSetVarNodeUb(), SCIPexprgraphGetVarsBounds()
- removed SCIPexprgraphCreate(), SCIPexprgraphFree()
- removed SCIPexprgraphAddNode(), SCIPexprgraphAddVars(), SCIPexprgraphAddConst(), SCIPexprgraphAddExprtreeSum()
- removed SCIPexprgraphReplaceVarByLinearSum(), SCIPexprgraphFindVarNode(), SCIPexprgraphFindConstNode()
- replaced SCIPexprgraphPrintDot() by SCIPprintExprDotInit[2](), SCIPprintExprDot(), SCIPprintExprDotFinal()
- removed SCIPexprgraphEval(), use SCIPevalExpr() instead
- removed SCIPexprgraphPropagateVarBounds(), SCIPexprgraphPropagateNodeBounds()
- removed SCIPexprgraphCheckCurvature(), use SCIPcomputeExprCurvature() instead
- removed SCIPexprgraphSimplify(), use SCIPsimplifyExpr() instead
- removed SCIPexprgraphGetTree(), SCIPexprgraphGetSeparableTrees(), SCIPexprgraphGetSubtreeVarsUsage(), SCIPexprgraphGetSumTreesNSummands(), SCIPexprgraphGetSumTrees()

Constraint handlers for NLP:
- removed SCIPincludeConshdlrAbspower()
- deprecated SCIPcreateConsAbspower() and SCIPcreateConsBasicAbspower(), use SCIPcreateConsBasicSignpowerNonlinear() instead
- deprecated SCIPgetNlRowAbspower(), use SCIPgetNlRowNonlinear() instead
- removed SCIPgetNonlinearVarAbspower(), SCIPgetLinearVarAbspower(), SCIPgetExponentAbspower(), SCIPgetOffsetAbspower(), SCIPgetCoefLinearAbspower(), SCIPgetLhsAbspower(), SCIPgetRhsAbspower()
- removed SCIPgetViolationAbspower(), use SCIPgetAbsViolationNonlinear() instead
- removed SCIPisConvexAbspower(), use SCIPhasExprCurvature() instead
- removed SCIPincludeConshdlrBivariate(), SCIPcreateConsBivariate(), SCIPcreateConsBasicBivariate()
- removed SCIPgetLinearVarBivariate(), SCIPgetLinearCoefBivariate(), SCIPgetExprtreeBivariate(), SCIPgetLhsBivariate(), SCIPgetRhsBivariate()
- removed SCIPincludeConshdlrQuadratic(), use SCIPincludeNlhdlrQuadratic() instead
- removed SCIPincludeQuadconsUpgrade()
- removed SCIPcreateConsQuadratic2(), SCIPcreateConsBasicQuadratic2()
- deprecated SCIPcreateConsBasicQuadratic(), use SCIPcreateConsBasicQuadraticNonlinear() instead
- deprecated SCIPcreateConsQuadratic(), use SCIPcreateConsQuadraticNonlinear() instead
- deprecated SCIPaddConstantQuadratic(), use SCIPgetLhsNonlinear() and SCIPgetRhsNonlinear() instead
- deprecated SCIPaddLinearVarQuadratic(), use SCIPaddLinearVarNonlinear() instead
- deprecated SCIPaddQuadVarQuadratic(), use SCIPaddLinearVarNonlinear() and SCIPaddExprNonlinear() instead
- deprecated SCIPaddQuadVarLinearCoefQuadratic(), use SCIPaddLinearVarNonlinear() instead
- deprecated SCIPaddSquareCoefQuadratic(), use SCIPaddExprNonlinear() instead
- deprecated SCIPaddBilinTermQuadratic(), use SCIPaddExprNonlinear() instead
- deprecated SCIPchgLhsQuadratic(), use SCIPgetLhsNonlinear() instead
- deprecated SCIPchgRhsQuadratic(), use SCIPgetRhsNonlinear() instead
- deprecated SCIPgetNlRowQuadratic(), use SCIPgetNlRowNonlinear() instead
- removed SCIPgetNLinearVarsQuadratic(), SCIPgetLinearVarsQuadratic(), SCIPgetCoefsLinearVarsQuadratic(), SCIPgetNQuadVarTermsQuadratic(), SCIPgetQuadVarTermsQuadratic(), SCIPsortQuadVarTermsQuadratic(), SCIPfindQuadVarTermQuadratic(), SCIPgetNBilinTermsQuadratic(), SCIPgetBilinTermsQuadratic(), SCIPgetLhsQuadratic(), SCIPgetRhsQuadratic()
- removed SCIPgetLinvarMayDecreaseQuadratic(), SCIPgetLinvarMayIncreaseQuadratic()
- removed SCIPcheckCurvatureQuadratic() and SCIPisConvexConsQuadratic(), use SCIPcomputeExprQuadraticCurvature() instead
- removed SCIPisConvexQuadratic(), SCIPisConcaveQuadratic()
- removed SCIPgetViolationQuadratic() and SCIPgetFeasibilityQuadratic(), use SCIPgetAbsViolationNonlinear() instead
- removed SCIPisLinearLocalQuadratic(), SCIPaddToNlpiProblemQuadratic()
- removed SCIPchgLinearCoefQuadratic(), SCIPchgSquareCoefQuadratic(), SCIPchgBilinCoefQuadratic()
- renamed SCIPgetNAllBilinearTermsQuadratic() to SCIPgetNBilinTermsNonlinear() and changed argument from SCIP* to SCIP_CONSHDLR*
- renamed SCIPgetAllBilinearTermsQuadratic() to SCIPgetBilinTermsNonlinear() and replaced arguments by SCIP_CONSHDLR* and changed return type to SCIP_CONSNONLINEAR_BILINTERM*
- removed SCIPaddBilinearIneqQuadratic(), use SCIPinsertBilinearTermImplicitNonlinear() instead
- renamed SCIPcreateConsQuadratic() to SCIPcreateConsQuadraticNonlinear() and removed argument stickingatnode
- removed SCIPincludeConshdlrSOC()
- replaced SCIPcreateConsBasicSOC() by SCIPcreateConsBasicSOCNonlinear()
- deprecated SCIPcreateConsSOC(), use SCIPcreateConsBasicSOCNonlinear() instead
- deprecated SCIPgetNlRowSOC(), use SCIPgetNlRowNonlinear() instead
- removed SCIPgetNLhsVarsSOC(), SCIPgetLhsVarsSOC(), SCIPgetLhsCoefsSOC(), SCIPgetLhsOffsetsSOC(), SCIPgetLhsConstantSOC(), SCIPgetRhsVarSOC(), SCIPgetRhsCoefSOC(), SCIPgetRhsOffsetSOC(), use SCIPisSOCNonlinear() instead
- removed SCIPaddToNlpiProblemSOC()
- renamed SCIPincludeNonlinconsUpgrade() to SCIPincludeConsUpgradeNonlinear() and removed nodereform argument
- removed arguments nlinvars, linvars, lincoefs, nexprtrees, exprtrees, nonlincoefs, stickingatnode from SCIPcreateConsNonlinear() and added SCIP_EXPR* argument
- removed arguments nlinvars, linvars, lincoefs, nexprtrees, exprtrees, nonlincoefs from SCIPcreateConsBasicNonlinear() and added SCIP_EXPR* argument
- removed SCIPcreateConsNonlinear2(), SCIPcreateConsBasicNonlinear2()
- removed SCIPsetExprtreesNonlinear(), use SCIPchgExprNonlinear() instead
- removed SCIPaddExprtreesNonlinear()
- removed SCIPgetNLinearVarsNonlinear(), SCIPgetLinearVarsNonlinear(), SCIPgetLinearCoefsNonlinear()
- removed SCIPgetNExprtreesNonlinear(), SCIPgetExprtreesNonlinear(), SCIPgetExprtreeCoefsNonlinear(), SCIPgetExprgraphNodeNonlinear(), use SCIPgetExprNonlinear() instead
- removed argument scip from SCIPgetLhsNonlinear() and SCIPgetRhsNonlinear()
- removed SCIPcheckCurvatureNonlinear(), SCIPgetCurvatureNonlinear(), and SCIPgetExprtreeCurvaturesNonlinear(), use SCIPhasExprCurvature() instead
- renamed SCIPgetViolationNonlinear() to SCIPgetAbsViolationNonlinear()
- added arguments var and coef to SCIPgetLinvarMayDecreaseNonlinear() and SCIPgetLinvarMayIncreaseNonlinear() and changed return type to void
- removed SCIPgetExprgraphNonlinear()
- removed SCIPcomputeHyperplaneThreePoints(), use SCIPcomputeFacetVertexPolyhedralNonlinear() instead

### New API functions

- added SCIPallocClearMemory() and SCIPallocClearBlockMemory() to allocate a chunk of (block) memory
  that is initialized to zeros
- New internal functions for changing the default values of parameters:
    SCIPparamsetSetDefaultLongint(), SCIPparamsetSetDefaultReal(), SCIPparamsetSetDefaultChar(),
    SCIPparamsetSetDefaultString() and
    SCIPparamSetDefaultLongint(), SCIPparamSetDefaultReal(), SCIPparamSetDefaultChar(),
    SCIPparamSetDefaultString()
- new internal function SCIPisPackingPartitioningOrbitope() to check whether an orbitope is of
  packing or partitioning type
- new internal function SCIPcomputeOrbitVar() to compute the symmetry orbit of a variable
- added SCIPcalcFibHash(SCIP_Real) to hash a floating-point value to an unsigned integer
- added SCIPcomputeArraysIntersectionPtr() to compute intersection of two sorted arrays of pointers
- new function SCIPinterruptLP() (intended to be called from a different thread) that interrupts ongoing lp solve
- added SCIPcreateConsIndicatorGeneric() and SCIPcreateConsIndicatorGenericLinCons()
  which copy the interface of SCIPcreateConsIndicator() and SCIPcreateConsIndicatorLinCons() and
  add an activeone argument to specify whether the indicator constraint should be activated on 0 or 1.
  SCIPcreateConsIndicator() also adds a lessthanineq flag to choose whether the linear constraint is a less-than or greater-than inequality.
- added SCIPmarkDoNotAggrVar() to mark that a variable should not be aggregated
- added SCIPdoNotAggrVar() to query whether a variable should not be aggregated
- added SCIPdecompGetNBorderVars() and SCIPdecompGetNBorderConss() to get number of border variables/constraints
- added SCIPdecompGetVarsSize() and SCIPdecompGetConssSize() to get variable/constraint size for each block of a decomposition
- added SCIPincludeDialogDefaultBasic()
- added SCIPintervalAreDisjointEps(), SCIPintervalIntersectEps()
- added SCIPintervalEntropy()
- added SCIPintervalPropagateWeightedSum()
- added SCIPcalcRootNewton()
- added SCIPvarGetImplicVarBounds()
- added SCIPcreateRowprep(), SCIPfreeRowprep(), SCIPcopyRowprep(),
  SCIProwprepGetNVars(), SCIProwprepGetVars(), SCIProwprepGetCoefs(), SCIProwprepGetSide(), SCIProwprepGetSidetype(), SCIProwprepIsLocal(), SCIProwprepGetName(), SCIProwprepGetNModifiedVars(), SCIProwprepGetModifiedVars(),
  SCIProwprepReset(), SCIProwprepAddSide(), SCIProwprepAddConstant(), SCIProwprepSetSidetype(), SCIProwprepSetLocal(), SCIProwprepRecordModifications(),
  SCIPprintRowprep(), SCIPprintRowprepSol(), SCIPensureRowprepSize(), SCIPaddRowprepTerm(), SCIPaddRowprepTerms(), SCIPgetRowprepViolation(), SCIPisRowprepViolationReliable(),
  SCIPmergeRowprepTerms(), SCIPcleanupRowprep(), SCIPcleanupRowprep2(), SCIPscaleupRowprep(), SCIPscaleRowprep(),
  SCIPgetRowprepRowConshdlr(), SCIPgetRowprepRowCons(), SCIPgetRowprepRowSepa()
- added SCIPsetClockEnabled()
- added SCIPisSolveInterrupted() to check whether SCIPinterruptSolve() has been called
- added SCIPgetNPresolRounds()
- added SCIPgetNUnfixedLPCols()
- moved SCIPhistoryGetInferenceSum() and SCIPhistoryGetAvgConflictlength() from internal to public API

Expression handler:
- added SCIPincludeExprhdlr(), SCIPgetExprhdlrs(), SCIPgetNExprhdlrs(), SCIPfindExprhdlr()
- added SCIPgetExprhdlrVar(), SCIPgetExprhdlrValue(), SCIPgetExprhdlrSum(), SCIPgetExprhdlrProduct(), SCIPgetExprhdlrPower()
- added SCIPexprhdlrSetCopyFreeHdlr(), SCIPexprhdlrSetCopyFreeData(), SCIPexprhdlrSetPrint(), SCIPexprhdlrSetParse(), SCIPexprhdlrSetCurvature(), SCIPexprhdlrSetMonotonicity(), SCIPexprhdlrSetIntegrality(), SCIPexprhdlrSetHash(), SCIPexprhdlrSetCompare(), SCIPexprhdlrSetDiff(), SCIPexprhdlrSetIntEval(), SCIPexprhdlrSetSimplify(), SCIPexprhdlrSetReverseProp(), SCIPexprhdlrSetEstimate()
- added SCIPexprhdlrGetName(), SCIPexprhdlrGetDescription(), SCIPexprhdlrGetPrecedence(), SCIPexprhdlrGetData(), SCIPexprhdlrHasPrint(), SCIPexprhdlrHasBwdiff(), SCIPexprhdlrHasFwdiff(), SCIPexprhdlrHasIntEval(), SCIPexprhdlrHasEstimate(), SCIPexprhdlrHasInitEstimates(), SCIPexprhdlrHasSimplify(), SCIPexprhdlrHasCurvature(), SCIPexprhdlrHasMonotonicity(), SCIPexprhdlrHasReverseProp()
- added SCIPexprhdlrComp()
- added SCIPexprhdlrGetNIntevalCalls(), SCIPexprhdlrGetIntevalTime(), SCIPexprhdlrGetNReversepropCalls(), SCIPexprhdlrGetReversepropTime(), SCIPexprhdlrGetNCutoffs(), SCIPexprhdlrGetNDomainReductions(), SCIPexprhdlrIncrementNDomainReductions(), SCIPexprhdlrGetNEstimateCalls(), SCIPexprhdlrGetEstimateTime(), SCIPexprhdlrGetNBranchings(), SCIPexprhdlrIncrementNBranchings(), SCIPexprhdlrGetNSimplifyCalls(), SCIPexprhdlrGetSimplifyTime(), SCIPexprhdlrGetNSimplifications()
- added SCIPprintExpressionHandlerStatistics()
- added SCIPincludeExprhdlrEntropy(), SCIPcreateExprEntropy(), SCIPisExprEntropy()
- added SCIPincludeExprhdlrErf(), SCIPcreateExprErf(), SCIPisExprErf()
- added SCIPcreateExprAbs(), SCIPincludeExprhdlrAbs(), SCIPisExprAbs()
- added SCIPcreateExprExp(), SCIPincludeExprhdlrExp(), SCIPisExprExp()
- added SCIPcreateExprLog(), SCIPincludeExprhdlrLog(), SCIPisExprLog()
- added SCIPcreateExprPow(), SCIPcreateExprSignpower(), SCIPincludeExprhdlrPow(), SCIPincludeExprhdlrSignpower(), SCIPisExprSignpower(), SCIPgetExponentExprPow(), SCIPisExprPower()
- added SCIPincludeExprhdlrProduct(), SCIPcreateExprProduct(), SCIPgetCoefExprProduct(), SCIPisExprProduct()
- added SCIPincludeExprhdlrSum(), SCIPcreateExprSum(), SCIPsetConstantExprSum(), SCIPappendExprSumExpr(), SCIPmultiplyByConstantExprSum(), SCIPgetCoefsExprSum(), SCIPgetConstantExprSum(), SCIPisExprSum()
- added SCIPincludeExprhdlrSin(), SCIPcreateExprSin(), SCIPincludeExprhdlrCos(), SCIPcreateExprCos(), SCIPisExprSin(), SCIPisExprCos()
- added SCIPincludeExprhdlrValue(), SCIPcreateExprValue(), SCIPgetValueExprValue(), SCIPisExprValue()
- added SCIPincludeExprhdlrVar(), SCIPcreateExprVar(), SCIPgetVarExprVar(), SCIPisExprVar()
- added SCIPincludeExprhdlrVaridx(), SCIPcreateExprVaridx(), SCIPisExprVaridx(), SCIPgetIndexExprVaridx(), SCIPsetIndexExprVaridx()

Expression:
- added SCIPcaptureExpr(), SCIPreleaseExpr(), SCIPexprGetNUses()
- added SCIPexprGetHdlr(), SCIPexprGetData(), SCIPexprSetData(), SCIPexprGetOwnerData()
- added SCIPevalExpr(), SCIPgetExprNewSoltag(), SCIPexprGetEvalValue(), SCIPexprGetEvalTag()
- added SCIPevalExprGradient(), SCIPevalExprHessianDir(), SCIPexprGetDerivative(), SCIPexprGetDot(), SCIPexprGetBardot(), SCIPexprGetDiffTag()
- added SCIPevalExprActivity(), SCIPexprGetActivity(), SCIPexprGetActivityTag(), SCIPexprSetActivity()
- added SCIPcomputeExprCurvature(), SCIPexprGetCurvature(), SCIPexprSetCurvature()
- added SCIPcomputeExprIntegrality(), SCIPexprIsIntegral(), SCIPexprSetIntegrality()
- added SCIPcheckExprQuadratic(), SCIPfreeExprQuadratic(), SCIPevalExprQuadratic(), SCIPprintExprQuadratic(), SCIPcomputeExprQuadraticCurvature()
- added SCIPexprGetQuadraticData(), SCIPexprGetQuadraticQuadTerm(), SCIPexprGetQuadraticBilinTerm(), SCIPexprAreQuadraticExprsVariables()
- added SCIPcreateExpr(), SCIPcreateExpr2(), SCIPcreateExprQuadratic(), SCIPcreateExprMonomial()
- added SCIPappendExprChild(), SCIPreplaceExprChild(), SCIPremoveExprChildren()
- added SCIPduplicateExpr(), SCIPduplicateExprShallow(), SCIPcopyExpr()
- added SCIPparseExpr()
- added SCIPprintExpr(), SCIPdismantleExpr()
- added SCIPprintExprDotInit(), SCIPprintExprDotInit2(), SCIPprintExprDot(), SCIPprintExprDotFinal(), SCIPshowExpr()
- added SCIPcompareExpr(), SCIPhashExpr()
- added SCIPsimplifyExpr(), SCIPreplaceCommonSubexpressions()
- added SCIPgetExprNVars(), SCIPgetExprVarExprs()
- added SCIPcallExprPrint(), SCIPcallExprCurvature(), SCIPcallExprMonotonicity(), SCIPcallExprEval(), SCIPcallExprEvalFwdiff(), SCIPcallExprInteval(), SCIPcallExprEstimate(), SCIPcallExprInitestimates(), SCIPcallExprSimplify(), SCIPcallExprReverseprop()
- added SCIPexprcurvPowerInv(), SCIPexprcurvMonomialInv()

Expression iterator:
- added SCIPcreateExpriter(), SCIPfreeExpriter()
- added SCIPexpriterIsInit(), SCIPexpriterInit()
- added SCIPexpriterRestartDFS(), SCIPexpriterSetStagesDFS(), SCIPexpriterGetCurrent(), SCIPexpriterGetStageDFS(), SCIPexpriterGetChildIdxDFS(), SCIPexpriterGetChildExprDFS(), SCIPexpriterGetParentDFS()
- added SCIPexpriterGetCurrentUserData(), SCIPexpriterGetChildUserDataDFS(), SCIPexpriterGetExprUserData(), SCIPexpriterSetCurrentUserData(), SCIPexpriterSetExprUserData(), SCIPexpriterSetChildUserData()
- added SCIPexpriterGetNext(), SCIPexpriterSkipDFS(), SCIPexpriterIsEnd()
- added SCIPexprintHessianSparsity(), SCIPexprintHessian()

Constraint handlers for NLP:
- added SCIPgetCurBoundsTagNonlinear(), SCIPgetLastBoundRelaxTagNonlinear(), SCIPincrementCurBoundsTagNonlinear()
- added SCIPgetVarExprHashmapNonlinear()
- added SCIPprocessRowprepNonlinear()
- added SCIPassumeConvexNonlinear()
- added SCIPcollectBilinTermsNonlinear(), SCIPgetBilinTermIdxNonlinear(), SCIPgetBilinTermNonlinear(), SCIPevalBilinAuxExprNonlinear(), SCIPinsertBilinearTermExistingNonlinear(), SCIPinsertBilinearTermImplicitNonlinear()
- added SCIPcomputeFacetVertexPolyhedralNonlinear()
- added SCIPgetExprNonlinear()
- added SCIPcheckQuadraticNonlinear(), SCIPchgLhsNonlinear(), SCIPchgRhsNonlinear(), SCIPchgExprNonlinear(), SCIPaddExprNonlinear()
- added SCIPgetRelViolationNonlinear()
- added SCIPgetExprNLocksPosNonlinear(), SCIPgetExprNLocksNegNonlinear(), SCIPgetExprAuxVarNonlinear(), SCIPgetExprNEnfosNonlinear(), SCIPgetExprEnfoDataNonlinear(), SCIPsetExprEnfoAuxValueNonlinear()
- added SCIPgetExprNPropUsesActivityNonlinear(), SCIPgetExprNSepaUsesActivityNonlinear(), SCIPgetExprNAuxvarUsesNonlinear(), SCIPregisterExprUsageNonlinear()
- added SCIPgetExprAbsOrigViolationNonlinear(), SCIPgetExprAbsAuxViolationNonlinear(), SCIPgetExprRelAuxViolationNonlinear()
- added SCIPgetExprBoundsNonlinear(), SCIPtightenExprIntervalNonlinear(), SCIPmarkExprPropagateNonlinear()
- added SCIPaddExprViolScoreNonlinear(), SCIPaddExprsViolScoreNonlinear(), SCIPgetExprViolScoreNonlinear()
- added SCIPgetExprPartialDiffNonlinear(), SCIPgetExprPartialDiffGradientDirNonlinear()
- added SCIPevalExprQuadraticAuxNonlinear()
- added SCIPincludeNlhdlrNonlinear(), SCIPfindNlhdlrNonlinear(), SCIPgetNNlhdlrsNonlinear(), SCIPgetNlhdlrsNonlinear(), SCIPgetNlhdlrExprDataNonlinear()
- added SCIPcreateConsQuadraticNonlinear() and SCIPcreateConsBasicQuadraticNonlinear() to create a nonlinear constraint that is quadratic
- added SCIPcreateConsBasicSignpowerNonlinear() to create a nonlinear constraint that looks like the former abspower or signpower constraints

Nonlinear Handler:
- added SCIPincludeNlhdlrBilinear(), SCIPgetExprsBilinear(), SCIPgetNExprsBilinear(), SCIPaddIneqBilinear()
- added SCIPincludeNlhdlrConvex(), SCIPincludeNlhdlrConcave(), SCIPhasExprCurvature()
- added SCIPincludeNlhdlrDefault()
- added SCIPincludeNlhdlrPerspective()
- added SCIPincludeNlhdlrQuadratic()
- added SCIPincludeNlhdlrQuotient()
- added SCIPincludeNlhdlrSoc(), SCIPisSOCNonlinear(), SCIPfreeSOCArraysNonlinear()
- added SCIPnlhdlrSetCopyHdlr(), SCIPnlhdlrSetFreeHdlrData(), SCIPnlhdlrSetFreeExprData(), SCIPnlhdlrSetInitExit(), SCIPnlhdlrSetProp(), SCIPnlhdlrSetSepa()
- added SCIPnlhdlrGetName(), SCIPnlhdlrGetDesc(), SCIPnlhdlrGetDetectPriority(), SCIPnlhdlrGetEnfoPriority(), SCIPnlhdlrIsEnabled(), SCIPnlhdlrGetData()
- added SCIPnlhdlrHasIntEval(), SCIPnlhdlrHasReverseProp(), SCIPnlhdlrHasInitSepa(), SCIPnlhdlrHasExitSepa(), SCIPnlhdlrHasEnfo(), SCIPnlhdlrHasEstimate()
- added SCIPnlhdlrComp()

NLPI:
- added SCIPgetNlpiSolverPointer(), SCIPcreateNlpiProblem(), SCIPfreeNlpiProblem(), SCIPgetNlpiProblemPointer(), SCIPaddNlpiVars(), SCIPaddNlpiConstraints(), SCIPsetNlpiObjective(), SCIPchgNlpiVarBounds(), SCIPchgNlpiConsSides(), SCIPdelNlpiVarSet(), SCIPdelNlpiConsSet(), SCIPchgNlpiLinearCoefs(), SCIPchgNlpiExpr(), SCIPchgNlpiObjConstant(), SCIPsetNlpiInitialGuess(), SCIPsolveNlpiParam(), SCIPgetNlpiSolstat(), SCIPgetNlpiTermstat(), SCIPgetNlpiSolution(), SCIPgetNlpiStatistics()
- added SCIPincludeNlpSolverAll()
- added SCIPincludeNlpSolverFilterSQP(), SCIPgetSolverNameFilterSQP(), SCIPgetSolverDescFilterSQP(), SCIPisFilterSQPAvailableFilterSQP()
- added SCIPincludeNlpSolverIpopt()
- added SCIPincludeNlpSolverWorhp()
- added SCIPnlpiOracleChgExpr()
- added SCIPcreateNlpiProblemFromNlRows()
- added SCIPnlpiOracleGetObjectiveConstant()
- added SCIPnlpiOracleIsVarNonlinear(), SCIPnlpiOracleGetVarCounts(), SCIPnlpiOracleIsConstraintNonlinear()
- added SCIPnlpiGetNProblems(), SCIPnlpiGetProblemTime(), SCIPnlpiGetNSolves(), SCIPnlpiGetSolveTime(), SCIPnlpiGetEvalTime(), SCIPnlpiGetNIterations(), SCIPnlpiGetNTermStat(), SCIPnlpiGetNSolStat(), SCIPnlpiMergeStatistics()
- added SCIPmergeNLPIStatistics(), SCIPprintNLPIStatistics()
- added SCIPnlpiOracleResetEvalTime(), SCIPnlpiOracleGetEvalTime()
- added SCIPaddNlpiProblemNlRows()

Cut Selector:
- added SCIPincludeCutsel(), SCIPincludeCutselBasic(), SCIPsetCutselCopy(), SCIPsetCutselFree(), SCIPsetCutselInit(), SCIPsetCutselExit(),  SCIPsetCutselInitsol(), SCIPsetCutselExitsol(), SCIPfindCutsel(), SCIPgetCutsels(), SCIPgetNCutsels(), SCIPsetCutselPriority()
- added SCIPcutselGetName(), SCIPcutselGetData(), SCIPcutselGetDesc(), SCIPcutselGetPriority(), SCIPcutselSetData(), SCIPcutselIsInitialized(), SCIPcutselGetSetupTime(), SCIPcutselGetTime()

### Command line interface
### Interfaces to external software

- removed GAMS interface (originally in interfaces/gams) and reading capability of gms reader;
  the removed interface was a poorly maintained copy of the GAMS/SCIP interface that is available at
  https://github.com/coin-or/GAMSlinks
- integrated AMPL interface into main SCIP executable, that is, added possibility to use SCIP executable as solver in AMPL
  (AMPL calls solver with name of .nl file and -AMPL as arguments; SCIP will then attempt to solve the problem and write an AMPL solution file)
- the ZIMPL interface has been updated to support ZIMPL 3.4.1;
  the minimal required ZIMPL version is now 3.4.1

### Changed parameters

- Extended range of parameter "misc/usesymmetry" from [0,3] to [0,7], changed default from 3 to 5
- deleted parameter "constraints/orbitope/usedynamicprop"
- changed type of parameter "propagating/symmetry/recomputerestart" from SCIP_Bool to int with range [0,2]
- deleted parameter "propagating/symmetry/disableofrestart"
- parameter "heuristics/padm/original" is now an advanced parameter
- removed constraints/nonlinear/linfeasshift, constraints/nonlinear/reformulate, constraints/nonlinear/maxexpansionexponent, constraints/nonlinear/sepanlpmincont
- removed constraints/nonlinear/upgrade/abspower
- removed constraints/nonlinear/upgrade/and, use constraints/nonlinear/reformbinprodsand instead
- removed constraints/nonlinear/upgrade/bivariate
- removed constraints/nonlinear/upgrade/quadratic, use nlhdlr/quadratic/enabled instead
- changed default of constraints/nonlinear/maxproprounds from 1 to 10
- replaced constraints/nonlinear/enfocutsremovable by constraints/nonlinear/rownotremovable
- replaced constraints/nonlinear/cutmaxrange by separating/maxcoefratiofacrowprep
- removed constraints/quadratic/sepafreq, constraints/quadratic/propfreq, constraints/quadratic/proptiming, constraints/quadratic/eagerfreq, constraints/quadratic/maxprerounds, constraints/quadratic/delaysepa, constraints/quadratic/delayprop, constraints/quadratic/presoltiming
- removed constraints/quadratic/replacebinaryprod, use constraints/nonlinear/reformbinprodsfac instead
- removed constraints/quadratic/empathy4and, use constraints/nonlinear/reformbinprodsand instead
- removed constraints/quadratic/binreforminitial, constraints/quadratic/binreformbinaryonly, constraints/quadratic/binreformmaxcoef
- removed constraints/quadratic/cutmaxrange, constraints/quadratic/mincurvcollectbilinterms, constraints/quadratic/linearizeheursol, constraints/quadratic/checkcurvature, constraints/quadratic/checkfactorable, constraints/quadratic/checkquadvarlocks, constraints/quadratic/linfeasshift
- removed constraints/quadratic/maxdisaggrsize, constraints/quadratic/disaggrmergemethod, constraints/quadratic/maxproprounds, constraints/quadratic/maxproproundspresolve, constraints/quadratic/enfolplimit, constraints/quadratic/sepanlpmincont, constraints/quadratic/enfocutsremovable
- removed constraints/quadratic/gaugecuts, constraints/quadratic/interiorcomputation, constraints/quadratic/projectedcuts, constraints/quadratic/branchscoring, constraints/quadratic/usebilinineqbranch, constraints/quadratic/bilinineqmaxseparounds,
- removed constraints/quadratic/minscorebilinterms, use nlhdlr/bilinear/enabled instead
- removed constraints/quadratic/upgrade/linear, constraints/quadratic/upgrade/abspower, constraints/quadratic/upgrade/bivariate, constraints/quadratic/upgrade/bounddisjunction
- removed constraints/quadratic/upgrade/soc, use nlhdlr/soc/enabled instead
- renamed constraints/quadratic/upgrade/setppc to constraints/nonlinear/upgrade/setppc
- removed constraints/abspower/sepafreq, constraints/abspower/propfreq, constraints/abspower/proptiming, constraints/abspower/eagerfreq, constraints/abspower/maxprerounds, constraints/abspower/delaysepa, constraints/abspower/delayprop, constraints/abspower/presoltiming
- removed constraints/abspower/cutmaxrange, constraints/abspower/projectrefpoint, constraints/abspower/preferzerobranch, constraints/abspower/branchminconverror, constraints/abspower/addvarboundcons, constraints/abspower/linfeasshift, constraints/abspower/dualpresolve, constraints/abspower/sepainboundsonly, constraints/abspower/sepanlpmincont, constraints/abspower/enfocutsremovable
- removed constraints/bivariate/sepafreq, constraints/bivariate/propfreq, constraints/bivariate/proptiming, constraints/bivariate/eagerfreq, constraints/bivariate/maxprerounds, constraints/bivariate/delaysepa, constraints/bivariate/delayprop, constraints/bivariate/presoltiming
- removed constraints/bivariate/cutmaxrange, constraints/bivariate/linfeasshift, constraints/bivariate/maxproprounds, constraints/bivariate/ninitlprefpoints, constraints/bivariate/enfocutsremovable
- removed constraints/soc/sepafreq, constraints/soc/propfreq, constraints/soc/proptiming, constraints/soc/eagerfreq, constraints/soc/maxprerounds, constraints/soc/delaysepa, constraints/soc/delayprop, constraints/soc/presoltiming
- removed constraints/soc/projectpoint, constraints/soc/nauxvars, constraints/soc/glineur, constraints/soc/sparsify, constraints/soc/sparsifymaxloss, constraints/soc/sparsifynzgrowth, constraints/soc/linfeasshift, constraints/soc/nlpform, constraints/soc/sepanlpmincont, constraints/soc/enfocutsremovable, constraints/soc/disaggregate
- removed constraints/soc/generalsocupgrade, use nlhdlr/soc/compeigenvalues instead
- changed default of presolving/qpkktref/maxrounds from -1 to 0
- changed default of propagating/obbt/onlynonconvexvars from FALSE to TRUE
- changed default of heuristics/subnlp/resolvetolfactor from 0.001 to 1.0
- removed heuristics/subnlp/nlpoptfile, use nlpi/ipopt/optfile instead
- removed separating/convexproj/nlptimelimit
- removed separating/gauge/nlptimelimit
- removed heuristics/subnlp/nlptimelimit and heuristics/subnlp/nlpiterlimit
- removed heuristics/subnlp/resolvetolfactor and heuristics/subnlp/resolvefromscratch
- changed default of heuristics/subnlp/itermin to 20
- renamed heuristics/subnlp/iteroffset to heuristics/subnlp/nodesoffset
- renamed heuristics/subnlp/iterquotient to heuristics/subnlp/nodesfactor
- removed heuristics/subnlp/runalways, use heuristics/subnlp/nodesoffset=INT_MAX and heuristics/subnlp/successrateexp = 0.0 instead
- removed heuristics/subnlp/minimprove, heuristics/multistart/nlpminimpr
- Removed parameters for strongcg separator: separating/strongcg/..., i.e.,
  maxrounds, maxroundsroot, maxsepacutsroot, maxsepacuts, dynamiccuts. One can control the
  strongcg behavior throught the parameters of sepa_gomory.
- renamed separating/{minortho,minorthoroot,objparalfac,intsupportfac} to cutselection/hybrid/{minortho,minorthoroot,objparalweight,intsupportweight}

### New parameters

- It is now possible to add orbitope constraints to handle symmetries even if not all variables
  in a component of the symmetry group are binary. This feature can be enabled using the
  parameter "propagating/symmetry/onlybinorbitope".

- new parameter "propagating/symmetry/sstleaderrule" to select a rule for selecting the
  leader in SST cuts
- new parameter "propagating/symmetry/ssttiebreakrule" to select a tiebreak rule for selecting the
  leader in SST cuts
- new parameter "propagating/symmetry/sstleadervartype" to select the possible variable types
  for a leader in SST cuts
- new parameter "propagating/symmetry/addconflictcuts" to control whether SST cuts are added if
  a binary leader variable is in conflict with a variable in its orbit
- new parameter "propagating/symmetry/sstaddcuts" to control whether SST cuts are added
- new parameter "propagating/symmetry/sstmixedcomponents" to control whether SST cuts are added
  if a symmetry component contains variables of different types
- new parameter "propagating/symmetry/detectsubgroups" to search for orbitopes defined by subgroups
- new parameter "propagating/symmetry/addweaksbcs" to add Schreier Sims cuts for a single
  variable orbit in case an orbitope subgroup is detected
- new parameter "propagating/symmetry/addstrongsbcs" to add symretope facets for a single
  variable orbit on which the symmetry group acts like a symmetric group
- new parameter "propagating/symmetry/maxnconsssubgroup" to control up to which number of
  constraints subgroups are detected
- new parameter "propagating/symmetry/preferlessrows" to control whether orbitopes with
  smallest number of rows shall be computed by the subgroup detection heuristic
- new parameter "propagating/symmetry/usedynamicprop" to control if rows of full orbitope
  shall be ordered dynamically in propagation
- new parameter "separating/filtercutpoolrel" to control whether cutpool uses
  a dynamic strategy to separate only cuts with high relative efficacy
- if run from AMPL: display/statistics to enable printing detailed solve statistics after solve
- if run from AMPL: display/logfile to specify name of file to write SCIP log to (additionally to writing to stdout)
- constraints/nonlinear/propauxvars, constraints/nonlinear/varboundrelax, constraints/nonlinear/varboundrelaxamount, constraints/nonlinear/conssiderelaxamount
- constraints/nonlinear/vpmaxperturb, constraints/nonlinear/vpadjfacetthresh, constraints/nonlinear/vpdualsimplex
- constraints/nonlinear/bilinmaxnauxexprs, constraints/nonlinear/forbidmultaggrnlvar, constraints/nonlinear/checkvarlocks, constraints/nonlinear/violscale
- constraints/nonlinear/reformbinprods, constraints/nonlinear/reformbinprodsand, constraints/nonlinear/reformbinprodsfac
- constraints/nonlinear/tightenlpfeastol, constraints/nonlinear/propinenforce, constraints/nonlinear/weakcutthreshold, constraints/nonlinear/strongcutmaxcoef, constraints/nonlinear/strongcutefficacy, constraints/nonlinear/forcestrongcut, constraints/nonlinear/enfoauxviolfactor, constraints/nonlinear/weakcutminviolfactor
- constraints/nonlinear/branching/aux, constraints/nonlinear/branching/external, constraints/nonlinear/branching/highviolfactor, constraints/nonlinear/branching/highscorefactor, constraints/nonlinear/branching/violweight, constraints/nonlinear/branching/dualweight, constraints/nonlinear/branching/pscostweight, constraints/nonlinear/branching/domainweight, constraints/nonlinear/branching/vartypeweight, constraints/nonlinear/branching/scoreagg, constraints/nonlinear/branching/violsplit, constraints/nonlinear/branching/pscostreliable
- constraints/nonlinear/linearizeheursol
- nlhdlr/default/enabled
- nlhdlr/convex/enabled, nlhdlr/convex/detectsum, nlhdlr/convex/extendedform, nlhdlr/convex/cvxquadratic, nlhdlr/convex/cvxsignomial, nlhdlr/convex/cvxprodcomp, nlhdlr/convex/handletrivial
- nlhdlr/concave/enabled, nlhdlr/concave/detectsum, nlhdlr/concave/cvxquadratic, nlhdlr/concave/cvxsignomial, nlhdlr/concave/cvxprodcomp, nlhdlr/concave/handletrivial
- nlhdlr/bilinear/enabled, nlhdlr/bilinear/useinteval, nlhdlr/bilinear/usereverseprop, nlhdlr/bilinear/maxseparoundsroot, nlhdlr/bilinear/maxseparounds, nlhdlr/bilinear/maxsepadepth
- nlhdlr/perspective/enabled, nlhdlr/perspective/maxproprounds, nlhdlr/perspective/mindomreduction, nlhdlr/perspective/minviolprobing, nlhdlr/perspective/probingonlyinsepa, nlhdlr/perspective/probingfreq, nlhdlr/perspective/convexonly, nlhdlr/perspective/tightenbounds, nlhdlr/perspective/adjrefpoint
- nlhdlr/quadratic/enabled, nlhdlr/quadratic/useintersectioncuts, nlhdlr/quadratic/usestrengthening, nlhdlr/quadratic/useboundsasrays, nlhdlr/quadratic/ncutslimit, nlhdlr/quadratic/ncutslimitroot, nlhdlr/quadratic/maxrank, nlhdlr/quadratic/mincutviolation, nlhdlr/quadratic/minviolation, nlhdlr/quadratic/atwhichnodes, nlhdlr/quadratic/nstrengthlimit, nlhdlr/quadratic/ignorebadrayrestriction, nlhdlr/quadratic/ignorehighre
- nlhdlr/quotient/enabled
- nlhdlr/soc/enabled, nlhdlr/soc/mincutefficacy, nlhdlr/soc/compeigenvalues
- propagating/obbt/createlincons
- propagating/symmetry/onlybinarysymmetry
- separating/minor/priority, separating/minor/freq, separating/minor/maxbounddist, separating/minor/delay, separating/minor/expbackoff, separating/minor/maxminorsconst, separating/minor/maxminorsfac, separating/minor/mincutviol, separating/minor/maxrounds, separating/minor/maxroundsroot, separating/minor/ignorepackingconss
- separating/rlt/priority, separating/rlt/freq, separating/rlt/maxbounddist, separating/rlt/delay, separating/rlt/expbackoff, separating/rlt/maxncuts, separating/rlt/maxunknownterms, separating/rlt/maxusedvars, separating/rlt/maxrounds, separating/rlt/maxroundsroot, separating/rlt/onlyeqrows, separating/rlt/onlycontrows, separating/rlt/onlyoriginal, separating/rlt/useinsubscip, separating/rlt/useprojection, separating/rlt/detecthidden, separating/rlt/hiddenrlt, separating/rlt/addtopool, separating/rlt/goodscore, separating/rlt/badscore, separating/rlt/objparalweight, separating/rlt/efficacyweight, separating/rlt/dircutoffdistweight, separating/rlt/goodmaxparall, separating/rlt/maxparall
- separating/interminor/usestrengthening, separating/interminor/usebounds, separating/interminor/mincutviol, separating/interminor/maxrounds, separating/interminor/maxroundsroot
- table/cons_nonlinear/active, table/nlhdlr/active, table/exprhdlr/active, table/nlpi/active, table/nlhdlr_bilinear/active, table/nlhdlr_quadratic/active
- expr/log/minzerodistance, expr/pow/minzerodistance
- benders/default/maxslackvarcoef to specify maximal coefficient for slack variables; if exceeded, slack variables are fixed to zero
- nlpi/ipopt/optfile to specify name of Ipopt options file to use for every solve with Ipopt
- nlpi/ipopt/print_level, nlpi/ipopt/hsllib, nlpi/ipopt/pardisolib, nlpi/ipopt/linear_solver, nlpi/ipopt/linear_system_scaling, nlpi/ipopt/nlp_scaling_method, nlpi/ipopt/mu_strategy, nlpi/ipopt/hessian_approximation
- nlpi/ipopt/warm_start_push
- timing/nlpieval
- heuristics/subnlp/iterinit, heuristics/subnlp/ninitsolves, heuristics/subnlp/successrateexp
- heuristics/subnlp/expectinfeas, heuristics/subnlp/opttol, heuristics/subnlp/feastolfactor
- heuristics/subnlp/presolveemphasis, heuristics/subnlp/setcutoff
- new parameters "branching/inference/conflictprio" and "branching/inference/cutoffprio" that allow
  using the different score criteria in inference branching hierarchically
- new parameters "heuristics/alns/nodesquotmin", "heuristics/alns/maxcallssamesol" and "heuristics/alns/initduringroot"
  to control neighborhoods in ALNS
- new parameter "benders/default/benderscut/optimality/mir" to control whether mixed-integer rounding procedure is applied to Benders optimality cuts
- new parameter "misc/avoidmemout" to try to avoid running into memory limit
- cutselection/hybrid/dircutoffdistweight, cutselection/hybrid/efficacyweight, cutselection/hybrid/intsupportweight, cutselection/hybrid/objparalweight, cutselection/hybrid/priority
- new parameter "decomposition/disablemeasures" to disable expensive measures in SCIPcomputeDecompStats()
- new parameter "presolving/milp/probfilename" filename to write the problem to a file before MILP presolving starts

### Data structures

- removed quadratic terms from NLROWs
- removed SCIP_NLPPAR_INFINITY from SCIP_NLPPARAM enum
- added types SYM_OPTYPE, SYM_CONSTTYPE, SYM_RHSTYPE, SYM_EXPRDATA
- removed class SCIPInterval
- removed enum SCIP_EXPROP
- removed union SCIP_EXPROPDATA, added SCIP_EXPRDATA
- removed struct SCIP_EXPRTREE, use SCIP_EXPR instead
- removed structs SCIP_QUADELEM, SCIP_EXPRDATA_QUADRATIC, SCIP_EXPRDATA_MONOMIAL, SCIP_EXPRDATA_POLYNOMIAL, SCIP_EXPRDATA_USER
- removed structs SCIP_EXPRGRAPHNODE, SCIP_EXPRGRAPH
- removed type SCIP_EXPRBOUNDSTATUS
- removed struct SCIP_USEREXPRDATA
- added enum SCIP_MONOTONE
- added structs SCIP_EXPRHDLR, SCIP_EXPRHDLRDATA
- added union SCIP_EXPRITER_USERDATA
- added enum SCIP_EXPRITER_TYPE
- added structs SCIP_EXPRITERDATA, SCIP_EXPRITER
- added type SCIP_EXPRPRINT_WHAT, struct SCIP_EXPRPRINTDATA
- removed enum SCIP_BIVAR_CONVEXITY
- removed structs SCIP_QUADVAREVENTDATA, SCIP_QUADVARTERM, SCIP_BILINTERM
- added structs SCIP_CONSNONLINEAR_AUXEXPR, SCIP_CONSNONLINEAR_BILINTERM
- added type SCIP_NLHDLR_METHOD
- added structs SCIP_NLHDLR, SCIP_NLHDLRDATA, SCIP_NLHDLREXPRDATA
- enum SCIP_NLPPARAM has been changed to a struct that holds values of parameters for an NLP solve
- removed SCIP_NLPPAR_OPTFILE/optfile from SCIP_NLPPARAM
- added SCIP_NLPTERMSTAT_INTERRUPT to SCIP_NLPTERMSTAT enum; returned from NLP solver if SCIPinterruptSolve() has been called
- renamed SCIP_NLPTERMSTAT_TILIM to SCIP_NLPTERMSTAT_TIMELIMIT
- renamed SCIP_NLPTERMSTAT_ITLIM to SCIP_NLPTERMSTAT_ITERLIMIT
- renamed SCIP_NLPTERMSTAT_LOBJLIM to SCIP_NLPTERMSTAT_LOBJLIMIT
- renamed SCIP_NLPTERMSTAT_NUMERR to SCIP_NLPTERMSTAT_NUMERICERROR
- renamed SCIP_NLPTERMSTAT_EVALERR to SCIP_NLPTERMSTAT_EVALERROR
- renamed SCIP_NLPTERMSTAT_MEMERR to SCIP_NLPTERMSTAT_OUTOFMEMORY
- renamed SCIP_NLPTERMSTAT_LICERR to SCIP_NLPTERMSTAT_LICENSEERROR
- added evaltime to SCIP_NLPSTATISTICS
- added structs SCIP_CUTSEL, SCIP_CUTSELDATA

Deleted files
-------------

- interfaces/gams/*
- interfaces/ampl/*
- src/nlpi/*
- src/scip/cons_bivariate.{c,h}
- src/scip/pub_misc_nonlinear.h
- src/scip/misc_nonlinear.c
- src/scip/scip_nonlinear.{c,h}
- src/scip/sepa_strongcg.{h|c}

Unit tests
----------

- added cons/linear/nonlinupgd.c
- added cons/nonlinear/addcons.c
- added cons/nonlinear/bilinhash.c
- added cons/nonlinear/check.c
- added cons/nonlinear/copy.c
- added cons/nonlinear/create_nlrow.c
- added cons/nonlinear/curvature.c
- added cons/nonlinear/glbconss.c
- added cons/nonlinear/hessian.c
- added cons/nonlinear/locks.c
- added cons/nonlinear/nlhdlr.c
- added cons/nonlinear/nlhdlr_bilinear.c
- added cons/nonlinear/nlhdlr_concave.c
- added cons/nonlinear/nlhdlr_convex.c
- added cons/nonlinear/nlhdlr_perspective.c
- added cons/nonlinear/nlhdlr_quadratic.c
- added cons/nonlinear/nlhdlr_quotient.c
- added cons/nonlinear/nlhdlr_soc.c
- added cons/nonlinear/parse.c
- added cons/nonlinear/presolve.c
- added cons/nonlinear/propagate.c
- added cons/nonlinear/readers.c
- added cons/nonlinear/reformbinprods.c
- added cons/nonlinear/repair.c
- added cons/nonlinear/transform.c
- added cons/nonlinear/vertexpolyhedral.c
- removed cons/nonlinear/getCoeffsAndConstantFromLinearExpr.c
- removed cons/soc/upgrade.c
- added expr/abs/estimation.c
- added expr/commonsubexprs.c
- added expr/compare.c
- added expr/copy.c
- added expr/cos/cos.c
- added expr/cos/estimation.c
- added expr/curvature.c
- added expr/derivative.c
- added expr/entropy/entropy.c
- added expr/entropy/estimation.c
- added expr/eval.c
- added expr/exp/estimation.c
- added expr/free.c
- added expr/getvarexprs.c
- added expr/hash.c
- added expr/hessian.c
- added expr/integrality.c
- added expr/iterator.c
- added expr/log/estimation.c
- added expr/monotonicity.c
- added expr/parse.c
- added expr/pow/estimation.c
- added expr/pow/pow.c
- added expr/product/estimation.c
- added expr/quad.c
- added expr/simplify.c
- added expr/sin/estimation.c
- added expr/sin/sin.c
- added expr/sum/estimation.c
- added nlpi/exprinterpret.c
- speedup test nlpi:solveQP in nlpi/nlpi.c
- added test projection:transitivity in prob/obbt.c
- added reader/nl.c
- added test intervalarith:sincos in scip/intervalarith.c
- added sepa/minor.c
- added sepa/rlt/cuts.c
- added sepa/rlt/product_detection.c
- added sepa/rlt/separation.c
- added tests test_compute_symmetry:expr{1,2,3,4} in symmetry/compute.c

Build system
------------

- the separate NLPI library has been integrated into the main SCIP library;
  uses of NLPILIBFILE or NLPILIBSRC in Makefiles that use make/make.project
  should be removed

### Cmake

- replace flag PARASCIP by THREADSAFE
- option AMPL is now ON by default
- add -D_XOPEN_SOURCE=600 cflag for compilation on systems other than windows
- add compile options directly instead of modifying CMAKE_C_FLAGS and CMAKE_CXX_FLAGS

### Makefile

- prefix PKG_CONFIG_PATH with Ipopt's pkgconfig dir instead of postfixing
- replace flag PARASCIP by THREADSAFE
- flag AMPL is now true by default
- libscip has been renamed to libscipbase and libscipsolver has been renamed to libscip
  in order to have the same library names for makefiles and cmake. For downward
  compatibility libscipsolver still exists (as a link).

Fixed bugs
----------

- fixed handling of multi-aggregation in cons_symresack and cons_orbisack
- SCIPgetLowerbound() now consistently returns infinity when status is infeasible
- improved the likelihood that a solution that satisfies the nonlinear constraints in the transformed (presolved) problem is also feasible for the original problem
- worked around a problem with derivatives of pow at 0 with non-integer exponents in CppAD
- fixed that setting of feasiblity and optimiality tolerance for NLP relaxation was overwritten with defaults when solving NLP
- fixed variance computation in t-value computation in hypothesis testing of reliability branching
- fixed potential overflow in cuts.c:evaluateLiftingFunctionKnapsack()
- do not transfer dual reductions to main SCIP in sepa_rapidlearning if strong dual reductions are forbidden
- fixed a bug in cons_setppc.c:removeDoubleAndSingletonsAndPerformDualpresolve() which led to wrong variable aggregations
- added missing redundancy check to coefficient tightening routine in cons_varbound that led to wrong variable locks
- added a check of numerics to avoid wrong reductions in cons_linear.c:simplifyInequalities()
- fixed a bug in cons_logicor.c regarding fixed variables that were not removed
- presol_milp.c handles variable fixings, suggested by PaPILO, more carefully to cover all cases that can appear
- fixed several reproducability bugs that led to different solving paths across multiple runs with one SCIP environment
- fixed check of limits/absgap, which was incorrectly applied to the scaled objective of the transformed problem

Miscellaneous
-------------

- in LP, use absolute instead of relative tolerances to check whether solutions from LP solver are primal feasible
- when a restart occurs, SCIP now asserts (during EXITSOLVE) that all relaxation-only variables are unlocked and
  only captured by the transformed problem.
- Avoid redundant calls to LP solver when LP is already flushed and solved
- In SCIPdebugMsg(), SCIPsetDebugMsg(), SCIPstatDebugMsg() strip directory from filename.
- Recompute activity of rows when checking LP solutions instead of trusting the value given by the LP solver
- The define NPARASCIP has been replaced by SCIP_THREADSAFE
- Parameters are not reset to their default values before activating an emphasis setting; this now allows to combine
  different emphasis settings.
- If a lazy bound is set to a value that is tighter than the current global bound, then the global bound is now tightened accordingly.

@page RN7 Release notes for SCIP 7

@section RN703 SCIP 7.0.3
*************************

Interface changes
-----------------

### New API functions

- added function SCIPwithDebugSol() to determine whether SCIP was compiled with WITH_DEBUG_SOLUTION

- New function SCIPcreateConsBounddisjunctionRedundant() and SCIPcreateConsBasicBounddisjunctionRedundant() that allow
  the input to contain redundant literals.

### Changed API functions

- added __attribute__((format(printf,,,))) to variadic SCIP message printing functions;
  this enables warnings about mismatches between format string and variadic function arguments if using GCC.

### Interfaces to external software

- removed MATLAB interface from interfaces/matlab

Build system
------------

- Compilation will now also work in a raw tarball of the scip git repository

### Cmake

- Make find_package more verbose and require packages to be found. Now enabled packages that are not found result in an error.

Fixed bugs
----------

- Fixed numerical bug by creating and checking the empty solution when problem vanishes in presolving.
- Fixed several bugs in reoptimization.
- Fixed bug in cons_bounddisjunction in which a constraint leads to a cutoff.
- Fixed bug in reoptimization by avoiding redundant literals for bound disjunctions.
- Replace wrong usage of CMAKE_BINARY_DIR by PROJECT_BINARY_DIR in CMake system
- Fixed lpi_glop to use absl flag instead of GFlags
- Fixed invalid initialization of limits/softtime parameter in cons_components
- Fixed MIN macro not defined in some cases.
- Safeguard some API functions for querying solving statistics against segmentation faults after SCIPpresolve()
- Fixed unfreed solution in concurrent solving
- Make sure that logicor constraints are enforced/separated if genlogicor is true in cons_indicator.
  Thus, do not change constraints/logicor/sepafreq anymore, but output warning.
- Fixed assert that assumed infeasibility cannot occur in presol_boundshift.
- Fixed sign bug during creation of conflict constraints with almost zero left-hand side.
- Disabled call of conflict handler for conflict sets that contain relaxation-only variables.
- Fixed bug in cons_symresack by initializing all constraint data in constrans
- Avoid allowing the upgrade of linear constraints corresponding to indicators in propagation of nodes.
- Fixed bug in computing lex. min/max faces in dynamic orbitope propagation.
- Limit vbounds propagator to one sweep through all bounds per call in order to avoid an infinite loop.
- Fixed mismatches between formatter strings and arguments in calls to SCIP message printing functions.

Miscellaneous
-------------

- To avoid performance variablity during reoptimization, the active constraints are now stored in the same order as in the
  original problem.
- Added workaround for bug in MSVS 2019 when compiling CppAD source.
- The original order of variables is now only restored after presolve if `randomization/permutevars` is set to FALSE.

@section RN702 SCIP 7.0.2
*************************

Features
--------

- Extended check for valid variable and constraint names in PIP writer.
- Indicator constraints now write the name of the linear constraint in CIP format. This avoids a complicated
  name matching during parsing. The old format is still supported.
- The objective scale and offset are now taken into account when reading/writing problems in lp/mps/fzn/pip format.
  This often changes the behavior when writing transformed problems.

Performance improvements
------------------------

Examples and applications
-------------------------

- Add c++ Sudoku example

Interface changes
-----------------

### Deleted and changed API functions

- deprecated SCIPsetParam(); use SCIPsetIntParam(), SCIPsetRealParam(), etc, instead

### New API functions

- new function SCIPcolGetVarProbindex() for accessing the probindex of a variable corresponding to a column
- added new sorting functions SCIPsortPtrRealRealBoolBool()

Fixed bugs
----------

- Fixed a sign bug occuring for some cases in the computation of the directed cutoff distance
- Fixed overflow in inference information of cumulative constraint handler
- Fixed problem with propfreq == 0 in cons_linear.c
- Fixed aggregation heuristic in sepa_aggregation.c to not use local rows when that is requested nor modifiable rows
- Fixed problem with incompatibility of symmetry handling in Benders decomposition
- Fixed parsing of small number in CIP format of nonlinear constraint
- Fixed problem in upgrading full orbitopes to partitioning orbitopes
- Fixed treatment of negated variables in parsing orbitope constraints
- Fixed potential indexing error in prop_vbounds.c
- Fixed bug in writing fzn format
- Revert to old parameter value when parameter change is rejected in PARAMCHGD callback
- Fixed order of linker flags when building AMPL interface with cmake system.
- Fixed bug with ofsymcomptiming == 0: now symmetry is actually computed
- Improved separation for SOC constraint with multiaggregated variable on right-hand-side.
- Fixed bug in presol_boundshift: do not shift non-active variables
- Fixed bug in domain propagation for SOC constraints with negative coefficient for variable on right-hand-side.
- Fixed bug with multi-aggregated integer variables in cons_xor.
- Fixed bug with changed number of variables in storing relaxation solution in probing/diving.
- Fixed issues with scip statistics
- Fixed issue with multi-aggregated variables
- Fixed issue in with buffer memory in cons_cumulative

@section RN701 SCIP 7.0.1
*************************

Build system
------------

### Cmake

- Fixed cmake module for Ipopt to support Ipopt 3.13
- Added cmake variable BLISS_LIBRARY_DIR to pass a bliss library
- Added warning to require minimal GCC version 4.8
- Renamed FindCriterion cmake findmodule to FindCRITERION

### Makefile

- Updated make/make.project for macOS
- Add SANITZERFLAGS (only OPT=dbg) to LDFLAGS also if SHARED=true (and rename SANITZERFLAGS to SANITIZERFLAGS)
- Fixed GCC version check in make/make.linux.gnu.dbg

Fixed bugs
----------

- Fixed handling of constant term in quadratic objective of pip-reader
- Fixed incorrect value string for parameter estimation/completiontype
- Fixed initialization of first LP which led to wrong output about LPs not resolved correctly
- Fixed bug in SCIPcutpoolClear() function not clearing internal datastructures properly
- Fixed inability to set a value in a solution if it was within epsilon to the current value
- Fixed problems for linking optimized code with debug library of SCIP (and vice versa) by moving debug-only members
  to end of SCIP structs

Miscellaneous
-------------

- Variables that are marked as relaxation-only are no longer checked against debug solutions if
  they are captured by the transformed problem only.

@section RN700 SCIP 7.0.0
*************************

Features
--------

- Using the parameter "propagating/symmetry/recomputerestart" one can now decide to recompute symmetries after a
  restart or not. Previously one could just turn off symmetry computation after a restart. If orbital fixing
  has found a reduction before the restart occured, symmetries have to be updated to ensure correctness.
  To this end, the user can decide via "propagating/symmetry/disableofrestart" whether orbital fixing is disabled or
   whether symmetries are recomputed.

- extended relaxators statistics in solve statistics about information on number of cutoffs, improved bounds, etc.

- extends SMPS file reader for the stochastic information, the sto files, to read a lower bound for the discrete
  scenarios. The lower bound is used when creating the auxiliary variables for Benders' decomposition.

- extended Benders framework to solve NLPs and generate optimality and feasibility cuts from their solution
  when the subproblem is convex nonlinear.

- extended Benders framework to create copies of Benders decompositions that can be used in a multithreading environment

- additional functionality has been added to enable the transfer of Benders' decomposition cuts between different SCIP
  instances, e.g., when used in UG

- LP rows (SCIP_ROW) can now store pointer to a constraint from which the row originates

- Trust region, a new LNS heuristic, has been added to SCIP as both a standalone primal heuristic heur_trustregion.c
  and as a neighborhood inside of Adaptive Large Neighborhood Search (heur_alns.c). This heuristic is designed to improve the
  heuristic performance of the Benders' decomposition algorithm. It builds upon the successful trust region approaches
  applied to Benders' decomposition.

- Modularity of symmetry handling has been increased. It is now possible to use orbitopes (i.e., polyhedral symmetry
  handling techniques) and orbital fixing on the same instance.

- cut strengthening enabled within the Benders' decomposition framework. This uses a mix of the Improved Magnanti-Wong
  method and Kelly's method. The cut strengthening is enabled by setting the paramemter
  "benders/<bendersname>/cutstrengthenenabled" to TRUE. The parameters "cutstrengthenmult", "noimprovelimit" and
  "corepointperturb" control the behavior of the cut strengthening method. Additionally, the parameter
  "cutstrengthenintpoint" allows the user to specify the solution that is used to initialize the core point. The options
  are the first LP solution, the first integer feasible solution, a relative interior point, a solution vector of all
  ones and a solution vector of all zeros. Also, the core point can be reinitialized after each update to the incumbent
  solution.

- added option to adjust weights of different scores in relpscost (hybrid) branching rule based on degeneracy information
  and skip strong branching for very high degeneracy rates

- added new SCIP_DECOMP* object to store user decompositions. The user can specify one or several decompositions by assigning variable
  and/or constraint labels either through the API or by reading a file in DEC format (which is one of the formats that GCG writes).
  This format specifies constraint labels, variable labels are inferred from that. The decomposition is transformed after presolving.
- statistics regarding the number of blocks, the largest and smallest blocks, the border, and the constraint graph are printed for the original decomposition,
  and for each decomposition after presolving.
- the decomposition can be used as initial decomposition for the Benders functionality of SCIP.
- new subsection "How to provide a problem decomposition" in the SCIP documentation

- GINS heuristic can make use of a user-provided decomposition labels in two ways:
 1. by selecting a block of variables that maximizes the potential, and randomly selecting a start variable for the neighborhood and/or
 2. by selecting an interval of consecutive blocks as neighborhood, until fixing rate is reached. In this case, no variable is randomly selected.

- extend potential parameter of GINS to allow computation based on local LP solution, as well

- new primal heuristic Adaptive Diving, which registers all publicly available dive sets from other diving heuristics.
  At each call, it selects one of the available dive sets based on the user's score type choice (heuristics/adaptivediving/scoretype).
  During the solution process, the heuristics learns online which divesets reach the best score, and executes them more frequently.
  The statistic output for Diving heuristics has been extended to incorporate the statistics of each dive set within Adaptive diving.

- Added new penalty alternating direction method (PADM) primal heuristic that splits the problem into several sub-SCIPs
  according to a user-provided decomposition. The sub-SCIPs are solved on an alternating basis until a feasible solution of
  the original problem is found.

- Symmetry handling constraints (cons_orbisack, cons_orbitope, cons_symresack) now have an additional parameter to encode
  whether they are model constraints, i.e., define the problem, or whether they are only present to handle symmetries.

- The symmetry code has been completely restructured. The presolvers presol_symbreak and presol_symmetry as well as the propagator
  prop_orbitalfixing have been merged into the single propagator prop_symmetry to avoid storing the same information
  multiple times. This propagator is now responsible for adding symmetry handling constraints as well as activating orbital
  fixing. Moreover, the new file symmetry.c contains general functions for symmetry computations like orbit computations.

- Variables can now be marked as "relaxation-only". This flag should be used to introduce new variables that are required
  to define a relaxation, but that are not part of any checked constraints. Essentially, these variables should only be used
  in the current SCIP solve and disregarded after a restart or in SCIP copies. Hence, these variables are not copied by SCIPcopy and
  SCIPgetVarCopy, they are currently not used in conflict constraints, and cuts involving them are not upgraded to linear constraints.
  Relaxation-only variables cannot appear in the objective function.

- The OSiL reader now supports nonlinear expressions of type "signpower".

- Expressions of form abs(x)^p * x in a nonlinear constraint are now sometimes recognized and handled by abspower constraints.

- If polyhedral symmetry handling methods are used (cons_orbisack, cons_orbitope, cons_symresack), it is now possible to
  recompute symmetries if a restart occured.

- upgrade some more quadratic constraints to second-order cone constraints, that is,
  handle linear binary variables as if squared in simple upgrade and
  do not require bounds for variables that have a zero entry in the computed eigenvectors in the non-simple upgrade

- new variable event when changing the variable type

- It is no longer necessary to provide a SCIP pointer for the subproblem in SCIPaddBendersSubproblem if custom solving
  methods are defined. A NULL pointer can be supplied to SCIPaddBendersSubproblem. In this case, no internal Benders'
  cut generation methods can be used.

- Using the parameter "constraints/symresack/checkmonotonicity" one can now decide to upgrade to packing/partitioning
  symresacks even if the underlying permutation is not monotone.

- New branching rule `vanillafullstrong`, mostly for scientific purpose, with the following features:
  1) no cutoff or domain reduction: only branching;
  2) idempotent (optional): leave SCIP, as much as possible, in the same state before / after the strong branching calls
     - basically, do not update any statistic;
  3) donotbranch (optional): do no perform branching. So that the brancher can be called as an oracle only
     (on which variable would you branch ? But do not branch please);
  4) scoreall (optional): keep scoring variables, even if infeasibility is detected;
  5) collectscores (optional): store the candidate scores from the last call, which can then be retrieved by calling SCIPgetVanillafullstrongData();
  6) integralcands (optional): consider integral candidates for branching,
     i.e., get candidates from SCIPgetPseudoBranchCands() instead of SCIPgetLPBranchCands().

- If a reference value (misc/referencevalue) is given, the primal-reference and reference-dual integrals are calculated automatically and printed within the SCIP statistics.

- Locally valid cuts / rows are now considered for dual proof analysis when `conflict/uselocalrows` is set to TRUE.

- Linking variables in the linking constraint handler (cons_linking.{ch}) can now be integer or continuous. The coefficients of the binary variables are therefore now stored as SCIP_Real.

- To save memory, it is now possible to remove all variables from the internal symmetry data structures that are
  not affected by any symmetry.

- Allow to filter first variables from orbits and transfer pseudo cost information to variables in orbit

- Add integration of external MILP presolve library as a SCIP presolver plugin that runs on MILP problems

- Parallelisation can be used when applying Benders' decomposition. There are two different forms of parallelisation
  available. The first is applying Benders' decomposition within a parallel branch-and-bound. This is achieved through
  the integration with the UG framework. The second is the use of shared memory parallelisation for solving the Benders'
  decomposition subproblems. A priority queue has been added to help with load balancing.

- The Benders' decomposition framework can handle MINLPs. If a convex relaxation of the MINLP exists, then this is
  solved to generate optimality and feasibility cuts. The extensions to the framework are:
  - New generic solving methods to solve convex NLP subproblems.
  - Modification to benderscut_opt and benderscut_feas to enable the generation of cuts from convex NLPs.
  - Addition of benderscut_feasalt to generate feasibility cuts from an alternative subproblem that minimises the
    violation of infeasible problems.
  - Better handling of subproblem solution results

- Adds a feasibility phase to the Benders' decomposition subproblem solving methods. The feasibility phase adds slack
  variables to each of the constraints to ensure feasibility of the subproblem. A large coefficient is given to these
  slack variables in the objective function to penalise constraint violations. The coefficients are progressively
  increased until all slack variables take the value 0.0.

- Improved convexity check for Benders' decomposition subproblems. The constraints of the subproblem are now checked for
  convexity in the initialisation of the Benders' decomposition algorithm. This enables the solving of convex NLPs as
  Benders' decomposition subproblems.

- Benders' decomposition can be applied using decomposition supplied in the DEC format. To apply Benders' decomposition
  the parameters decomposition/benderslabels and decomposition/applybenders must be set to TRUE.

- new event handler event_estim.c/h that approximates search tree completion and estimates tree size
  to trigger restarts; many approximations of search tree completion and estimation, including WBE, SSG, and tree profile method
- new display column that reports approx. search tree completion during the search, and an overview in the statistics table
- added resources (script, tutorial, test data) to adapt tree size estimation to user instances.

- Orbital Fixing uses a list of variables that have been fixed globally since the computation of symmetries to filter
  symmetries. Previously, some plugins were disabled, which is not necessary anymore.

- A new presolver "dualsparsify" was added. It tries to combine columns (i.e. variables) to cancel nonzero coefficients in the constraint matrix.

- The presolver "tworowbnd" was implemented with better performance.

- To be able to calculate better bounds for the dual variables, the presolver "dualinfer" was extended by the ability to perform convex combinations of continuous columns.

- allow disabling of pricers during solving process

- added emphasis setting for numerically challenging instances

Performance improvements
------------------------

- Extended cut presolving by removing variables that been fixed at their bounds

- Improved branching point selection when branching on externals branching candidates. Instead of using exactly the
  LP solution, a point closer to the middle of the variables domain is chosen.

- Matrix presolvers that do not work on incomplete matrices now skip matrix creation if unsupported constraint types are detected.

- consLockBenders callback implemented to add down locks on the Benders' decomposition auxiliary variables and
  up and down locks per subproblem for all master problem variables. This allows the use of presolving and propagation
  with Benders' decomposition.

- improved performance of orbital fixing in several ways:
  store permutations in transposed form to improve cache efficency;
  reverse order to speed up filtering of permutations;
  handle variables globally fixed to 1 in list;
  use event handler to catch global fixings;
  speed up orbit computations;
  change handling of restarts;
  use only permutations that can contribute to a variable's orbit;

- allow rapid learning at local nodes

- allow to recompute cut without using fractional values for sepa_cgmip

- restrict the number of the clique table nonzeros relative to the number of problem nonzeros, which could be a performance bottleneck.

- variable fixings of LP face heuristic are now computed earlier; subproblem creation is skipped if not enough variables are fixed.

- Improved domcol presolver to not require a complete representation of all constraints in the matrix

- performance improvement of adaptive large neighborhood search heuristic on merely continuous problems. The heuristic
  stops if presolving in the sub-SCIP fixes less than 50 % of the current target fixing rate over all variables
  (including continuous).

- reduce memory usage in symmetry detection by a staggered allocation with decreasing overhead for larger instances

- improved full orbitope propagation using a static implementation or a dynamic reordering of orbitope rows by a global rank function

- improved detection of packing/partitioning orbitopes

- enable an in-tree restart if after a reasonable initialization, the estimated size of the remaining tree is large.


Examples and applications
-------------------------

- added functions to set and get hmin and hmax for optcumulative constraints

Interface changes
-----------------

### New and changed callbacks

- new optional callback `SCIP_DECL_DIVESETAVAILABLE` to check preconditions for this dive set, e.g., if an incumbent solution is available,
  which is passed as new argument to SCIPcreateDiveset(). SCIPcreateDiveset() has another new parameter "ispublic".

- new callback `SCIP_DECL_CONSHDLRCOPY` and `SCIP_DECL_CONSCOPY` in cons_orbisack and cons_symresack

- new `idempotent` argument to SCIPgetVarStrongbranchInt() and SCIPgetVarStrongbranchFrac(),
  so that statistics are not updated during the call. Likewise, new `updatecol` and `updatestat` arguments to SCIPcolGetStrongbranch().

- callback `SCIP_DECL_CONSHDLRENFOLP` can now also return SCIP_SOLVELP as *result, which indicates to the SCIP core that the LP relaxation
  should be solved again because the primal feasibility tolerance of the LP has been tightened (using SCIPsetLPFeastol())

- extension of SCIP_PQUEUE by a new callback SCIP_DECL_PQUEUEELEMCHGPOS to catch swaps as well as functionality to delete arbitrary elements from the priority queue.

### Deleted and changed API functions

- LPI:
  + now for all lp interfaces consistent requirements on SCIP_LPPAR:
    LPITLIM and BARRIERCONVTOL positive or zero; FEASTOL, DUALFEASTOL, LPTILIM strictly positive
  + now projecting SCIP_LPPAR values on feasible values for each lp interface
  + add interface to Glop
  + fixed mapping between scaling parameter values in Gurobi LPI lpi_grb
- Symmetry:
  + removed function SCIPseparateCoversOrbisack() in cons_orbisack.h since the orbitope constraint
    handler has its own implementation of this routine with advanced features now
  + renamed SCIPgetGeneratorsSymmetry() to SCIPgetSymmetry() and removed two arguments
  + extended function SCIPgetSymmetry(): It is possible to access both the original and
    transposed permutations matrix as well as the (independent symmetry) components of a permutation group now.
  + arguments of functions SCIPcreateConsOrbisack(), SCIPcreateConsBasicOrbisack(), SCIPcreateConsOrbitope(),
    SCIPcreateConsBasicOrbitope(), SCIPcreateConsSymresack(), SCIPcreateConsBasicSymresack(), and SCIPcreateSymbreakCons() extended
    by "ismodelcons" to encode whether the constraints are model constraints or not
  + the function SCIPgetSymmetry() no longer accepts the parameter recompute, but has parameter permvarmap as new input
  + removed SCIPgetPermvarsObjSymmetry(), SCIPsetSymmetryComponentblocked(), SCIPgetSymmetryComponentblocked(),
    SCIPgetSyminfoGloballyFixedVars(), SCIPcomputeGroupOrbitsSymbreak, SCIPincludePresolSymmetry(),SCIPincludePresolSymbreak(),
    and SCIPincludePropOrbitalfixing()
  + add function SCIPcomputeOrbitsComponentsSym() to compute orbits without filtering permutations and indices of orbits for each variable
- SCIPallowObjProp() and SCIPallowDualReds() are deprecated and replaced by SCIPallowWeakDualReds() and SCIPallowStrongDualReds(), respectively
- Benders' decomposition
  + changed SCIPstoreBenderscutCut() in scip_benders.c to SCIPstoreBendersCut(). Where this function used to take a
    SCIP_BENDERSCUT pointer, it now accepts a SCIP_BENDERS pointer.
  + the functions SCIPsolveBendersSubproblem() no longer accepts the parameter type. The type is not a necessary
    argument for the subproblem solving method.
  + arguments of functions SCIPbendersSolveSubproblemLP(), SCIPbendersSolveSubproblemCIP(), and SCIPbendersOnlyCheckConvexRelax() changed
  - removed SCIPbenderscutGetNAddedCuts() and SCIPbenderscutGetAddedCutData()


### New API functions

- new argument "onlyifcomplete" in SCIPmatrixCreate() to skip matrix creation right after detecting unsupported constraint types
  and new arguments to count statistics when doing a clean-up of inactive variables in the constraints before building the matrix

- new argument "threadsafe" in SCIPcopy(), SCIPcopyConsCompression(), SCIPcopyOrig(), SCIPcopyOrigConsCompression and
  SCIPcopyBenders(). This argument must only be set to TRUE if the source and target SCIP instances are to be solved in
  parallel. Setting this argument to TRUE has a performance cost.

- new argument "append" in SCIPsetModifiedDefaultSettingsIpopt()
- functions SCIPclearRelaxSolVals(), SCIPsetRelaxSolVal(), SCIPsetRelaxSolVals(), SCIPsetRelaxSolValsSol(), and SCIPmarkRelaxSolValid()
  receive an additional argument "relax" to store the relaxation handler as creator of the relaxation solution.

- LP:
  - SCIProwGetOriginCons() now returns a SCIP_CONS* instead of a SCIP_CONSHDLR*, use SCIProwGetOriginConshdlr() for the previous behavior
  - SCIPcreateRowCons() and SCIPcreateEmptyRowCons() now expect a SCIP_CONS* instead of a SCIP_CONSHDLR*,
    use SCIPcreateRowConshdlr() and SCIPcreateEmptyRowConshdlr(), respectively, for the previous behavior
  - deprecated SCIPlpfeastol() and SCIPchgLpfeastol(), use SCIPgetLPFeastol() and SCIPsetLPFeastol()

- new parameter "divecontext" for every function that queries statistics for a diveset. The context can be used to distinguish between the dive set
  as single (standalone) heuristic or within Adaptive Diving.
- new parameters "divecontext" and "iterlim" to SCIPperformGenericDivingAlgorithm() to control in which context (single,adaptive) statistics are updated.

- SCIPcopyVars, SCIPcopy, SCIPcopyConsCompression, and SCIPgetVarCopy do not copy variables that are marked as relaxation-only,
  thus it cannot be assumed anymore that each active variable from the master SCIP also has a counterpart in the copy.
  SCIPcopy, SCIPcopyConsCompression, and SCIPcopyConss can now return *valid=TRUE if some non-checked and non-enforced constraints were not copied, e.g.,
  because they involved relaxation-only variables. Thus, a copy is already regarded as valid if all checked or enforced constraints were copied successfully.

- linking constraint handler:
  - changed type of vals argument from int* to SCIP_Real* in SCIPcreateConsLinking() and SCIPcreateConsBasicLinking()
  - SCIPgetIntvarLinking() has been renamed to SCIPgetLinkvarLinking().
  - changed return value of SCIPgetValsLinking() from int* to SCIP_Real*.
  - new function SCIPgetBinvarsDataLinking().

- SCIPbendersCheckSubproblemOptimality() now returns a boolean indicating whether the subproblem is optimal or not.
  Previously this result was returned through a parameter. The change was required to facilitate the integration with
  the UG framework.

- deleted SCIPcombineTwoInt(), SCIPcombineThreeInt(), SCIPcombineFourInt(); use the appropriate SCIPhashTwo(), ..., SCIPhashSeven() function instead

- SCIPsetupBendersSubproblem takes a parameter of the enforcement type.

- SCIPcreateNlpiProb takes a hashmap to store the map between the nlrows and the index in the nlrow array.

### New API functions

- SCIPallowWeakDualReds() and SCIPallowStrongDualReds() replace the deprecated SCIPallowObjProp() and SCIPallowDualReds(), respectively
- functions have been added to facilitate the transfer of Benders' decomposition cuts between solvers in UG. These include
  SCIPapplyBendersStoredCuts(), SCIPbendersGetNStoredCuts(), SCIPbendersGetStoredCutData() and
  SCIPbendersGetStoredCutOrigData().
- added SCIPisConvexAbspower()
- new functions SCIPsolGetType(), SCIPsolGetRelax(), SCIPsolSetRelax(), SCIPsolSetLPRelaxation(), SCIPsolSetStrongbranch(),
  SCIPsolSetPseudo to set or query the new type attribute of a primal solution. The type attribute gives information
  about the origin of the solution, ie, whether it was created by a relaxation handler,
  by the LP relaxation, by strong branching, by the current pseudo solution, or by a primal heuristic.
  The meaning of the argument 'heur' in all creation methods for primal solutions such as SCIPcreateSol() stays unchanged.
- added SCIProwGetOriginConshdlr(), SCIPcreateRowConshdlr(), SCIPcreateEmptyRowConshdlr()
- new API functions SCIPsetCommonSubscipParams(), SCIPtranslateSubSol(), and SCIPtranslateSubSols() shared by several Large Neighborhood Search heuristics.
- new API function SCIPgetLPDualDegeneracy() to get two measures for the dual degeneracy of the current LP
- new API functions SCIPdivesetIsAvailable() to check preconditions of a dive set and SCIPdivesetIsPublic() to check if the dive set can be used
  by other primal heuristics.
- new API functions SCIPcomputeOrbitsSym(), SCIPcomputeOrbitsFilterSym(), SCIPgetPropertiesPerm(), SCIPdetermineBinvarAffectedSym(),
  SCIPdetermineNVarsAffectedSym(), SCIPcomputeComponentsSym(), and SCIPextendSubOrbitope(), SCIPgenerateOrbitopeVarsMatrix() for symmetry computations
- new API functions SCIPvarIsRelaxationOnly() and SCIPvarMarkRelaxationOnly() to query and set, resp., whether a variable is marked as relaxation-only
- new API functions SCIPconshdlrGetNUpdateConss() and SCIPconshdlrGetUpdateConss(), for expert users only
- new API function SCIPgetNConflictDualproofsApplied()
- new API functions SCIPeventGetOldtype() and SCIPeventGetNewtype() for the new event when changing the variable type
- new API function SCIPisConvexConsQuadratic() to check whether a quadratic constraint is convex when a given set of variables would be fixed
- new API functions SCIPgetLPFeastol(), SCIPsetLPFeastol(), and SCIPresetLPFeastol() to get, set, and reset (to the default), respectively, the primal
  feasibility tolerance for the LP relaxation
- new API functions SCIPcleanupConss{Linear,Varbound,Setppc,Logicor,Knapsack}() to clean up inactive variables from those types of linear constraints
- new API function SCIPsetBendersSubproblemComp() used to add a custom comparison method for ordering the Benders'
  decomposition subproblem solves. The comparison method is used to help with load balancing.
- new API function SCIPgetRowObjParallelism to get the objective parallelism of a row
- new API function SCIPcolGetAge to get the age of a column
- added SCIPhashThree(), SCIPhashFive(), SCIPhashSix(), and SCIPhashSeven() that complement SCIPhashTwo(), SCIPhashFour() to combine 32bit integers to
  a 32bit hash value
- new API function SCIPgenerateAndApplyBendersOptCut is used to generate a Benders' optimality cut using the dual
  solutions. This function can be supplied vectors for the primal and dual solution for generating an optimality cut.
  This avoids the need for a SCIP instance to solve the Benders' decomposition subproblem and generating cuts.
- new API function SCIPconsAddCoef used for adding a coefficient to a linear-type constraint.
- new API functions SCIPconsNonlinearGetRhs, SCIPconsNonlinearGetLhs and SCIPconsNonlinearAddLinearCoef for getting the
  RHS and LHS from a nonlinear-type constraint and adding a linear coefficient to the constraint.
- new API function SCIPbendersSolSlackVarsActive for checking whether any slack variables from the feasibility phase are
  active in the subproblem solution.
- new API functions SCIPbendersSetSubproblemType and SCIPbendersGetSubproblemType sets and gets the subproblem type.
  This is either:
  - Convex constraints with continuous variables
  - Convex constraints with discrete variables
  - Non-convex constraints with continuous variables
  - Non-convex constraints with discrete variables
- new API functions SCIPbendersSetSubproblemIsNonlinear() and SCIPbendersSubproblemIsNonlinear() for setting and
  identifying whether the Benders' decomposition subproblems contain nonlinear constraints. Similarly, the functions
  SCIPbendersSetMasterIsNonlinear() and SCIPbendersMasterIsNonlinear() sets and identifies whether the Benders'
  decomposition master problem contains nonlinear constraints.
- new API function SCIPapplyBendersDecomposition for applying Benders' decomposition given a decomposition in the DEC
  format
- new API function SCIPwasNodeLastBranchParent to query if a node has been the parent of the most recent branching in the tree
- new API functions SCIPtreemodelInit(), SCIPtreemodelFree(), SCIPtreemodelIsEnabled(), SCIPtreemodelSelectCandidate() related to the new
  treemodel way of comparing branching candidates. These functions are only currently used for reliability pscost branching, but they can be used
  in other parts of the code.
- New function SCIPcalcChildEstimateIncrease() to compute the increase in the child estimation
- new API functions SCIPisOrbitalfixingEnabled() and SCIPgetSymmetryNGenerators() to check whether orbital fixing is
  enabled and to get the number of generators of the current symmetry group, respectively
- new API function SCIPdelNlRow() to remove a row from the NLP

### Event system

- new event type SCIP_EVENTTYPE_NODEDELETE to react on nodes that are about to be deleted from the tree

### Changed parameters

- renamed parameter "propagating/orbitalfixing/enableafterrestart" to ".../symmetry/recomputerestart"
- Parameter "misc/allowdualreds" is now called "misc/allowstrongdualreds"
- Parameter "misc/allowobjprop" is now called "misc/allowweakdualreds"
- changed default values of propagation (new value: 1, old value: 5) and separation frequency (new value: -1, old value: 5) in cons_orbitope.c
- all primal heuristics that use sub-SCIPs are disabled within the heuristics fast emphasis setting
- deleted parameter heuristics/localbranching/useuct, use heuristics/useuctsubscip instead
- changed default value of "presolving/symbreak/detectorbitopes" (new value: TRUE, old value: FALSE)
- extended range of "misc/usesymmetry" (new range: [0,3], old range: [0,2])
- deleted parameter "constraints/orbisack/checkalwaysfeas"
- deleted parameter "constraints/orbitope/checkalwaysfeas"
- deleted parameter "constraints/symresack/checkalwaysfeas"
- deleted parameter "presolving/symmetry/maxgenerators"
- deleted parameter "presolving/symmetry/checksymmetries"
- deleted parameter "presolving/symmetry/displaynorbitvars"
- deleted parameter "presolving/symbreak/conssaddlp"
- deleted parameter "presolving/symbreak/addsymresacks"
- deleted parameter "presolving/symbreak/computeorbits"
- deleted parameter "presolving/symbreak/detectorbitopes"
- deleted parameter "presolving/symbreak/addconsstiming"
- deleted parameter "propagating/orbitalfixing/symcomptiming"
- deleted parameter "propagating/orbitalfixing/performpresolving"
- deleted parameter "propagating/orbitalfixing/recomputerestart"
- changed default value of "heuristics/coefdiving/freq" (old: 10, new: -1)
- changed default value of "heuristics/conflictdiving/freq" (old: -1, new: 10)
- changed default value of "heuristics/conflictdiving/lockweight" (old: 1.0, new: 0.75)
- replaced parameter "numerics/lpfeastol" by "numerics/lpfeastolfactor" to specify which factor should be applied to the SCIP feasibility
  tolerance to initialize the primal feasibility tolerance of the LP solver
- enabling aggressive presolving now activates all available presolving plugins,
  and decreases the presolving/restartfac parameter correctly with respect to default.
- changed default value of heuristics/rins/nodesquot to 0.3 (was 0.1), to compensate
  the removal of a hard coded factor of 3.0 in the code without affecting the default behavior
  of the RINS heuristic.
- changed default value of "constraints/quadratic/empathy4and" (old: 0, new: 2)
- changed default value of "propagating/redcost/useimplics" (old: TRUE, new: FALSE)

### New parameters

- the possibility to define the Benders' decomposition auxiliary variables as implicit integer is provided. This
  behavior is controlled with an additional parameter in the Benders' decomposition framework.
- added parameter benders/<bendersname>/cutcheck to enable the generation of Benders' decomposition cuts during solution
  checking.
- constraints/orbitope/usedynamicprop: the possibility to propagate orbitope constraints by reordering the rows based on the
  branching strategy is provided (only possible for non-model constraints)

- new parameters heuristics/shiftandpropagate/minfixingratelp and heuristics/locks/minfixingratelp to stop the
  heuristics after propagating integer fixings if no sufficient fixing of the all variables (including continuous)
  could be achieved. These parameters help to avoid solving LP's that are comparable in hardness to the main root LP.

- Added parameters branching/midpull and branching/midpullreldomtrig to control by how much to move
  the branching point for an external branching candidate closer to the middle of the candidates domain. The
  default of 0.75 and 0.5, respectively, uses a point that is 75*alpha% closer to the middle of the domain, where
  alpha is the relative width of the candidates domain (width of local domain divided by width of global domain),
  if the latter is below 0.5, and alpha=1.0 otherwise. That is, with the default settings, a branching point is
  chosen closer to the middle of the candidates domain if the variables local domain is still similar to its
  global domain, but is chosen closer to the LP solution if the local domain is much smaller than the global
  domain.

- Added parameter lp/minmarkowitz to set the Markowitz stability threshold (range 0.0001 to 0.9999).
  High values sacrifice performance for stability.

- Added parameters benders/<bendersname>/lnsmaxcalls and benders/<bendersname>/lnsmaxcallsroot to the Benders'
  decomposition core. These parameters limit the number of Benders' decomposition subproblem checks, for the full
  branch-and-bound tree and root node respective, when solving the auxiliary problem of LNS hueristics. These
  parameters only have effect if the lnscheck parameter is set to TRUE.

- Added parameter cons/linear/maxmultaggrquot to limit the maximum coefficient dynamism of an equation on which
  multiaggregation is performed. This replaces a compiler define of the same name.
  Default value is 1000, smaller values make multiaggregations numerically more stable.
- new global parameter heuristics/useuctsubscip that affects all LNS heuristics using common sub-SCIP parameters

- new parameter branching/relpscost/degeneracyaware to switch degeneracy-aware hybrid branching

- new parameter separation/rapidlearning/checkexec to check whether rapid learning is allowed to run locally
- new parameters separation/rapidlearning/check{degeneracy,dualbound,leaves,nsols,obj} to enable checking the respective feature for local rapid learning
- new parameter separation/rapidlearning/maxcalls to limit the number of rapid learning executions
- new parameter separation/rapidlearning/nwaitingnodes to set the number of waiting nodes before the dual bound is checked
- new parameter separation/rapidlearning/mindegeneracy to set the minimal threshold of degenerate basic-variables
- new parameters separation/rapidlearning/minvarconsratio to set the minimal ratio of unfixed variables in relation to basis size

- new parameters to control the Benders' decomposition two-phase method.
  - constraints/benderslp/depthfreq: after the maxdepth is reached, then the two-phase method will only be called at
    nodes at a depth divisible by depthfreq.
  - constraints/benderslp/stalllimit: after the maxdepth is reached, if there has been no improvement in the dual bound
    for stalllimit number of nodes, then the two-phase method is executed for the next fractional LP solution that is
    encountered.
  - constraints/benderslp/iterlimit: after the root node, only iterlimit fractional LP solutions are used at each node
    to generate Benders' decomposition cuts.

- new parameters for symmetry handling
  - new parameter "propagating/symmetry/maxgenerators"
  - new parameter "propagating/symmetry/checksymmetries"
  - new parameter "propagating/symmetry/displaynorbitvars"
  - new parameter "propagating/symmetry/conssaddlp"
  - new parameter "propagating/symmetry/addsymresacks"
  - new parameter "propagating/symmetry/detectorbitopes"
  - new parameter "propagating/symmetry/addconsstiming"
  - new parameter "propagating/symmetry/ofsymcomptiming"
  - new parameter "propagating/symmetry/performpresolving"
  - new parameter "propagating/symmetry/recomputerestart"
  - new parameter "constraints/symresack/checkmonotonicity"
  - new parameter "propagating/symmetry/compresssymmetries"
  - new parameter "propagating/symmetry/compressthreshold"
  - new parameter "propagating/symmetry/disableofrestart"
  - new parameter "propagating/symmetry/symfixnonbinaryvars"

- new parameter for enabling shared memory parallelisation for solving Benders' decomposition subproblems. The parameter
  benders/<bendersname>/numthreads sets the number of threads used for parallel subproblem solving.

- new parameters to control enhancements for solving MINLPs by Benders' decomposition
  - benders/<bendersname>/execfeasphase: enables the feasibility phase for solving the Benders' decomposition
    subproblems
  - benders/<bendersname>/slackvarcoef: the initial coefficient of the slack variable for the feasibility phase
  - benders/<bendersname>/checkconsconvexity: should the constraints be checked for convexity. This can be set to FALSE
    if you are certain that the NLP subproblem is convex.

- new parameter presolving/clqtablefac (default value 2.0) as limit on number of entries in clique table relative to number of problem nonzeros

- new parameter conflict/uselocalrows (default: TRUE) to incorporate locally valid cuts / rows for dual proof analysis

- new return code SCIP_NOTIMPLEMENTED for functions, e.g., in the LPI that have not been implemented (yet)

- new parameter separating/cgmip/genprimalsols that allows to generate initial primal solutions from Gomory cuts

- new parameter branching/relpscost/filtercandssym to allow filtering from orbits

- new parameter branching/relpscost/transsympscost to transfer pseudo cost information to orbit

- new parameters for tree size estimation and restarts:
    - estimation/restarts/restartpolicy (default value n)
    - estimation/method (default value c)
    - estimation/restarts/restartlimit (default value 1)
    - estimation/restarts/minnodes (default value 1000)
    - estimation/restarts/countonlyleaves (default value FALSE)
    - estimation/restarts/restartfactor (default value 2)
    - estimation/coefmonoprog (default value 0.3667)
    - estimation/coefmonossg (default value 0.6333)
    - estimation/restarts/hitcounterlim (default value 50)
    - estimation/reportfreq (default value -1)
    - estimation/regforestfilename (default value "-")
    - estimation/completiontype (default value a)
    - estimation/treeprofile/enabled (default value FALSE)
    - estimation/treeprofile/minnodesperdepth (default value 20)
    - estimation/useleafts (default value TRUE)
    - estimation/ssg/nmaxsubtrees (default value -1)
    - estimation/ssg/nminnodeslastsplit (default value 0)

- new parameter constraints/linear/extractcliques to turn clique extraction off

- new emphasis setting emphasis/numerics to increase numerical stability of (mostly) presolving operations such as (multi-)aggregations at the cost of performance.

- new parameters for treemodel:
  - new parameter branching/treemodel/enable to enable the treemodel in reliability pscost branching and possible
    future parts of the code where it could be used.
  - new parameter branching/treemodel/highrule to specify which branching rule to use when treemodel thinks the node
    is high in the tree.
  - new parameter branching/treemodel/lowrule to specify which branching rule to use when treemodel thinks the node
    is low in the tree.
  - new parameter branching/treemodel/height to specify at which (estimated) height a node is high or low in the tree.
  - new parameter branching/treemodel/filterhigh to specify whether to filter dominated candidates in nodes which are
    high in the tree.
  - new parameter branching/treemodel/filterlow to specify whether to filter dominated candidates in nodes which are
    low in the tree.
  - new parameter branching/treemodel/maxfpiter to specify the maximum number of fixed-point iterations to use when
    computing the ratio of a variable using the fixed-point method.
  - new parameter branching/treemodel/maxsvtsheight to specify the maximum height to compute the SVTS score exactly
    before approximating it using the ratio.
  - new parameter branching/treemodel/fallbackinf defines the fallback strategy to use when the tree size estimates
    obtained by SVTS are infinite.
  - new parameter branching/treemodel/fallbacknoprim defines the fallback strategy to use when no primal bound is known
    and thus SVTS would not be able to compute a tree size (it would be infinite).
  - new parameter branching/treemodel/smallpscost defines the value under which pscosts are considered too small to be
    the deciding factor for branching, in which case it may be better not to use the treemodel.

- new parameters for symmetry handling constraint handlers to enforce that also non-model constraint are copied:
  - new parameter "constraints/orbisack/forceconscopy"
  - new parameter "constraints/orbitope/forceconscopy"
  - new parameter "constraints/symresack/forceconscopy"


### Data structures

- small changes in constants of hash functions
- added fast 2-universal hash functions for two to seven 32bit elements with 32bit output
- extended SCIPpqueueCreate() by additional callback argument SCIP_DECL_PQUEUEELEMCHGPOS to catch position changes
- new methods SCIPpqueueDelPos() to delete elements at a specific position in the priority queue and SCIPpqueueFind() to
  find a specific position. It is recommended to track position changes using the new callback SCIP_DECL_PQUEUEELEMCHGPOS.
  In contrast, using SCIPpqueueFind() can be slow because it needs to compare the element it searches for
  with each slot in the queue.

### Build system

- The default value for DFLAGS in the non-cmake buildsystem has changed from -MM to -MMD. This will break the
  generation of depend.* files if that was done by a compiler call that relied on -MM. The new preferred way
  to handle compilation dependencies is to additionally use $(DFLAGS) when compiling the object files (.o) and
  to include the generated .d files in the Makefile, see also "Build system / Makefile" below.

Unit tests
----------
 - new unit test for treemodel.

Testing
-------

 - fixed an issue that may have lead to wrong status reports in the evaluation scripts

Build system
------------

### Cmake

- avoid problem with doubly defined object together with CPLEX

### Makefile

- Removed static object compilation dependency files (depend.*). If using a GCC compatible compiler, then dependency
  files are now dynamically created and updated during build. The new dependency files (*.d) reside next to each object
  file (.o) in the corresponding obj subdirectory.
- added support for building against Ipopt >= 3.13
- unify compiler switches for Intel compiler and avoid problem with doubly defined object together with CPLEX

Fixed bugs
----------

- fix and improve memory handling in symmetry computation
- fix shown number of applied conflicts in solving statistics
- fix wrongly skipping strong branching call and using old information if LP was solved with 0 iterations
- fix minor bug in cut score calculation
- fixed several bugs related to rounding locks of variables not being updated correctly
- small fix in cons_varbound.c to skip changing bounds of multi-aggregated variables in separation callback
- fixed issue in SCIPtightenVar* and SCIPinferVar* that occurs for small bound changes
- fixed rejecting minimal boundchange that changed sign of variable, even though SCIPisLb/UbBetter approved it
- fixed issue in generateCutNonConvex() which is triggered when adding quadratic constraints during the solving process
- fixed bug in freeing the reoptimization data if no problem exists
- fixed bug in SCIPreoptReleaseData() when freeing all stored constraints
- fixed bug when freeing the transformed problem via interactive shell if reoptimization is enabled
- fixed two issues related to (near-)redundant logicor constraints in presolving
- fixed counting of aggregations in XOR constraint handler
- fixed handling of unbounded solutions
- fixed update of LP size information when an LP error occured during probing
- handle special case of variable bound constraints during aggregating variables
- tighten sides of linear constraints before trying to upgrade them to more specialized constraints (knapsack, logic-or etc.) when calling SCIPupgradeConsLinear()
- fixed an issue in repair heuristic in the case of loose (noncolumn) variables
- allow user to correctly set heuristics/alns/(un)fixtol
- fixed an issue in heur_completesol which is triggered during bound widening of unbounded continuous variables
- fixed bug in cons_indicator if addopposite is true
- fixed bug in sepa_disjunctive: treat case that conflictgraph is empty
- added safety check in conversion to rational number to avoid overflow
- fixed bug in interval evaluation with power-operator in certain situations
- fixed behavior of SCIPmatrixCreate() regarding memory management and column generation
- SCIPmatrixCreate() returns complete=FALSE when locks do not add up
- fixed bug in sepa_oddcylce when variables are fixed
- fixed numerical issues related to tighter constraint sides in varbound constraint handler
- fixed update of watchedvars in logicor constraint handler in case of a restart during the tree
- fixed treatment of multi-aggregated variables in logicor constraint handler
- handle special case of redundant implications
- fixed numerical issue related to almost-0-values in pseudosolution conflict analysis
- fixed numerical issue related to very large greatest common dividers in linear constraint handler
- avoid using implications on multiaggregated variables when propagating implications
- fixed creation of (Lagrangian) variable bounds in the OBBT propagator
- fixed sorting of primal solutions
- fixed cleaning of clean buffer in conflict analysis
- avoid probing on variables with huge bounds in shift and propagate heuristic
- fix issue in printing solutions for variables that have been added by the dual sparsify presolver
- fix issue related to fixing redundant logic-or constraints after presolving
- fixed bug when parsing logic-or and and-constraints
- fixed wrong assert in updateLazyBounds()
- fixed bug in pricestore, which resulted in too many problem variables being added
- fixed bug in cons_knapsack where weight of clique was not reset after an infeasibility was detected
- fixed bug in presol_inttobinary which did not take into account that the aggregation could be rejected due to numerics
- fixed bug in debug solution mechanism in connection to variables created by presol_inttobinary
- fixed wrong indexing while undoing the implications from a redundant variable in SCIPshrinkDisjunctiveVarSet
- redundancy checks in SCIPnodeAddBoundinfer now take a possible change to an active variable into account
- fixed adding already added quadratic rows to NLP relaxation during solve
- fixed issue related to variable locks in the varbound constraint handler
- fixed bug in the quadratic constraint handler when changing infinite constraint sides
- fixed sorting of variables in linear constraint handler
- added additional checks to ensure numerical stability of dual proofs
- fixed a case when activities of a linear constraint got unreliable but where still used for reductions
- ensure that lhs <= rhs for linear constraints (without tolerances)
- make handling of read errors in SCIPfread() consistent between version with and without ZLIB
- correctly drop variable events in cons_indicator in restart
- fixed bug in cons_orbitope with upgrading of orbitope constraints
- additional checks in some presolvers for time limit being exceeded
- fixed bug in presolving of cons_varbound with multi-aggregated variables
- improve numerics in conflict analysis by using double-double arithmetic
- fixed bound acceptance condition to avoid inconsistencies
- fixed numerics in pseudoobj propagator by using double-double arithmetic

Miscellaneous
-------------

- modified display column for memory usage ("mem"), which reports the memory usage most of the time, but shows the creator name
  (heuristic, relaxation handler, LP relaxation, strong branching, pseudo solution) of every new incumbent solution. Together with this change,
  heuristic display characters have been unified to represent the type of the heuristic
  (diving, Large neighborhood search, propagation, etc.), see also type_heur.h.
- added assert that ensures that the locks of a variable have been decreased to 0 when it is freed
- added more output for completing a partial solution
- checks in debug mode that clean buffer memory is really clean when being freed are now disabled by default
- don't compute symmetries if reoptimization is enabled
- prefer integral values when fixing an almost-fixed continuous variable in the trivial presolver
- changed the name of the variable that is added by the OSiL reader to represent the quadratic or nonlinear parts of the objective function
- SCIP_EXPORT is now defined as __attribute__((__visibility__("default"))) if GCC and no SCIP config header is used

@page RN6 Release notes for SCIP 6

@section RN602 SCIP 6.0.2
*************************

Features
--------

- The abspower constraint handler now passes more accurate convexity
  information to the NLP relaxation.

Examples and applications
-------------------------

- added parsing functionality for optcumulative constraints in CIP format

Interface changes
-----------------

### Interfaces to external software

- Updated the Mosek LP solver interface to support Mosek 9.0.

Build system
------------

### Cmake

- new target to 'doc' to build documentation
- ctests now fail if parameter file not found
- add flag STATIC_GMP and improve GMP find module
- remove non-API functions from library (API functions use new macro SCIP_EXPORT)
- increase minimal required CMake version to 3.3
- correct paths and dependency information when installing SCIP

Fixed bugs
----------
- fixed SCIP-Jack presolving bug that could lead to wrong results for Steiner arborescence problems
- fixed wrong unboundedness result in case not all constraints were already in the LP and enforcement was
  skipped because an optimal solution was found
- fixed wrong enforcement of constraints in the disjunction constraint handler
- fixed wrong behavior of concurrent solve ignoring initial solutions
- fixed bug in concurrent solve when problem was already solved in presolving
- aggregate non-artificial integer variable for XOR constraints with two binary variables and delete constraint
- copy the objective offset when copying the original problem
- fixed bug in SCIPlpiGetBInvARow in lpi_cpx using wrong size of resulting vector
- fixed quadratic runtime behavior in sepa_aggregation
- fixed statistics of separators
- improve numerical stability in varbound constraint handler by using double-double arithmetic
- fixed bug in propagation of dual proofs
- fixed bugs that arise for multiaggregated indicator variables by disallowing multiaggregation for them
- improve numerical stability in SCIPcomputeBilinEnvelope* by using double-double arithmetic
- fixed bug related to releasing pending bound changes in tree.c
- set STD FENV_ACCESS pragma to on in code that changes floating-point rounding mode
- disable GCC optimizations in main interval arithmetic code to prevent wrong optimizations
- fixed wrong assert in cons_xor concerning the variable type
- fixed different behavior of SCIPisLbBetter and SCIPisUbBetter between having NDEBUG defined or not
- correctly handle bound disjunctions in symmetry detection
- fixed issue in reliability branching related to the LP error flag not being reset
- fixed treatment of near-infinite bounds in shiftandpropagate's problem transformation
- fixed handling of infinite values in SCIPcomputeHyperplaneThreePoints()
- fixed comparisons of infinite values in heur_intshifting.c and heur_shifting.c
- fixed bug related to updating unprocessed cuts in the cutpool
- fixed bug related to enabling quadratic constraints during `CONSINITLP`
- add missing SCIP_EXPORT for functions used by GCG
- fixed memory leak and wrong initialization for trival cases in cons_symresack.c
- fixed bug with upgrading to packing/partitioning orbitopes
- fixed bug with the status while upgrading in presol_symbreak.c
- fixed wrong stage while clearing the conflict store
- fixed behavior of SCIPfixVar() by setting infeasible pointer to TRUE if fixval lies outside variable domain
- allow tightenVar() in SCIP_STAGE_PROBLEM stage
- fixed bug in cumulative constraint handler when separating the LP solution
- fixed issues with integer overflow in cumulative constraint handler
- fixed bug where the convexity of Benders' decomposition subproblems was checked even when users defined subproblem
  solving methods. Now, as per the documentation, the user must explicitly state whether the subproblem is convex
- fixed wrong indexing in heur_dualval
- fixed issue with basis status in SoPlex LPi

Miscellaneous
-------------

- statistics now output primal/dual bounds if objective limit is reached
- memory check in debug mode is now disabled by default
- message is now provided to the user to inform that automatic Benders' auxiliary variable lower bound computations are
  not activated when user defined subproblem solving methods are present
- corrected documentation of the primalgap in SCIP; describe when it will be infinite

@section RN601 SCIP 6.0.1
*************************

Features
--------

- when using a debug solution every (multi-)aggregation will be checked w.r.t. this solution

Performance improvements
------------------------

- try greedy solution first before solving knapsack exactly using dynamic programming in SCIPsolveKnapsackExactly,
  compute greedy solution by weighted median selection.
- don't consider implied redcost by default in the reduced cost propagator

Interface changes
-----------------

### Deleted and changed API functions and macros

- The preprocessor macro NO_CONFIG_HEADER now needs to be defined when
  including SCIP header files from a SCIP build or installation that
  has been build via the Makefile-only build system.

- The following preprocessor macros have been renamed:
  WITH_ZLIB to SCIP_WITH_ZLIB, WITH_GMP to SCIP_WITH_GMP, WITH_READLINE
  to SCIP_WITH_READLINE, NO_SIGACTION to SCIP_NO_SIGACTION, NO_STRTOK_R
  to SCIP_NO_STRTOK_R, ROUNDING_FE to SCIP_ROUNDING_FE, ROUNDING_FP to
  SCIP_ROUNDING_FP, ROUNDING_MS to SCIP_ROUNDING_MS. Note, however, that
  the names of macros NO_RAND_R and NO_STRERROR_R have not been changed
  so far.

### New API functions

- SCIPhashmapInsertInt(), SCIPhashmapSetImageInt(), and SCIPhashmapGetImageInt() to use integer values as images in hashmaps

### Command line interface

- warn about coefficients in MPS files with absolute value larger than SCIP's value for infinity

### Changed parameters

- default clock type for timing is now wallclock

Unit tests
----------

- added unit tests for exact knapsack solving and (weighted) median selection algorithms

Build system
------------

### Cmake

- add missing GMP dependency when compiling with SYM=bliss
- add DL library when linking to CPLEX to avoid linker errors
- new config.h header defining the current build configuration, e.g. SCIP_WITH_GMP

Fixed bugs
----------

- fixed handling of weights in cons_sos1 and cons_sos2 (NULL pointer to weights)
- fixed handling of unbounded LPs in SCIP and in several LPIs; added heuristic method to guess solution
- the STO reader is capable of handling scenarios defined using lower case "rhs"
- fixed OPB reader for instances without explicit plus signs
- correct dual solution values for bound constraints
- fixed recognition of variable with only one lock in cons_bivariate, cons_quadratic, and cons_nonlinear
- fixed update of constraint violations in solution repair in cons_bivariate, cons_quadratic, and cons_nonlinear
- print error message and terminate if matrix entries of a column are not consecutive in mps format
- fixed incorrect handling of fixed variables when transfer of cuts from LNS heuristic for Benders' decomposition
- fix returning local infeasible status by Ipopt interface if Ipopt finds problem locally infeasible
- skip attempt to apply fixings in linear constraint handler during solving stage as LP rows cannot change anymore
- fixed bug when reading >= indicator constraints in MPS format
- fix issue with nodes without domain changes if we ran into solution limit in prop_orbitalfixing
- fixed unresolved reference to CppAD's microsoft_timer() function on builds with MS/Intel compilers on Windows
- ignore implications added through SCIPaddVarImplication() that are redundant to global bounds also in the
  special case of an implication between two binary variables; also, use implications instead of cliques in the case
  of a binary implied variable with nonbinary active representative
- fixed bug with aggregated variables that are aggregated in propagation of cons_sos1
- fixed some special cases in SCIPselect/SCIPselectWeighted methods
- relaxed too strict assertion in Zirounding heuristic
- fixed the upgrade routine to XOR constraints: aggregate integer variable if its coefficient has the wrong sign
- fixed handling of nonartificial parity variables when deleting redundant XOR constraints
- earlier deletion of trivial XOR constraints (at most 1 operator left)
- fixed wrong hashmap accesses and added sanity check for the correct hashmap type
- avoid copying of unbounded solutions from sub-SCIPs as those cannot be checked completely
- corrected the output of the first LP value in case of branch-and-price
- fixed possible integer overflow, which led to wrong conclusion of infeasibility, in energetic reasoning of cons_cumulative.c

Miscellaneous
-------------

- do not scale linear constraints to integral coefficients

@section RN600 SCIP 6.0.0
*************************

Features
--------

- new diving heuristic farkasdiving that dives into the direction of the pseudosolution and tries to construct Farkas-proofs
- new diving heuristic conflictdiving that considers locks from conflict constraints
- restructuring of timing of symmetry computation that allows to add symmetry handling components within presolving
- `lp/checkstability` is properly implemented for SoPlex LPI (spx2)
- new branching rule lookahead that evaluates potential child and grandchild nodes to determine a branching decision
- limits on the number of presolving rounds a presolver (maxrounds) or propagator/constraint handler (maxprerounds)
  participates in are now compared to the number of calls of the particular presolving method, not the number of
  presolving rounds in general, anymore
- new miscellaneous methods for constraints that have a one-row linear representation in pub_misc_linear.h
- a Benders' decomposition framework has been added. This framework provides the functionality for a user to solve a
  decomposed problem using Benders' decomposition. The framework includes classical optimality and feasibility cuts,
  integer optimality cuts and no-good cuts.
- add statistic that presents the number of resolves for instable LPs
- new readers for stochastic programming problems in SMPS format (reader_sto.h, reader_smps.h)

Performance improvements
------------------------

- cuts generated from certain quadratic constraints with convex feasible region are now global
- performance improvements for Adaptive Large Neighborhood Search heur_alns.c
  + all neighborhoods now start conservatively from maximum fixing rate
  + new default parameter settings for bandit selection parameters
  + no adjustment of minimum improvement by default
- improved bound tightening for some quadratic equations
- constraint handler checking order for original solutions has been modified to check those with negative check priority
  that don't need constraints after all other constraint handlers and constraints have been checked
- deactivate gauge cuts

Examples and applications
-------------------------

- new example `brachistochrone` in CallableLibrary examples collection; this example implements a discretized model to
  obtain the trajectory associated with the shortest time to go from point A to B for a particle under gravity only
- new example `circlepacking` in CallableLibrary examples collection; this example models two problems about packing
  circles of given radii into a rectangle
- new price-and-branch application for the ringpacking problem
- new stochastic capacitated facility location example demonstrating the use of the Benders' decomposition framework

Interface changes
-----------------

### New and changed callbacks

- added parameter locktype to `SCIP_DECL_CONSLOCK` callback to indicate the type of variable locks

### Deleted and changed API functions

- Symmetry:
  + removed function SCIPgetTimingSymmetry() in presol_symmetry.h since this presolver does not compute symmetries independent
    of other components anymore
  + additional argument `recompute` to SCIPgetGeneratorsSymmetry() to allow recomputation of symmetries

- Random generators:
  + the seed of SCIPinitializeRandomSeed() is now an unsigned int
  + the seed of SCIPsetInitializeRandomSeed() is now an unsigned int and it returns an unsigned int
  + new parameter for SCIPcreateRandom() to specify whether the global random seed shift should be used in the creation of
    the random number generator

- Miscellaneous:
  + additional arguments `preferrecent`, `decayfactor` and `avglim` to SCIPcreateBanditEpsgreedy() to choose between
    weights that are simple averages or higher weights for more recent observations (the previous default).
    The last two parameters are used for a finer control of the exponential decay.
  + functions SCIPintervalSolveUnivariateQuadExpression(), SCIPintervalSolveUnivariateQuadExpressionPositive(), and
    SCIPintervalSolveUnivariateQuadExpressionPositiveAllScalar() now take an additional argument to specify already
    existing bounds on x, providing an entire interval ([-infinity,infinity]) gives previous behavior

### New API functions

- SCIPintervalSolveUnivariateQuadExpressionNegative()
- SCIPvarGetNLocksDownType() and SCIPvarGetNLocksUpType()
- SCIPaddConsLocksType()
- SCIPconsIsLockedTypePos(), SCIPconsIsLockedTypeNeg(), SCIPconsIsLockedType(), SCIPconsGetNLocksTypePos() and SCIPconsGetNLocksTypeNeg()
- SCIPstrncpy(), a safe version of strncpy()

### Changed parameters

- Removed parameters:
  - `heuristics/alns/stallnodefactor` as the stall nodes are now controlled directly by the target node limit within the heuristic
  - `presolving/symmetry/computepresolved` since this presolver does not compute symmetries independent of other components anymore
  - `separating/maxincrounds`

### New parameters

- `lp/checkfarkas` that enables the check of infeasibility proofs from the LP
- `heuristics/alns/unfixtol` to specify tolerance to exceed the target fixing rate before unfixing variables, (default: 0.1)
- `propagating/orbitalfixing/symcomptiming` to change the timining of symmetry computation for orbital fixing
- `lp/alwaysgetduals` ensure that the dual solutions are always computed from the recent LP solve
- `display/relevantstats` indicates whether the small relevant statistics are displayed at the end of solving
- `propagating/orbitalfixing/performpresolving` that enables orbital fixing in presolving
- `presolving/symbreak/addconsstiming` to change the timining of symmetry computation for symmetry handling inequalities
- `propagating/orbitalfixing/enabledafterrestarts` to control whether orbital fixing is enabled after restarts
- `benders/*` new submenu for Benders' decomposition related settings. This includes the settings related to the
  included Benders' decompositions and the general Benders' decomposition settings.
- `benders/<decompname>/benderscuts/*` submenu within each included Benders' decomposition to control the Benders'
  decomposition cuts. The cuts are added to each decomposition separately, so the setting are unique to each
  decomposition.

### Data structures

- new enum `SCIP_LOCKTYPE` to distinguish between variable locks implied by model (check) constraints (`SCIP_LOCKYPE_MODEL`)
  and variable locks implied by conflict constraints (`SCIP_LOCKYPE_CONFLICT`)
- expression interpreter objects are now stored in the block memory

Deleted files
-------------

- removed presolving plugin presol_implfree
- separated scip.c into several smaller implementation files scip_*.c for better code overview; scip.c was removed,
  but the central user header scip.h remains, which contains includes of the separated headers

Fixed bugs
----------

- fixed bug in gcd reductions of cons_linear regarding an outdated flag for variable types
- fixed bug in heur_dualval regarding fixing routine for integer variables
- suppress debug solution warnings during problem creation stage
- fixed check for activated debugging solution in components constraint handler
- fixed potential bug concerning solution linking to LP in SCIPperformGenericDivingAlgorithm()
- fixed reward computation in ALNS on continuous, especially nonlinear, problems
- fixed bug in freeing reoptimization data if problem was solved during presolving
- fixed check of timing in heur_completesol
- fixed wrong propagation in optcumulative constraint handler
- fixed non-deterministic behavior in OBBT propagator
- don't disable LP presolving when using Xpress as LP solver
- fixed possible `NULL` pointer usage in cons_pseudoboolean
- ensured that SCIPgetDualbound() returns global dual bound instead of the dual bound of the remaining search tree
- fixed rare division-by-zero when solving bivariate quadratic interval equation
- use total memory for triggering memory saving mode
- fix parsing of version number in the CMake module for Ipopt
- fixed handling of implicit integer variables when attempting to solve sub-MIP in nlpdiving heuristic
- added workaround for bug when solving certain bivariate quadratic interval equations with unbounded second variable
- fixed bug with releasing slack variable and linear constraint in cons_indicator
- fixed problem when writing MPS file with indicator constraints with corresponding empty linear constraints
- fixed bug in heur_vbound triggered when new variables were added while constructing the LP
- fixed bug with unlinked columns in SCIProwGetLPSolCutoffDistance()

Miscellaneous
-------------

- updated CppAD to version 20180000.0
- remove LEGACY mode, compiler needs to be C++11-compliant

@page RN5 Release notes for SCIP 5

@section RN501 SCIP 5.0.1
*************************

Features
--------

- SCIP executable handles the `SIGTERM` signal. If the process receives a `SIGTERM`, SCIP terminates the solution process with a
  new `SCIP_STATUS` code `SCIP_STATUS_TERMINATE` and displays all relevant statistics before exiting.
- add number of conflict constraints found by diving heuristics to statistics
- allow output of lower bounds for visualization
- added symmetry detection for linking constraints

Performance improvements
------------------------

- disable disaggregation of quadratic constraints by changing the default for `constraints/quadratic/maxdisaggrsize` to 1
  (disaggregation can still be very helpful on some instances, but also seems hurtful on others)

- Cuts:
  - increased threshold when to scale up cuts that are generated by nonlinear constraint handlers
  - test additional scaling factors in CMIR cut generation heuristic
  - cleaned up implementation of the cut selection procedure and added new cut quality measure
  - use random tie-breaking in cut selection

Interface changes
-----------------

### New API functions

- new methods SCIPtryTerminate() and SCIPterminated() in scip/interrupt.h for handling of SIGTERM signals.
- new method SCIPselectCuts() to run SCIP's cut selection procedure on a given array of cuts

### Changed parameters

- rename parameter `constraints/orbisack/orbisack/coverseparation` to `constraints/orbisack/coverseparation`

### New parameters

- `visual/displb` that enables output of lower bounds for visualization
- `presolving/symmetry/displaynorbitvars` (whether we display the number of affected variables in the statistics)
- `separating/efficacyfac` to change the weight of the efficacy in cut score calculation
- `separating/dircutoffdistfac` to change the weight of the directed cutoff distance in cut score calculation

### Data structures

- new `SCIP_STATUS` code `SCIP_STATUS_TERMINATE` in scip/interrupt.h for handling of SIGTERM signals.

Unit tests
----------

- expanded unit tests of the lpis
- added check to unit tests that problem is not solved after every change

Fixed bugs
----------

- fixed LP status to unsolved when marking LP to be resolved if objective limit has changed
- copy parameter settings to sub-SCIPs in SCIPcopyLargeNeighborhoodSearch() also when copying only LP rows
- fixed a check for fixed variables in Binpacking example
- generate deprecation warnings when using SCIPaddCut
- fix bug in sepa_gomory if cut is a bound change
- fixed handling of infinite bounds in cons_sos1

- Constraints:
  - fixed bug while scaling linear constraints
  - don't delete conflict constraints that were transformed into model constraints during a restart
  - fixed treatment of variable aggregations in knapsack constraint handler that led to wrong propagations

- LP Interface:
  - fixed LPI status after changing objective in lpi_cpx, lpi_grb, lpi_xprs, lpi_msk
  - fixed and unified asserts in LPIs
  - retrieve interior solution instead of (possibly non-existing) basic solution from mosek after using barrier without crossover in lpi_msk
  - fixed bug with `NULL` pointer handling in LPIs

- Heuristics:
  - fixed wrong cast in LP iteration limit computation in proximity search heuristic
  - fixed check for time limit in heur_nlpdiving
  - improved numerics and fixed stop criterion in zirounding heuristic

@section RN500 SCIP 5.0.0
*************************

Features
--------

- new numerical solution violations get printed when checksol is called
- added analysis of the clique table which identifies possible aggregations via the search for
  strongly connected components and may detect infeasible assignments on the way
- added macros to do computations with a higher precision by using double-double arithmetic
- extended conflict analysis by analyzing dual solutions of boundexceeding LPs
- revised internal debugging mechanism to check against a user given debug solution (debug.h)

- Heuristic:
  - add new heuristic MPEC that solves a MPEC reformulation of a mixed-binary nonlinear problem by regularized NLP reformulations
  - new primal heuristic ALNS that orchestrates eight different LNS heuristics adaptively
    using algorithms for the multi-armed bandit problem
  - three bandit selection algorithms to face sequential decision problems under uncertainty

- Presolving and symmetry:
  - added presol_symmetry.c for computing and storing symmetry information of a MIP
  - added presol_symbreak.c to detect special symmetry structures and to add symmetry handling constraints
  - SCIP can now automatically detect and compute symmetries in MIPs (if a graph automorphism code is linked in)
  - added cons_symresack.c to handle permutation symmetries in a binary programs via inequalities and propagation
  - added cons_orbisack.c to handle special permutation symmetries in a binary programs via inequalities and propagation
  - cons_orbitope.c can now handle full orbitopes as well

- Propagator:
  - added new propagator orbital fixing
  - utilizing linear inequalities to compute stronger linearizations for bilinear terms; the inequalities are computed in
    the OBBT propagator

- Cuts:
  - added API for aggregating rows for generating cuts which uses double-double arithmetic internally
  - added filtering of parallel cuts in the cut pool

- Plugins:
  + added new plugin type `table` for adding user-defined statistics tables
  + new presolving plugin presol_sparsify that tries to cancel nonzero coefficients in linear constraints by adding
    multiples of linear equalities

Performance improvements
------------------------

- use disjoint set to reduce peak memory usage and time to compute of clique table connectedness information
- add and use RESTRICT macro for some pointers
- improved the implementation of SCIPvarGetActiveRepresentatives
- speed-up reverse propagation
- removed bestrelaxsol and directly access relaxation solution instead to decrease overhead when using relaxation handlers
- for fast presolving emphasis, disable use of implications in logicor presolving
- use limit on the total number of nonzeros added to the clique table during the greedyCliqueAlgorithm of cons_knapsack.c
- revised disaggregation of quadratic constraints: the number of created constraints can now be controlled and the
  disaggregated constraints are scaled in order to increase numerical accuracy
- disabled reformulation of products of a binary variable with a linear term that does not solely involve binary variables
- speed up creation of LP in the computation of relative interior points
- improved dual ray analysis
- drop events of disabled linear constraints to reduce event processing effort

- Separation:
  - new implementation of zerohalf separator
  - enabled cutting plane separation in the tree
  - improved cut selection and management
  - improved cut post-processing: apply coefficient tightening, enforce maximal dynamism

- Heuristics:
  - improved selection of rows in CMIR aggregation heuristic
  - generate lifted flowcover cuts in CMIR cut generation heuristic
  - faster implementation of CMIR cut generation heuristic
  - use LP solution polishing during probing and diving mode to activate it during many primal heuristics; remains disabled
    during strong branching and OBBT
  - improved versions of the clique and variable bound pre-root heuristics that are often able to fix many more variables

Interface changes
-----------------

### New and changed callbacks

- New types:
  - added new abstract selection algorithm `SCIP_BANDIT` together with callbacks
  - added new types for symmetry handling

- NLP interface:
  - dropped NLP termination status `SCIP_NLPTERMSTAT_UOBJLIM`

- NLP callbacks:
  - added parameter `objval` to `SCIP_DECL_NLPIGETSOLUTION` for returning the optimal objective value (can be set to `NULL`)

- Separation callbacks:
  - added parameter `allowlocal` to `SCIP_DECL_SEPAEXECLP` and `SCIP_DECL_SEPAEXECSOL` to switch generation of locally valid cuts
  - added parameter `dstatssize` to `SCIP_DECL_NLPIDELVARSET` and `SCIP_DECL_NLPIDELCONSSET`

### Deleted and changed API functions

- Branching rules:
  - removed parameter `allowaddcons` from SCIPselectVarPseudoStrongBranching(), SCIPselectVarStrongBranching(), and
    SCIPincludeBranchruleRelpscost()

- Constraint Handlers:
  - generalized SCIPcreateConsOrbitope() and SCIPcreateConsBasicOrbitope() method to three orbitope types (full, partitioning, packing)

- Cutting plane separation methods:
  - changed function signature of SCIPcalcMIR()
  - changed function signature of SCIPcalcStrongCG()
  - new method SCIPaddRow() to replace deprecated SCIPaddCut()
  - removed parameter `scaling` from SCIPgetRowprepViolation()
  - added parameter `allowlocal` to SCIPseparateSol()

- LP interface:
  - replaced LP parameters `SCIP_LPPARAM_LOBJLIM` and `SCIP_LPPARAM_UOBJLIM` by `SCIP_LPPARAM_OBJLIM`

- NLP interface:
  - SCIPnlpStatisticsCreate() and SCIPnlpStatisticsFree() now require a pointer to blockmemory as parameter
  - added parameter `objval` to SCIPnlpiGetSolution() of NLPIs for returning the optimal objective value (can be set to `NULL`)
  - added parameter `varnameslength` to SCIPexprParse()
  - added parameter `dstatssize` to SCIPnlpiDelVarSet() and SCIPnlpiDelConsSet()
  - added modifier const to `exprtree` parameter of SCIPnlpiChgExprtree()

- Primal heuristics:
  - SCIPheurPassIndicator() has a new parameter which allows to pass the objective of the solution

- Relaxator methods:
  - added parameter `includeslp` to SCIPmarkRelaxSolValid(), SCIPsetRelaxSolVals() and SCIPsetRelaxSolValsSol();
  - removed parameter `includeslp` from SCIPrelaxCreate() and SCIPincludeRelax()
  - removed functions SCIPrelaxIncludesLp() and SCIPrelaxSetIncludesLp()
  - replaced method SCIPgetRelaxFeastolFactor() by SCIPrelaxfeastol() and added SCIPchgRelaxfeastol()

- Misc:
  - changed return type of SCIPcliqueGetId() from `int` to `unsigned int`
  - removed SCIPvarGetCliqueComponentIdx(); the connectedness information of the clique table is now stored as a
    `SCIP_DISJOINTSET` member of the clique table and cannot be publicly accessed
  - added parameter `copytables` to SCIPcopyPlugins()
  - SCIPsolveParallel() has been deprecated, use the new method SCIPsolveConcurrent() instead
  - allowed SCIPgetNConss() in stage `SCIP_STAGE_INITSOLVE`

### New API functions

- SCIPaddRow() to replace deprecated SCIPaddCut()
- methods to display linear constraint classification types; use SCIPclassifyConstraintTypesLinear()
  after reading a problem to classify linear constraint types
- public methods SCIPvariableGraphBreadthFirst() and SCIPvariableGraph{Create,Free}() to
  perform breadth-first search on the variable constraint graph used by the GINS and ALNS heuristics
- SCIPsetProbingLPState() to install given LP state and/or norms at the current probing node
- SCIPbranchcandGetLPMaxPrio() and SCIPbranchcandGetExternMaxPrio() to query the maximal branching priority of given
  branching candidates; also added SCIPbranchcandGetNPrioLPCands() to access the number of LP candidates with this priority.
- SCIPupdateSolIntegralityViolation(), SCIPupdateSolBoundViolation(), SCIPupdateSolLPRowViolation(),
  SCIPupdateSolConsViolation() and SCIPupdateSolLPConsViolation() for updating numerical solution violations, as well as
  SCIPactivateSolViolationUpdates() and SCIPdeactivateSolViolationUpdates() for activating/deactivating violation updates globally
- SCIPsetSubscipDepth() to set the depth of SCIP as a copied subproblem during problem stage
- SCIPdivesetGetNSols() to query the number of found solutions from a diveset.
- SCIPnextafter() that wraps different nextafter methods to return the next representable value after a given value
- SCIPlinConsStats{Create,Free,GetTypeCount,GetSum}() and SCIPprintLinConsStats() to work with linear constraint classification through the C API
- SCIPgetRowNumIntCols() that returns the number of integer columns in a row
- SCIPsetSlackVarUb() to control upper bound of slack variable in cons_indicator

- Data structures:
  - methods SCIPrandomCreate() and SCIPrandomFree() are no longer public and should be replaced by SCIPcreateRandom() and
    SCIPfreeRandom(), respectively (the new methods respect the global parameter `randomization/randomseedshift` automatically)
  - methods SCIPdigraphCreate() and SCIPdigraphCopy() are no longer public and should be replaced by SCIPcreateDigraph() and
    SCIPcopyDigraph(), respectively, which receive a SCIP argument and are more robust towards future interface changes

- Bilinear:
  - SCIPgetAllBilinearTermsQuadratic() to access data of all existing bilinear terms in quadratic constraints
  - SCIPaddBilinearIneqQuadratic() to propose an inequality with two variables that appear in a bilinear term
  - SCIPcomputeBilinEnvelope{1,2}() to compute a linearization of a bilinear term when considering at most two linear inequalities

- Clique:
  - SCIPcliqueGetIndex() which returns the unique identifier for the given clique
  - SCIPgetNCliquesCreated() which returns the number of cliques created so far

- Cutting plane separation methods:
  - SCIPisCutNew() that returns whether a cut is already present in the global cut pool
  - SCIPgetSepaMinEfficacy() to access separating/minefficacy(root)

- Interfaces:
  - interface methods to create and use bandit algorithms implemented as SCIP core plugins
  - interface methods for aggregating rows and computating MIP cuts, see cuts.h
  - interface method SCIPsetRandomSeed() to (re)set a random number generator seed

### Command line interface

- new interactive shell functionality to display linear constraint classification types;
  use `display linclass` after reading a problem to classify linear constraint types
- new command line parameter `-r` to pass a nonnegative integer as random seed.

### Interfaces to external software

- added interface to the NLP solver WORHP
- added interface to the NLP solver FilterSQP
- added interface to graph automorphism algorithms in `src/symmetry/` (initially only to BLISS)
- unify handling of objective limit in LPIs by replacing LPI parameters `SCIP_LPPAR_LOBJLIM` and `SCIP_LPPAR_UOBJLIM` by
  `SCIP_LPPAR_OBJLIM`
- dropped support for MOSEK < 7.0.0.0

### Changed parameters

- changed and removed several parameters for zerohalf separator
- replaced `constraints/quadratic/disaggregate` by `constraints/quadratic/maxdisaggrsize` to bound
  the total number of created constraints when disaggregating a quadratic constraint
- new value 3 for parameter `lp/solutionpolishing` to enable LP polishing only during probing and diving mode
- parameter `conflict/useboundlp` has new values `d` (only dual solution analysis) and `b` (both, conflict and dual solution analysis)

- Heuristics:
  - fixed typo `heuristics/completesol/maxunkownrate` has changed to `heuristics/completesol/maxunknownrate`
  - replaced parameter `heuristics/{clique,vbounds}/minfixingrate` by `heuristics/{clique,vbounds}/minintfixingrate` and
    `heuristics/{clique,vbounds}/minmipfixingrate`, which check the fixing rate before LP solving and after sub-MIP presolve

- Separating:
  - parameter `separating/maxstallrounds` only applies to nodes in the tree (not the root node, anymore); use the new
    parameter `separating/maxstallroundsroot` for the root node
  - moved parameters for flowcover and cmir separators to `separating/aggregation`

- Removed parameters:
  - `constraints/{abspower,bivariate,nonlinear,quadratic,soc}/scaling`
  - `constraints/{abspower,bivariate,quadratic,nonlinear}/mincutefficacysepa`
  - `constraints/{abspower,bivariate,quadratic,nonlinear}/mincutefficacyenfofac`
  - `constraints/soc/minefficacy`
  - `conflict/usemir`
  - `conflict/prefermir`
  - `heuristics/clique/{multiplier,initseed}`
  - `separating/feastolfac`
  - `separating/orthofac`
  - `separating/cgmip/allowlocal` (use parameter passed to separation callback instead)
  - `separating/{gomory,strongcg}/maxweightrange`

### New parameters

- `conflict/prefinfproof` (prefer infeasibility proof to boundexceeding proof)
- `conflict/sepaaltproofs`
- `constraints/indicator/maxsepanonviolated` to stop separation after separation of non violated cuts
- `constraints/orbisack/coverseparation` (whether orbisack cover inequalities should be separated)
- `constraints/orbisack/orbiSeparation` (whether facet defining inequalities for orbisack should be separated)
- `constraints/orbisack/coeffbound` (maximal value of coefficients in orbisack facet inequalities)
- `constraints/orbisack/checkpporbisack` (check whether orbisacks can be strengthened by packing/partitioning constraints)
- `constraints/orbisack/checkalwaysfeas` (whether conscheck returns always `SCIP_FEASIBLE`)
- `constraints/orbitope/checkpporbitope` (check packing/partitioning orbitopes)
- `constraints/orbitope/sepafullorbitope` (separate full orbitopes)
- `constraints/orbitope/checkalwaysfeas` (whether conscheck returns always `SCIP_FEASIBLE`)
- `constraints/quadratic/{usebilinineqbranch,minscorebilinterms,bilinineqmaxseparounds}`
- `constraints/quadratic/disaggrmergemethod` to change the strategy of how to merge independent blocks of quadratic constraints
- `constraints/quadratic/mincurvcollectbilinterms` to change the minimal curvature of constraints
  to be considered when returning bilinear terms to other plugins
- `constraints/quadratic/binreformbinaryonly` to disable reformulation of products of binary and non-binary variables
- `constraints/symresack/ppsymresack` (check whether symresacks can be strengthend by packing/partitining constraints)
- `constraints/symresack/checkalwaysfeas` (whether conscheck returns always `SCIP_FEASIBLE`)
- `expbackoff` to all separators which increases the frequency exponentially over the depth in the tree
- `heuristics/completesol/{beforepresol,maxlpiter,maxcontvars}`
- `heuristics/{clique,vbounds}/maxbacktracks` to limit the number of backtracks in the fix-and-propagate phase
- `heuristics/{clique,vbounds}/uselockfixings` to enable fixing of additional variables based on variable locks
- `heuristics/vbounds/{feasvariant,tightenvariant}` to specify the fixing variants used by the vbounds heuristic
- `lp/refactorinterval` to change the refactorization interval of the LP solver
- `misc/debugsol` to specify a debug solution that should be checked during the solve
- `misc/usesymmetry` to determine whether symmetry handling should be used
- `presolving/symbreak/conssaddlp` (whether symmetry handling inequalities should be added to the LP)
- `presolving/symbreak/addsymresacks` (whether symresacks should be used to handle symmetries)
- `presolving/symbreak/computeorbits` (whether symmetry orbits should be computed)
- `presolving/symbreak/detectorbitopes` (whether it should be checked if some symmetries can be handled by orbitopes)
- `presolving/symmetry/computepresolved` (Whether symmetries are computed after presolving)
- `presolving/symmetry/maxgenerators` (maximal number of generators generated by symmetry detection)
- `presolving/symmetry/checksymmetries` (whether validity of computed symmetries should be verified)
- `propagating/obbt/{itlimitfactorbilin,minnonconvexity,createbilinineqs}`
- `propagating/vbounds/minnewcliques` to specify the minimum number of new cliques to trigger another clique table analysis
- `propagating/vbounds/{maxcliquesmedium,maxcliquesexhaustive}` to limit the number of cliques relative to the
  number of binary variable for performing clique table analysis
- `separating/maxincrounds`
- `separating/maxlocalbounddist`, `separating/maxcoefratio` and `separating/intsupportfac`
- if PaPILO >= 2.1: `presolving/milp/maxbadgesizepar` to limit the maximal badge size if PaPILO is called in parallel mode
- if PaPILO >= 2.1: `presolving/milp/maxbadgesizeseq` to limit the maximal badge size if PaPILO is called in sequential mode

### Data structures

- new type `SCIP_Shortbool` (equal to uint8_t) for storing Boolean values in a more compact manner
- new disjoint set data structure `SCIP_DISJOINTSET` to incrementally update connectedness information for a graph on nodes {0,...,n-1}
- new red black tree data structure defined in `src/scip/rbtree.{c,h}`
- new object `SCIP_LINCONSSTATS`, see type_cons.h, to work with linear constraint classification through the C API
- added new type `SCIP_TABLE` together with callbacks to output SCIP statistics

Unit tests
----------

- added several tests for the LP interface
- added tests that cover nonempty linear constraint classification types
- added tests for the double double arithmetic, the new red black tree data structure, the nlpi, obbt, interval arithmetics,
  symmetry computation, objective function changes in probing, computing envelopes of bilinear function, relaxation enforcement

Build system
------------

- added interface to the NLP solver WORHP; set `WORHP=true` in order to link to WORHP
- added interface to the NLP solver FilterSQP; set `FILTERSQP=true` in order to link to FilterSQP

### Cmake

- added support for sanitizers in debug mode and options SANITIZE_ADDRESS, SANITIZE_MEMORY, SANITIZE_UNDEFINED, SANITIZE_THREAD
- added option SYM to specify which graph automorphism package (bliss, none) should be used, if available
- disable non-standard compliant floating point optimizations in combination with intel compilers
- improve Visual Studio compilation
- only accept IPOPT version 3.12.0 or higher
- preserve correct rpath in library (e.g. path to libipopt) when installing

### Makefile

- new flag `DEBUGSOL={true,false}` to enable checks against a user given debug solution
- added flag SYM to specify which graph automorphism package (bliss, none) should be used
- default value for ZIMPL in the Makefile is now `false`

Fixed bugs
----------

- fix wrong statistic display of diving leaf solutions
- fixed order of SCIPcalcCliquePartition() in corner case where no cliques are available
- fix treatment of infinite lower bound in proximity objective cutoff
- fixed minor issue in expression graph simplification

- Separator:
  - fix linear knapsack relaxation during separation if a binary variable does not have a solution value in [0,1].
  - fixed potential ressource leaks in SCIPsolveLinearProb(), expr.c, sepa_eccuts, cons_cumulative.c, cons_nonlinear.c
  - fixed bug in cons_orbitope.c, where wrong terminating index in separation of SCIs was used
  - fixed wrong mapping of permuted basis indices in gomory separator
  - fixed integer objective separator for objective scales < 1

- Presolver:
  - fixed numerical issues in boundshift presolver when aggregating integer variables
  - fixed aggregation of variables in boundshift presolver that contain large variable bounds

- Heuristic:
  - fixed bug in feasibility pump heuristic when switching on the `usefp20` parameter
  - fixed handling of LOOSE variables in locks heuristic
  - fixed creation of conflicts in clique heuristic for incomplete LPs

- Constraints:
  - fixed bug in mps reader. Reader now prints `OBJSENSE` section and tries to generate unique names of constraints
  - fixed upgrade to a varbound constraint if abspower constraint contains a multi-aggregated variable
  - fixed several bugs related to hashing of constraints/rows in cutpool.c and cons_linear.c
  - fixed registration of almost fixed nonlinear variables in abspower constraints

- Propagator:
  - fixed releasing of variables in the genvbounds propagator in case the problem could be solved during presolving of a restart
  - fixed numerical issues in bound widening of variable bound constraint handler and vbound propagator during conflict analysis

@page RN4 Release notes for SCIP 4

@section RN401 SCIP 4.0.1
*************************

Features
--------

- added parsing functionality to cardinality constraint handler for CIP format
- allow to relax objective limit in reoptimization in presolved stage
- suppress excessive printing about numerical troubles in LP on default verblevel (high)

Performance improvements
------------------------

- only accept passed improving solutions in heur_indicator
- add and use RESTRICT macro for some pointers
- sorting of parents and children for some expression types is now independent of memory layout

- Constraints:
  - widened a bottleneck in simplifying long signomial sums in a nonlinear constraint
  - unified and extended code that improves numerics of cuts generated by nonlinear constraint handlers

- Separation:
  - stop separation in cons_indicator after maxsepanonviolated many non violated separated cuts
  - improve choice of variable to enter support in separation of cons_indicator

Interface changes
-----------------

### New API functions

- SCIPvalidateSolve() to compare solving result with an external primal and dual reference value
- SCIPisObjChangedProbing() to check whether the objective function has changed during probing mode
- SCIPgetDualSolVal() to get the dual solution value of a constraint
- SCIPisLPPrimalReliable() and SCIPisLPDualReliable() to check whether the current primal / dual LP solution
  were successfully checked for feasibility

### Command line interface

- New option in the interactive shell to validate the solution against an external primal and dual reference value
- added command line option `-o` and command `validatesolve` in interactive shell
  to validate the solution against an external primal and dual reference value.

### Interfaces to external software

- Updated and new interfaces to Mosek 8.1, GAMS and Gurobi
- new LP interface to Glop (Google OR tools); CMake only

### Changed parameters

- renamed parameter `heuristics/completesol/maxunkownrate` to `heuristics/completesol/maxunknownrate`

Testing
-------

- add options to make test target (see Makefile section)

Build system
------------

### Cmake

- New CMake build system alongside the usual Makefile setup

### Makefile

- added make options for specifying EXECUTABLE and OUTPUTDIR variables for the make test target

Fixed bugs
----------

- fixed unintended behavior of interrupt signal handler inside SCIP copies
- fixed uninitialized values in SCIP's digraph data structure after calling SCIPdigraphResize()
- fixed issue related to SCIPcreateFiniteSolCopy() not being able to remove all infinite fixings
- fixed issue in SCIPcopyLimits() w.r.t. soft time limit
- fixed bug in dynamic resizing of hashtables and hashmaps
- added workaround for bug in primal simplex of cplex 12.7.1.0 occuring when attempting to solve LPs without rows without presolving
- fixed bug in binpacking example that might have led to doing the same branching several times
- fixed memory issue in binpacking example
- in GAMS writer, forbid also various parenthesis characters in gams symbol names
- added missing definition of `SCIP_UNUSED` in memory.h if def.h is not included
- treat reopt bugs: Avoid numerical problems with changing objective; fix check for changed objective
- fixed reading issue in mps reader: integer variables fixed to 0 or 1 are treated as binaries now,
  allowing to use them as indicator variables
- afternode heuristics are now called even if the node limit was reached and the solving process will be stopped
  after the current node
- fixed bug when activating probing mode with a non-empty separation storage

- LP interfaces:
  - fixed guard against using old Gurobi versions in lpi_grb.c: Gurobi 7.5 was not permitted
  - fixed wrong handling of unboundedness status in lpi_grb.c
  - fixed wrong handling of row basis status in lpi_grb.c

- Propagator:
  - fixed bug in shift and propagate--variable information with a negation transformation is correctly reset after backtracking
  - fixed bug in genvbounds propagator when applying a restart after the root node

- Constraints:
  - fixed bug in varbound coefficient tightening: if a varbound constraint only contained one variable afterwards,
    it may have been deleted without applying the induced bound, if the change was too small, this is now forced
  - fixed potential wrong locks update after a varbound constraint became redundant in coefficient tightening
  - fixed potentially wrong cleanup of fixed variables in nonlinear constraint handler
  - fixed memory leak in OSiL reader when using SOS constraints

- Solution:
  - improved handling of infinite values in a primal solution in quadratic and nonlinear constraints
  - fixed bug in computing violation and cut for certain nonlinear constraints when LP solution is slightly out of bounds
  - fixed debug solution check that appeared in probing mode when the objective function has changed
  - relaxed a too strong assert concerning solutions close to the objective limit

@section RN400 SCIP 4.0.0
*************************

Features
--------

- Introduced support for partial or infeasible user solutions, which SCIP tries to complete/repair heuristically
- implemented linear time methods for (weighted) median selection for joint arrays of various types
- added adaptive solving behavior of SCIP based on solving phases and heuristic transitions, if enabled via `solvingphases/enabled`
- can now solve relaxations within probing
- in case of multiple relaxators the best solution is saved instead of the last one
- added write callback for reader_bnd
- added possibility to use a reference value for advanced analysis of the tree search. If a finite reference value
  (an objective value in original objective space) is passed via misc/referencevalue, SCIP keeps track of the
  number of nodes exceeding the reference value and the number of early backtracks -- path switches in the tree when
  a child node with lower bound smaller than the reference value was available.
- added reading capabilities for partial solutions with extension *.mst
- new global shift off all random seeds (randomization/randomseedshift) and unification of all existing random seeds
- use new macros SCIPdebugMsg(), SCIPsetDebugMsg(), SCIPstatDebugMsg() at all places where it makes sense
- new random number generator in pub_misc.h
- add check whether variables have been released when freeing SCIP
- a print callback can now be specified for user expressions

- LP Solutions:
  - will now enforce relaxation solution instead of lp or pseudosolution if lowerbound is better and the whole lp is included in the relaxation
  - new feature solution polishing to improve integrality of LP solutions

- Constraints:
  - new constraint handler for cardinality constraints
  - added interval-evaluation of sine and cosine
  - allow to create constraints of constraint handlers that don't need constraints
  - New constraint handlers cardinality and components

- Conflicts:
  - implement a storage for conflicts to have more control over active conflicts
  - Improved conflict analysis through central conflict pool and dual ray analysis for primal infeasible LPs; can now analyze dual
    unbounded rays of primal infeasible LPs

- Presolving:
  - New presolvers that disaggregate SOC constraints and reformulate QP's by adding KKT conditions
  - new presolving step for variables contained in a single quadratic constraint with proper square coefficients
  - add new presolving step to disaggregate second order cone constraints
  - new presolving method presol_qpkktref to add the KKT conditions of a QP
  - implemented and extended stuffing presolving in linear constraint handler
  - new components constraint handler which replaces the components presolver; it searches for independent subproblems
    and solves small ones as sub-SCIPs during presolve, larger ones are solved alternatingly during the main solving process
  - new presolving timing FINAL: presolving methods with this timing are only called once after all other presolvers with timings
    FAST, MEDIUM and EXHAUSTIVE are finished; during this timing only reductions are allowed that are self-contained, e.g.,
    fixing all variables and deleting all constraints of an independent component; note that reductions found in this timing
    do not trigger a new presolving round

- Separation and Cuts:
  - can now separate perspective cuts for indicator constraints
  - add sepa_convexproj, a separator which projects onto convex relaxation and build gradient cuts at the projection
  - add sepa_gauge, a separator which computes an interior point of a convex relaxation and performs a binary search in the segment joining
    the interior point and the point to separate until it finds a point in the boundary of the feasible region where to build a gradient cut
  - changed handling of coupling constraints in cons_indicator; the cuts will not be added to the pool, but are separated by default
  - concurrent solving mode that allows to run multiple SCIP instances, that share solutions and global variable bounds, in parallel
  - Revised pseudo random number generation and introduced central random seed for all plugins

- Heuristics:
  - new Graph induced neighborhood search (GINS) primal heuristic that uses neighborhoods
    based on distances in the variable constraint connectivity graph.
    In addition, the heuristic supports a rolling horizon-like procedure to solve auxiliary problems
    for neighborhoods with increasing distance from the starting neighborhood.
  - new primal heuristic LP face that tries to find an integer solution inside the optimal LP face.
  - new heuristic that tries to complete partial solutions
  - the subnlp heuristic now gives ownership of a found solution to the heuristic that constructed the starting point, if any;
    as a consequence, MIP heuristics may now be shown more frequently for having found a solution when solving MINLPs, even
    though the solutions required an additional NLP solve
  - new multistart heuristic for NLPs

- Propagator:
  - add prop_nlobbt, a nonlinear optimization-based bound propagator solving two convex NLP relaxations for each variable
  - nodes can now be postponed; currently, this can only be triggered by BEFORELP propagation callbacks

- Statistic:
  + Extended statistic output displayable via the interactive shell
  + new statistic computed: `Root LP Estimate` that shows the root LP best-estimate with every pseudo-cost update
  + added leaf statistics about LP objective limit|feasible|infeasible leaves to the statistics output and
    to the callable library: SCIPgetNObjlimLeaves(), SCIPgetNFeasibleLeaves(), SCIPgetNInfeasibleLeaves()
  + next to the number of found solution, also the number of new best solutions is now printed for each heuristic
    (and relaxation solutions) in the statistics in the `Primal Heuristic` section.

Performance improvements
------------------------

- Extended the presolving timings by an additional timing FINAL for self-contained reductions
- Randomized tie-breaking in different parts of the code to reduce performance variability
- use connectedness information of the clique table to speed up the clique partitioning algorithm
- knapsack approximation algorithms use linear-time weighted median selection instead of sorting
- improved greedy solution in SCIPsolveKnapsackApproximatelyLT() for the flow cover separation
- reduce performance variability by using random numbers as tie-breaker for external branching candidates

- Heuristics:
  - adjusted most Large Neighborhood Search heuristics such that they collect their variable fixings first in an array,
    and only create and populate a sub-SCIP if enough variables will be fixed.
  - reduce performance variability by using a small perturbation in the undercover heuristic
  - 1-opt heuristic can now be repeatedly executed as long as new incumbents are found

- Constraints:
  - Improved and extended stuffing inside of linear constraint handler
  - Changed handling of coupling constraints in cons_indicator
  - SCIP supports constraint compression for problem copies; constraint compression denotes the immediate
    removal of fixed variables from constraint data at creation time to reduce memory requirements.

- Propagation:
  - rewrote the propagate-and-cut-and-price loop so that successful propagations with DURINGLPLOOP timing, bound changes found by separation,
    and new primal solutions now trigger a new round of node solving, starting with propagation; improved tuning of propagation and heuristic timings
  - tuned propagation methods of several constraint handlers
  - make more use of SCIPmarkConsPropagate() to mark constraints for propagation and improved the internal handling of marked constraints
  - improve propagation of absolute-value expression in the case that the sign of the argument is fixed

Interface changes
-----------------

### New and changed callbacks

- Concurrent SCIP:
  - extended interface to support concurrent solving mode

- Constraint Handlers:
  - new optional callback `CONSENFORELAX` to enforce a relaxation solution, see \ref CONS
  - `CONSINITLP` callback now has a new parameter `infeasible`, which is a pointer to store whether infeasibility
    was detected while building the initial LP relaxation

### Deleted and changed API functions

- setting a parameter to a non-valid value now produces an error message instead of a warning
- bound reader uses angle bracket around variable names
- the parameters of SCIPlpiChgObj(), SCIPlpiSetBase(), SCIPlpiSetState(), SCIPlpiSetNorms() have been declared as const
- SCIPapplyHeurSubNlp() can now return the solution found by the sub-NLP heuristic

- Random:
  - methods SCIPrandomGetInt() substitutes SCIPgetRandomInt() (marked to be deprecated)
  - methods SCIPrandomGetReal() substitutes SCIPgetRandomReal() (marked to be deprecated)
  - methods SCIPrandomPermuteArray() substitutes SCIPpermuteRandomArray() (marked to be deprecated)
  - methods SCIPrandomPermuteIntArray() substitutes SCIPpermuteRandomIntArray() (marked to be deprecated)
  - method SCIPrandomGetSubset() substitutes SCIPgetRandomSubset() (marked to be deprecated)

- Conflict Analysis:
  - added parameters `conftype` and `iscutoffinvolved` to SCIPinitConflictAnalysis()
    that indicate the type of the conflict and whether the current cutoff bound is used or not

- Constraint Handlers:
  - added parameter `infeasible` to SCIPinitlpCons()

- Copying:
  - added parameters `fixedvars`, `fixedvals`, `nfixedvars` to SCIPcopyVars()
  - added parameters `fixedvars`, `fixedvals`, `nfixedvars` to SCIPcopyOrigVars()
  - renamed parameter `success` to `valid` in SCIPgetConsCopy()

- Hashmap and Hashtable:
  - removed function SCIPcalcHashtableSize() since not required anymore for `SCIP_HASHTABLE` and `SCIP_HASHMAP`
  - based on the initial size `SCIP_HASHTABLE` and `SCIP_HASHMAP` choose an appropriate size internally to allow insertion of that
    many elements without resizing
  - `SCIP_MULTIHASH` behaves like the old `SCIP_HASHTABLE` and SCIPcalcMultihashSize() should be used as replacement for
    SCIPcalcHashtableSize()

- Nonlinear Relaxation:
  - added parameter `curvature` to SCIPcreateNlRow()

- Parameters:
  - the following new methods return a bool indicating whether the given value is valid for the parameter instead of printing a warning
    message and returning an error code if the value is invalid
    - renamed method SCIPcheckBoolParam() to SCIPisBoolParamValid()
    - renamed method SCIPcheckLongintParam() to SCIPisLongintParamValid()
    - renamed method SCIPcheckCharParam() to SCIPisCharParamValid()
    - renamed method SCIPcheckStringParam() to SCIPisStringParamValid()
    - renamed method SCIPcheckRealParam() to SCIPisRealParamValid()
  - in param.c/h: the new methods return a bool whether the given value is valid for the parameter instead of printing a warning message
    and returning an error code if the value is invalid
    - rename SCIPparamCheckBool() to SCIPparamIsValidBool()
    - rename SCIPparamCheckString() to SCIPparamIsValidString()
    - rename SCIPparamCheckChar() to SCIPparamIsValidChar()
    - rename SCIPparamCheckLongint() to SCIPparamIsValidLongint()

- Primal Heuristics:
  - added parameter `initialseed` to SCIPcreateDiveset()
  - introduced new type `SCIP_HEURTIMING` for primal heuristic timing masks
  - changed type of parameter `timingmask` from unsigned int to `SCIP_HEURTIMING` in SCIPincludeHeur(), SCIPincludeHeurBasic()

- Relaxators:
  - new parameter `includeslp` for SCIPincludeRelax() and SCIPincludeRelaxBasic()
    to indicate whether relaxation includes all linear rows and can be enforced

- Reoptimization:
  - rename method SCIPgetReopSolsRun() to SCIPgetReoptSolsRun()

- Solutions:
  - added parameter `completely` to SCIPtrySol(), SCIPtrySolFree(), SCIPcheckSol() to check all constraints when
    printing violations

- Variables:
  - removed SCIPvarGetLbAtIndex() and added SCIPgetVarLbAtIndex()
  - removed SCIPvarGetUbAtIndex() and added SCIPgetVarUbAtIndex()
  - removed SCIPVarGetBdAtIndex() and added SCIPgetVarBdAtIndex()
  - removed SCIPvarWasFixedAtIndex() and added SCIPgetVarWasFixedAtIndex()
  - Removed method SCIPvarGetNBinImpls()

### New API functions

- added functions for concurrent solving mode (see concurrent.h, concsolver.h)
- SCIPcreateNlpiProb(), SCIPupdateNlpiProb() and SCIPaddNlpiProbRows() to create and update a nonlinear relaxation
- SCIPgetNObjlimLeaves(), SCIPgetNFeasibleLeaves(), SCIPgetNInfeasibleLeaves() for statistics output
  about LP objective leaves
- SCIPcheckCopyLimits() which can be used to check that enough time and memory is left to run a sub-SCIP after
  subtracting time and memory used by the main-SCIP and SCIPcopyLimits() which copies these limits accordingly and disables
  all other limits (need to be set by the plugin, if needed)
- SCIPcopyLargeNeighborhoodSearch() in heuristics.h that supports compressed copying and two kinds of problem copy: the MIP-relaxation or
  a 1-1 problem copy (by copying the constraints and not the LP relaxation)
- SCIPsolveProbingRelax() to solve a relaxation within probing
- SCIPgetLastStrongbranchingLPSolstat() to query the LP statuses after strong branching on a variable
- SCIPinitializeRandomSeed()
- SCIPswapReals() to swap two real values
- SCIPgetNNZs() to get the number of active non-zeros in the transformed/presolved problem

- Debug Messages:
  - SCIPprintDebugMessage(), SCIPsetPrintDebugMessage(), SCIPstatPrintDebugMessage() that output debug messages and also print the
    subscip depth; the first two output via the message handler; also added macros SCIPdebugMsg(), SCIPsetDebugMsg(), SCIPstatDebugMsg()
  - SCIPdebugMsgPrint()/SCIPsetDebugMsgPrint() that output a message without `[debug]` prefix via the message handler (compare SCIPdebugPrintf())

- Solution:
  - SCIPisDualSolAvailable() to query the dual solution availability
  - SCIPlpiSetIntegralityInformation() to improve SoPlex' solution polishing

- Constraints:
  - library methods SCIPcopyConsCompression(), SCIPcopyOrigConsCompression() that accept an array of variables that are immediately
    fixed in the copy. Alternatively, local instead of global bounds can be used for compression.
  - library methods SCIPenableConsCompression(), SCIPisConsCompressionEnabled(), SCIPcopyConsCompression(), SCIPcopyOrigConsCompression()
  - SCIPgetIntVarXor() to access integer variable of XOR constraints
  - SCIPcreateConsCardinality() to create a cardinality constraint
  - SCIPcreateConsBasicCardinality() to create a basic cardinality constraint
  - SCIPchgCardvalCardinality() to changes cardinality value of cardinality constraint (i.e., right hand side of cardinality constraint)
  - SCIPaddVarCardinality() to add a variable to a cardinality constraint
  - SCIPappendVarCardinality() to append a variable to a cardinality constraint
  - SCIPgetNVarsCardinality() to get the number of variables in a cardinality constraint
  - SCIPgetVarsCardinality() to get the array of variables in a cardinality constraint
  - SCIPgetCardvalCardinality() to get the cardinality value of a cardinality constraint (i.e., right hand side of cardinality constraint)
  - SCIPgetWeightsCardinality() to get the array of weights of a cardinality constraint
  - SCIPgetLinvarMay{Decrease,Increase}Quadratic() to get index of a variable in linear term of quadratic constraint that may be decreased
    without making any other constraint infeasible

- Parameters:
  - add SCIPparamIsValidInt() and SCIPparamIsValidReal() to param.c/h
  - add missing functions SCIPisIntParamValid() and SCIPisRealParamValid() to scip.c/h

### Command line interface

- new command line parameter `-v` to print detailed build options

### Interfaces to external software

- Interfaces for Python and Java are, among others, now available via http://www.github.com/scip-interfaces
- Revised documentation of the SCIP C-API to group methods more comprehensively by topics
- dropped support for Ipopt < 3.11
- Additional I/O-functionalities for debugging and logging in SCIP and in the AMPL interface
- updated CppAD to 20160000
- for users of the ampl interface, the display/logfile option has been added to set the name of a
  file to write the SCIP log to (additionally to stdout)

- LP Interfaces:
  - SCIP uses the lpi_spx2 interface by default
  - Improved Gurobi interface that can handle ranged rows (requires Gurobi >= 7.0.2)
  - the CPLEX LPI now also compiles with CPLEX 12.7.0.0

### Changed parameters

- setting a value for a fixed parameter will no longer return with an error, if the new value equals the one to which the parameter is fixed
- changed value of parameter `separating/clique/cliquedensity` to 0.0 such that the separator always constructs a dense clique table
  which proved to be faster on the benchmarks MMM and stableset.
- parameters `misc/permutationseed`, `misc/permuteconss` and `misc/permutevars` changed to `randomization/permutationseed`,
  `randomization/permuteconss` and `randomization/permutevars`
- parameters `conflict/useinflp` and `conflict/useboundlp` are now of type char (before bool)
- all parameters of the components presolver (starting with `presolving/components/`) are now parameters of the components
  constraint handler (starting with `constraints/components/`)

### New parameters

- class randomization
- `branching/sumadjustweight` to adjust branching scores by adding a sum epsilon in order to keep score differences
  near zero, which are otherwise completely disregarded (they are adjusted to at least sum epsilon)
- `concurrent/* ` and `parallel/* ` for configuring the concurrent solving mode
- `constraints/cardinality/branchbalanced` to decide whether to use a balanced branching scheme in the enforcing of cardinality
  constraints
- `constraints/cardinality/balanceddepth` to set the maximal depth until balanced branching is turned off
- `constraints/cardinality/balancedcutoff` to determine that balanced branching is only used if the branching cut off value
  w.r.t. the current LP solution is greater than a given value
- `constraints/indicator/sepaperspective` to turn on separation of perspective cuts for indicator constraints
- `constraints/indicator/sepapersplocal` to decide whether local cuts can be used for perspective cuts for indicator constraints
- `constraints/quadratic/projectedcuts` to enable convex quadratics to generate gradients cuts at the
  projection of the point onto the region described by the constraint, which is supporting
- `lp/solutionpolishing` to enable LP polishing only at the root LP or always
- `misc/referencevalue` to pass a reference value for further analysis of the tree search, see also in `features`
- `presolving/qpkktref/addkktbinary` to allow the presence of binary variables for the KKT update
- `presolving/qpkktref/updatequadbounded` to add the KKT conditions to QPs only if all variables are bounded
- `presolving/qpkktref/updatequadindef` to add the KKT conditions to QPs only if the quadratic matrix is indefinite
- `randomization/lpseed` to set the initial seed of the LP solver
- `solvingphases/enabled` to activate adaptive behavior during the solution process; several further parameters
  in the solvingphases-section to control how to switch the parameters and whether a restart should be performed between the phases.

### Data structures

- new `SCIP_REGRESSION` data structure in pub_misc.h to incrementally compute a best-fit line through pairs of observations
- add maximum branch-and-bound tree depth constant `SCIP_MAXTREEDEPTH` (replaces SCIPgetDepthLimit() and SCIPtreeGetDepthLimit())
- new files heuristics.c/heuristics.h to collect methods that are frequently used by heuristics
- merged dive.c/pub_dive.h with heuristics.c/heuristics.h, removed dive.c/pub_dive.h
- separated header pub_misc.h from repeated methods for sorting and (weighted) median selection;
  those are also available in separate headers pub_misc_sort.h
  and pub_misc_select.h, but included into pub_misc.h

Unit tests
----------

- New unit testing system built on the Criterion framework

Build system
------------

### Makefile

- All makefiles in `examples/` and `applications/` have been updated.
- `make.project` defines a variable `SCIP_VERSION` containing the SCIP version number
- revise sub-makefiles for MSVC on MinGW
- make shared libraries aware of their dependencies
- sub-makefile for CrayXC systems added

- Places:
  - All objective files are now placed in `obj/static` or `obj/shared`, depending on `SHARED=false` or `SHARED=true`, respectively.
  - All internal and external libraries are placed in `lib/static` and `lib/shared`, the include files are in `lib/include`.
  - The binaries now contain an rpath to the SCIP directory, such that shared libraries are found.

- Linking:
  - link binary to shared libs when compiling with `SHARED=true`
  - External projects (including make.project) can use the makefile variable LINKCXXSCIPALL or LINKCCSCIPALL to link all SCIP libraries.
  - Building with `SHARED=true` automatically generates the combined library libscipsolver.so for easier linking

- Targets:
  - Running `make help` lists all makefile options.
  - `make install` copies now all header files
  - new target `dll` to build Windows dlls with MSVC
  - rename `dll` target to `windowslib`

Fixed bugs
----------

- fixed bug in event system: bound change events of the new focus node must be processed, even if the bound
  is the same as at the last focus node
- avoid numerically unstable (multi-)aggregations
- fixed bug in XML reader concerning comments
- the AMPL interface now writes a solve status (solve_result_num) into the .sol file
- in the cmpres.awk (allcmpres.sh) output, the counts in the time column are now with respect to the
  whole set of processed instances (as with fail and solv), while before it was with respect to the
  set of instances where no solver failed (eval set); thus, now proc = fail + time + solv.
- writing of solutions or parameters to a file now works also with the message handler set to quiet
- ignore lower and upper bound tightenigs beyond +/-infinity during solving
- time limit of SCIP-infinity is converted to LPI-infinity when setting it
- fix LP activity of a row that has been modified

- Propagation:
  - fixed possible segmentation fault in genvbounds propagator
  - fixed bug with sorting of propagators in presolving: the order can be changed by calling probing; thus, there is a copy of the
    propagators, which is sorted by presolving priority
  - added missing capturing and releasing mechanism in genvbounds propagator
  - fix wrong propagation of product expressions

- Constraints:
  - fixed wrong representation of SOC constraints in NLP
  - fixed a few issues within redundant constraint detection of (specialized) linear constraint handlers
  - fixed issue in reader_opb concerning writing of fixed variables contained in no constraints

- Memory:
  - fixed memory bug in `SCIP_DIGRAPH`
  - improved counting of memory consumption by using more block memory and counting all allocated memory
  - fix memory leaks in TSP example
  - return `SCIP_ERROR` when a memory exception is caught in SoPlex (was `SCIP_LPERROR`)
  - fixed memory leak in OSiL reader

- Objective:
  - fixed bug while changing the objective value of an original value after transforming the problem
  - fixed bug with solutions from previous runs not satisfying an objective limit
  - SCIPisObjIntegral() now works correctly in `SCIP_STAGE_PROBLEM`

- Heuristics:
  - fixed two bugs in heur_indicator: use improvesols parameter now and update pointer to indicator constraint handler
  - fix wrong NLP representation of logic-or constraints in the dual value heuristic
  - correct handling of implicit integer variables with fractional solution value in simplerounding heuristic
  - fixed bug in heur_octane with uninitialized ray direction

@page RN3_2 Release notes for SCIP 3.2

@section RN321 SCIP 3.2.1
*************************

Features
--------

- new `force` parameter in (root)redcost propagator to run the propagator also with active pricers

Performance improvements
------------------------

- do not transfer solutions to original space, if SCIP is being freed
- modified implication graph analysis of SOS1 constraint handler; a new component allows to deduce zero fixings of variables
- made SOS1 constraint handler specific diving selection rule faster for the case that the SOS1 constraints do not overlap
- improved disjunctive cuts by the `monoidal cut strengthening` procedure of Balas and Jeroslow

Examples and applications
-------------------------

- several improvements of SCIP-Jack (STP application): extended presolving for STP variants, STP-specific branching
  rule, dual heuristic to generate initial LP relaxation
  SCIP-Jack is now competitive with problem specific state-of-the-art solvers on several well-known STP variants,
  e.g., the (rooted) prize-collecting Steiner tree problem.
- MultiObjective application renamed to PolySCIP; several improvements: better command line argument processing,
  overhaul of much of the source code, installation via CMake

Interface changes
-----------------

- made debug solution functionality thread safe (see debug.h for further information)

### Deleted and changed API functions

- add SCIPcomputeHyperplaneThreePoints() to compute a hyperplane containing three given 3-dimensional points
- SCIPsolveLinearProb() now uses a 1-dimensional matrix representation

### Command line interface

- added interactive shell command `display finitesolution` to print solution with infinite fixings removed,
  added reference to that method to `display solution` output if there are infinite fixings
- new interactive shell command `write history` to write the command line history (only when compiled with Readline)

### Interfaces to external software

- significantly improved Python interface to support user callbacks as well as linear and quadratic expressions

### New parameters

- `constraints/sos1/branchingrule` to decide whether to use neighborhood, bipartite, or SOS1 branching (this parameter
  replaces the old parameters `constraints/sos1/neighbranch`, `constraints/sos1/bipbranch`, and `constraints/sos1/sos1branch`)
- `constraints/sos1/depthimplanalysis` to limit the number of recursive calls of implication graph analysis
- `constraints/sos1/perfimplanalysis` to perform an implication graph analysis to deduce variable fixings and
  additional SOS1 constraints (this parameter replaces the old parameter `constraints/sos1/updateconflpresol`)
- `misc/transsolorig` for transfering transformed solutions to the original space (default: true)
- `propagating/rootredcost/onlybinary` to propagate root reduced costs of binary variables only

### Data structures

- renamed MIP matrix structure to `SCIP_MATRIX`
- changed the numeric values for `PRESOLTIMING` flags

Build system
------------

### Makefile

- new target `dll` to build Windows dlls with MSVC
- add new compiling flag OPENSOURCE to allow/forbid the usage of third party software

Fixed bugs
----------

- fixed wrong objective sense when copying the original problem
- fixed a bug in merge step of cliques during clean up phase; method did not correctly handle infeasibility in the case of multiple
  variable-negation pairs
- fixed a previously untreated case in the linear cons simplification where coefficients only differ by slightly more than an epsilon
- fixed bug in parsing emphasis parameters which formerly led to completely wrong results
- fixed bug in the computation of the Wilcoxon test
- do not use the relative and absolute gap limit if no primal solution has been found so far
- fixed bug in conflict.c with wrong reset of bounds used
- fixed bug with transferring solutions to new runs (need to recompute objective before checking)
- fixed issue with infinite values when checking cuts for redundancy
- fixed library problems on Windows operating systems

- Variables:
  - fixed wrong check when computing cuts for factorable quadratic functions bound tightening of a single variable
  - fixed wrong handling of loose variables in OBBT
  - fixed freeing of hash for binary variables
  - fixed bug during the computation of branching points for continuous variables which are almost fixed to +/- SCIPinfinity()
  - treated the case of integer variables as intermediate variables in the process of obtaining the active variable for a
    given binary variable

- LP:
  - fixed a bug in dive.c that occurred when lpsolvefreq was set to 1; after a cutoff, the solution values of the
    linked LP solution might have become invalid
  - do not analyse an infeasible LP for conflicts during diving mode when LHS/RHS of rows were changed
  - use LPi infinity when reverting bound changes in conflict analysis

- Heuristics:
  - fixed bug in heur_simplerounding in connection with relaxators
  - fixed bug in feaspump heuristic where last solution candidates were not updated correctly
  - fixed bug with infinite shift values in heur_shifting
  - fixed bug in shiftandpropagate heuristic: the heuristic did not correctly handle intermediate, global bound changes of the selected variable
    after its tentative fixing led to a cutoff.

- Propagator:
  - (root) reduced cost propagators are not run anymore when doing branch-and-price,
    since they may install upper bounds on variables which might interfere with the
    pricing (they may be enabled again by their force parameters)
  - fixed too hard assertion in pseudoobj propagator
  - fixed a bug in shiftandpropagate where column positions after sorting are now correctly linked to their variables after sorting
  - fixed potential memory leak in genvbound propagator

- Presolving:
  - fixed inconsistency in knapsack constraint handler data during presolving
  - fixed some problem with reoptimization when the problems are infeasible or have been solved in presolving
  - fixed endless loop in knapsack constraint handler when continuous variables change their types to binary during presolving
  - squares of binary variables might not have been replaced by the binary variable itself in presolve,
    if the variable was originally general integer and only became binary during presolve (due to bound tightening)
  - fixed bug in dive.c avoiding a check of constraints in the presence of indicator constraints

- Constraints:
  - fixed numerical problems in computation of cuts for bivariate functions in quadratic constraint handler
  - fixed bug in quadratic constraint handler when computing lifted-tangent inequalities
  - fixed bug in nonlinear constraint handler when replacing a violated nonlinear constraint leads to an infinite
  - fixed bug in SOS1 constraint handler with inconsistent data structure after restart
  - fixed wrong handling of negated variables in bound tightening procedure of SOS1 constraint handler
  - fixed bug in simple fixing heuristic of SOS1 constraint handler
  - fixed two bugs in pseudoboolean constraint handler with wrong sorting of and constraints
  - fixed issue: constraints being parallel to objective function (after restart) sometimes led to wrongly stating infeasible
  - fixed bug during coefficient tightening in varbound constraint handler
  - handle cutoffs in cons_indicator detected by infeasible inequalities
  - fixed late change of type of slack variables in cons_indicator, if the bounds are not integral
  - fixed initsol and exitsol of cons_indicator, if problem has already been solved
  - fixed bug in cons_indicator with changing type of slackvariable

@section RN320 SCIP 3.2.0
*************************

Features
--------

- added reoptimization feature for optimization problems with changed objective function or tighter feasible region
- the original problem can now be permuted directly after reading (if `misc/permutationseed` has value >= 0)
- added methods to compute strongly connected components with Tarjan's Algorithm
- added method to propagate implications of SOS1 variables
- convex quadratic contraints can now generate gradient cuts which are supporting to the feasible region
- SoPlex interface can now (re)store dual steepest edge weights
- extended expression parsing to support power, realpower and signpower operators; started support for user-defined operators
  in expression trees/graphs
- possibility to set a soft time limit which becomes active only after the first primal solution was found
- added matrix module for getting access to the internal mixed inter linear problem matrix
- better handling of large values returned by the LP solver
- added more checks to SCIP{alloc,realloc,duplicate}BufferArray() to handle overflows properly
- new plugin for reoptimizing a sequence of optimization problem that differ in the objective function, e.g., sequences arising from
  column generation
- new plugin `compr` for rearranging the search tree, currently this only works on the reoptimization tree
- moved assertions in comparison methods from scip.c to set.c

- Constraints:
  - we can now upgrade quadratic constraints with one bilinear term to SOC constraints
  - we can also upgrade general quadratic constraints with a single negative eigenvalue to SOC constraints

- Branching:
  - tighter reliability notions introduced for reliability branching, based on pseudo-cost relative errors
    and comparing candidates with the best pseudo-candidate using a 2-sample student-T test. These methods
    are used in disjunction with the existing reliability notion that uses a fixed number as reliability
    threshold for every variable before turning off strong-branching. This means, the classical method
    must be turned off by setting parameters minreliable and maxreliable to 0. The behavior is
    controlled through several parameters.
  - new distribution branching rule to base decisions on row activity (normal) distribution over domain space
  - can now output information for BAK: Branch-and-bound Analysis Kit
  - new score in hybrid reliability pseudocost branching that prefers nonlinear variables when solving MINLPs
  - new branching rule multaggr which allows to branch on general disjunctions defined by fractional multi-aggregated variables
  - new branching rules for SOS1 constraints for branching on a neighborhood or a complete bipartite subgraph of
    the conflict graph. In addition to variable domain fixings, it is sometimes also possible to add complementarity
    constraints to the branching nodes. This results in a nonstatic conflict graph, which may change dynamically
    with every branching node.
  - new branching rule nodereopt to reconstruct the tree after changing the objective function

- Reader:
  - the MPS reader can now read semi-integer variables, they are handled by creating bound disjunction constraints
  - the MPS reader can now handle objective constants given as (the negation of) the RHS of the objective row

- Separation:
  - obbt propagator applies now additional separation and propagation in order to learn stronger and more bound tightenings
  - extended probing mode to allow separation and objective coefficient changes
  - improved separation procedure of SOS1 constraint handler, including bound (clique) cuts and implied bound cuts
  - new disjunctive cut separator for SOS1 constraints
  - new edge-concave cut separator for quadratic constraints

- Presolver:
  - Improved coordination of presolvers. There are three timings for presolvers now, FAST, MEDIUM and EXHAUSTIVE.
    Each presolving callback can specify one or more of these timings in which it will be called later.
    Within a presolving method, the current timing can be checked and the algorithms to be performed selected based on
    the timing. In one presolving round, first all presolving methods with timing FAST are called, sorted by priority.
    If they found enough reductions, a new round is started, otherwise, all presolving methods with timing MEDIUM are
    called. Again, with enough reductions, a new presolving round is started, too few reductions lead to running
    the EXHAUSTIVE presolvers. Similar to the delay concept used before, we are not neccessarily running all EXHAUSTIVE
    presolvers but stop as soon as one of them found enough reductions, starting a new presolving round immediately.
  - new presolving components for SOS1 constraints, including bound tightening and clique extension
  - new presolver tworowbnd for improving variable bounds and detecting redundant constraints added
  - new presolver dualagg for aggregating single up-/downlocked variables by a binary variable added
  - new presolver implfree for aggregating implied free variables added
  - new presolver redvub which can detect redundant variable upper bound constraints added
  - new presolver stuffing for fixing of singleton continuous variables added

- Heuristic:
  - improved clique and variable bound heuristics
  - new heuristic distribution diving that bases its score function on the changes regarding solution density
  - variable histories can be transferred between sub-SCIPs solved by LNS heuristics and the component presolver
    and the main SCIP to reuse this information.
  - new heuristic heur_indicator that tries to make partial solutions with indicator constraints feasible. It also
    tries to improve them (or external solutions) by a one-opt local search.
  - new heuristic (heur_bound) which fixes all integer variables to their lower/upper bounds and solves the remaining LP
  - modified diving heuristics to handle SOS1 constraints
  - new primal heuristic for reoptimization 'ofins': objective function induced neighborhood heuristic
  - new heuristic for reoptimization which constructs solutions based in the changes between the objective function and the optimal
    solution before changing the objective function

- Statistic:
  - extended variable branching statistics in the interactive shell by sample variance of unit gains
  - extended statistic output of interactive shell by more information on diving heuristic behavior

Performance improvements
------------------------

- improved treatment of nonlinearities in hybrid reliability pseudo cost branching
- using sparsity information of the SoPlex LP

- Constraints:
  - improved vartype upgradability from continuous to implicit variables in cons_linear.c, depending on their objective coefficients
  - improved propagation of SOS1 constraint handler using the information from a conflict

- Heuristics:
  - zi rounding heuristic uses buffer data structures, thereby decreasing total memory usage of SCIP
  - adjusted (hard) diving heuristics to solve fewer LPs. LP's are resolved only if a parameter-defined
    percentage of the variable bounds changed through domain propagation or at a predefined frequency.
  - some of the diving heuristics additionally consider indicator variables and SOS1 variables as candidate variables and try to
    make these constraint types feasible before passing a rounded solution to SCIPtrySol()

- Presolving:
  - new presolving/propagation algorithm using the gcd for ranged rows and equations in cons_linear
  - added presolving levels (FAST, MEDIUM and EXHAUSTIVE) to allow better balancing of presolvers

- Separation:
  - improved separation procedure of SOS1 constraint handler
  - improved separation procedure for convex quadratic constraints

Examples and applications
-------------------------

- two new applications for multi-objective optimization (PolySCIP) and the Steiner Tree Problem in Graphs
- new application for solving Steiner tree problems: SCIP-Jack can handle both the classical Steiner tree problem in graphs
  and 10 of its variants

Interface changes
-----------------

### New and changed callbacks

- new callback function `SCIP_DECL_CONSGETDIVEBDCHGS` to provide
  constraint handler method to suggest dive bound changes during the generic diving algorithm, see type_cons.h for details
- new callback `SCIP_DECL_DIVESETGETSCORE` to implement scoring function to guide diving

### Deleted and changed API functions

- avoid potential comparisons of different infinity values by adjusting the LP solution value
- SCIPintervalSign(),  SCIPintervalAbs(), SCIPintervalMax(), SCIPintervalMin(), SCIPexprgraphGetNodePolynomialMonomialCurvature(),
  and SCIPexprgraphTightenNodeBounds() need an infinity value to decide whether an interval is empty or not
- SCIPgetFeasibilityQuadratic() and SCIPgetActivityQuadratic() returns now a `SCIP_RETCODE` and needs an additional `SCIP_Real*` to
  store the result
- methods which support statistical tests in pub_misc.h, SCIPstudentTGetCriticalValue(), SCIPcomputeTwoSampleTTestValue() etc.
- SCIPsolveLinearProb() solves a linear problem of the form Ax=b for a regular square matrix A
- Added parameter `freesubscip` to SCIPapplyProximity()

- Data structures:
  - Renamed method SCIPdigraphGetSuccessorsDatas() to SCIPdigraphGetSuccessorsData()
  - Renamed method SCIPdigraphGetNodeDatas() to SCIPdigraphGetNodeData()
  - Renamed method SCIPdigraphSetNodeDatas() to SCIPdigraphSetNodeData()

- Constraint Handlers:
  - Renamed method SCIPconshdlrGetPropTimingmask() to SCIPconshdlrGetPropTiming()
  - new method SCIPconshdlrSetPropTiming()
  - Removed method SCIPconshdlrIsPresolvingDelayed()
  - Removed method SCIPconshdlrWasPresolvingDelayed()
  - SCIPmakeSOS1sFeasible() based on solution values, fixes variables to zero to turn all SOS1 constraints feasible
  - removed `delay(presol)` parameter from SCIPinclude{Conshdlr,Presol,Prop}() and added `(presol)timing` parameter
  - new parameter `presoltiming` for method SCIPpresolCons()
  - SCIPvarIsSOS1() returns whether some variable is involved in an SOS1 constraint
  - SCIPgetConflictgraphSOS1() gets conflict graph of SOS1 constraints
  - Added parameter `presoltiming` to SCIPpropCumulativeCondition()
  - Removed parameter `delaypos` from SCIPsetConshdlrPresol()
  - Added parameter `presoltiming` to SCIPsetConshdlrPresol()
  - Removed parameter `delaypos` from SCIPincludeConshdlr()
  - Added parameter `presoltiming` to SCIPincludeConshdlr()
  - Added parameter `consgetdivebdchgs` to SCIPincludeConshdlr() to provide a divebdchg-callback for the constraint handler
    to include

- Branching Rules:
  - Added parameter `forcestrongbranch` to SCIPselectVarStrongBranching()
  - Added parameter `executebranching` SCIPexecRelpscostBranching()
  - Added parameters `ndomredsdown` and `ndomredsup` to SCIPgetVarStrongbranchWithPropagation()

- LP and Cutting Planes:
  - Added parameters `inds` and `ninds` to SCIPgetLPBInvRow(), SCIPgetLPBInvCol(), SCIPgetLPBInvARow(), SCIPgetLPBInvACol(), and
    SCIPcalcStrongCG()
  - Added parameters `maxweight`, `weightinds`, `nweightinds`, and `rowlensum` to SCIPcalcMIR()

- Variables:
  - SCIPvarGetNodeSOS1() returns node of SOS1 variable in the conflict graph
  - SCIPnodeGetVarSOS1() returns SOS1 variable associated to some given node in the conflict graph
  - Removed method SCIPvarGetNBinImpls()

- Presolving:
  - Removed parameter `delaypos` from SCIPincludePresolBasic()
  - Added parameter `presoltiming` to SCIPincludePresolBasic()
  - Removed parameter `delaypos` from SCIPincludePresol()
  - Added parameter `presoltiming` to SCIPincludePresol()
  - Removed parameters `presoldelay` and `presoltiming` from SCIPincludePresol()
  - Removed parameters `presoldelay` and `presoltiming` from SCIPsetPropPresol()

- Misc:
  - Added parameter `isequation` to SCIPaddClique()
  - Removed parameter `writeimplications` from SCIPwriteCliqueGraph()
  - Removed method SCIPallocBufferSize()
  - Removed method SCIPduplicateBufferSize()
  - Removed method SCIPreallocBufferSize()
  - Removed method SCIPfreeBufferSize()
  - Removed method callback SCIPdialogExecConflictgraph()

### New API functions

- started support for user-defined operators in expression trees/graphs (see SCIPexprCreateUser()),
  interface will likely change again in future SCIP versions
- new methods for mixed inter linear matrix access (see pub_matrix.h) added
- SCIPcomputeArraysIntersection() to compute the set intersection of two ordered arrays
- SCIPcomputeArraysSetminus() to compute the set difference of two ordered arrays
- SCIPcutGetLPActivityQuot() in pub_cutpool.h to get the potion of LP's where this cut was sharp in an optimal basis.
- SCIPpresolGetTiming(), SCIPpresolSetTiming(), SCIP{conshdlr,prop}GetPresolTiming(), and SCIP{conshdlr,prop}SetPresolTiming()
- SCIPdigraphSetNSuccessors() sets the number of successors of some digraph node to a given value

- Diving:
  - SCIPcreateDiveset() to add a diveset to a heuristic. Heuristics may have multiple divesets under different names
  - SCIPperformGenericDivingAlgorithm() that performs diving with periodic LP resolve according to the diveset argument.

- Constraints:
  - new setter function SCIPsetConshdlrGetDiveBdChgs() in scip.h to set dive bound change callback for this constraint handler
  - SCIPaddDiveBoundChange() to add a diving bound change to the diving bound change storage of SCIP together with the information if this is a
    bound change for the preferred direction or not, to be used by constraint handlers inside the getDiveBdChgs-callback
  - SCIPchgCoefLinear() and SCIPdelCoefLinear() to modify linear constraint during problem creation

- Memory:
  - BMSallocClearBlockMemoryArray()/SCIPallocClearBlockMemoryArray() and
    BMSallocClearBufferMemoryArray(), SCIPallocClearBufferArray() to allocate arrays that are initialized to 0
  - SCIPbuffermem() to get buffer memory;

- Sort:
  - added new sorting functions SCIPsortRealRealRealBoolBoolPtr(), SCIPsortDownRealRealRealBoolBoolPtr()
  - added new sorting functions SCIPsortIntIntIntReal(), SCIPsortDownIntIntIntReal(), SCIPsortRealIntInt(), SCIPsortDownRealIntInt()

- Param:
  - SCIPwriteParam() to write a single parameter to a file
  - SCIPcheckParam{Bool,Char,...}() to check whether a parameter value is within the feasible domain

- Quadratic:
  - SCIPchgLhsQuadratic(), SCIPchgRhsQuadratic(), SCIPchgLinearCoefQuadratic(), SCIPchgSquareCoefQuadratic(),
    and SCIPchgBilinCoefQuadratic() to modify quadratic constraints during problem creation
  - SCIPgetFeasibilityQuadratic() and SCIPgetActivityQuadratic() to get the feasibility and activity of a quadratic constraint in a given solution
  - SCIPaddSquareLinearization(), SCIPaddSquareSecant(), SCIPaddBilinLinearization() and SCIPaddBilinMcCormick()
    in cons_quadratic.h to compute linear under- and overestimation for bilinear and quadratic terms

### Command line interface

- extended variable branching statistics and statistic output in the interactive shell (see Statistic section)
- submenu for setting `vbc` settings renamed to `visual`
- at the end of a command line run the best solution can now be output in the orignal space

### Interfaces to external software

- in the AMPL interface, variable and constraint attributes (flags) can now be set via suffixes, where 0 (unset) stands
  for the default, 1 for TRUE and other values for FALSE; see SCIPcreateVar() and SCIPcreateCons() for their meaning;
  for variables, `initial` and `removable` are recognized;
  for constraints, `initial`, `separate`, `enforce`, `check`, `propagate`, `dynamic` and `removable` are recognized
- the AMPL interface now passes an initial guess, if specified, as a solution (that will be checked for feasibility) to SCIP

### Changed parameters

- rowrepswitch set to 2.0, so row representation is activated if LP has at least 2 times more rows than columns
- one can now set emphasis parameters at the beginning of a settings file; it should start with `emphasis:` and
  the contain the emphasis string, e.g., `emphasis: feasibility` or `emphasis: heuristics off`.

- Renamed parameters:
  - `vbc/filename` to `visual/vbcfilename`
  - `vbc/realtime` to `visual/realtime`
  - `vbc/dispsols` to `visual/dispsols`

### New parameters

- added parameter to switch pseudo cost update in diving heuristics (enabled by default)
- `branching/relpscost/confidencelevel` to set the confidence level to be used by statistical tests
- `branching/relpscost/higherrortol` to define the highest reliability threshold for relative error based reliability
- `branching/relpscost/lowerrortol` to define a lower reliability threshold for relative error based reliability
- `branching/relpscost/nlscoreweight` for weight of nonlinear score when branching on MINLPs
- `branching/relpscost/usedynamicconfidence` to use a dynamic confidence level based on the amount of
  strong-branching simplex-iterations compared to the overall simplex iterations (default is FALSE)
- `branching/relpscost/usehyptestforreliability` to enable strong branching decisions based on a 2-sample student-T test of all prior
  pseudo-cost observations between the best pseudo-candidate and the candidate for which to decide whether strong-branching should be applied
- `branching/relpscost/userelerrorreliability` to enable relative error based reliability
- `branching/relpscost/skipbadinitcands` for skipping strong-branching candidates whose estimated gain
  is significantly worse than the one of the locally best (sb or pseudo) candidate
- `constraints/linear/multaggrremove` to perform multi-aggregations in linear constraint handler only if the constraint can be removed afterwards
- `constraints/linear/rangedrowpropagation` to disabled newly implemented propagtion algorithm for ranged rows and equations
- `constraints/quadratic/advanced/interiorcomputation` to select the way of computing and interior point for gauge cuts
- `constraints/quadratic/gaugecuts` to enable convex quadratics to generate gradients cuts which are supporting
- `constraints/soc/generalsocupgrade` to allow general quadratics to be upgraded to soc
- `constraints/SOS1/addcomps` to add local complementarity constraints to the branching nodes (can be used in combination
  with neighborhood or bipartite branching)
- `constraints/SOS1/addbdsfeas` to define a minimal feasibility value for local bound (clique) inequalities in order to be
  added to the branching node
- `constraints/SOS1/addcompsdepth` to define the maximal depth for adding complementarity constraints
- `constraints/SOS1/addcompsfeas` to define a minimal feasibility value for local complementarity constraints in order to be
  added to the branching node
- `constraints/SOS1/autocutsfromsos1` to automatically switch to separating bound cuts from SOS1 constraints if the SOS1
  constraints do not overlap
- `constraints/SOS1/autosos1branch` to switch to SOS1 branching if the SOS1 constraints do not overlap
- `constraints/SOS1/conflictprop` to define whether to use conflict graph propagation
- `constraints/SOS1/bipbranch` to branch on a complete bipartite subgraph of the conflict graph
- `constraints/SOS1/boundcutsdepth` to define the node depth of separating bound (clique) cuts
- `constraints/SOS1/boundcutsfreq` to define the frequency for separating bound (clique) cuts
- `constraints/SOS1/boundcutsfromgraph` to define whether to separate bound (clique) inequalities from the conflict graph
- `constraints/SOS1/boundcutsfromsos1` to define whether to separate bound (clique) inequalities from SOS1 constraints
- `constraints/SOS1/fixnonzero`: If neighborhood branching is used, then fix the branching variable (if positive in sign)
  to the value of the feasibility tolerance
- `constraints/SOS1/implcutsdepth` to define the node depth of separating implied bound cuts
- `constraints/SOS1/implcutsfreq` to define the frequency for separating implied bound cuts
- `constraints/SOS1/implprop` to define whether to use implication graph propagation
- `constraints/SOS1/maxaddcomps` to define the maximal number of complementarity constraints added per branching node
- `constraints/SOS1/maxboundcuts` to define the maximal number of bound (clique) cuts separated per branching node
- `constraints/SOS1/maxboundcutsroot` to define the maximal number of bound (clique) cuts separated per iteration in the root node
- `constraints/SOS1/maximplcuts` to define the maximal number of implied bound cuts separated per branching node
- `constraints/SOS1/maximplcutsroot` to define the maximal number of implied bound cuts separated per iteration in the root node
- `constraints/SOS1/maxextensions` to define maximal number of extensions that will be computed for each SOS1 constraint in presolving
- `constraints/SOS1/maxsosadjacency` to define that the adjacency matrix of the conflict graph is not created in presolving if
  the number of SOS1 variables is too large
- `constraints/SOS1/maxtightenbds` to define the maximal number of bound tightening rounds per presolving round
- `constraints/SOS1/neighbranch` to branch on a neighborhood of the conflict graph
- `constraints/SOS1/nstrongiter` to define the maximal number LP iterations to perform for each strong branching round
- `constraints/SOS1/nstrongrounds` to define the maximal number of strong branching rounds to perform for each node (only
  available for neighborhood and bipartite branching)
- `constraints/SOS1/sos1branch` to branch on a single SOS1 constraint, i.e., a clique of the conflict graph
- `constraints/SOS1/sosconsprop` to define whether to use SOS1 constraint propagation
- `constraints/SOS1/strthenboundcuts` to define whether to strengthen bound (clique) cuts in case bound variables are available
- `constraints/SOS1/updateconflpresol` to update the conflict graph during the presolving procedure
- `display/allviols` to print all violated constraints of the best solution during checksol in the scip shell
- `heuristics/indicator/improvesols` that turns on the improvement of external solutions by one-opt
- `heuristics/*diving/lpresolvedomchgquot` to determine the percentage of changed domains since previous LP to trigger
  an LP resolve [default: 0.15] (* stands for eight diving heuristics to support this feature)
- `heuristics/*diving/lpsolvefreq` to determine the frequency for resolving LP's during the execution of
  this heuristic [default: 1, use 0 for a dynamic setting based on the number of domain reductions]
  (* stands for eight diving heuristics to support this feature)
- `heuristics/shiftandpropagate/binlocksfirst` to set if binaries without locks should be preferred in ordering
- `heuristics/shiftandpropagate/maxcutoffquot` to select a maximum percentage of allowed cutoffs before stopping the heuristic (default is 0.0)
- `heuristics/shiftandpropagate/selectbest` to trigger if shiftandpropagate should select the best candidate in every round
  (set to FALSE for static order) (default is FALSE)
- `limits/autororestart` for triggering an automatic restart after this many nodes, or -1 for no auto restart [default is -1]
- `limits/softtime` to set a soft time limit (active only after first primal solution was found)
- `misc/allowobjprop` to allow objective function propagation
- `misc/allowdualreds` to allow dual reductions
- `misc/outputorigsol` to control whether at the end of a command line run the solution should be output in the orignal space
- `numerics/checkfeastolfac` to scale feasibility tolerance when checking the feasibility of best found solution
  after the solving process finished (e.g., checksol in scip shell)
- `separating/cutselrestart` for cut selection during restart copy process (`a`ge, activity `q`uotient) [default is `a`]
- `separating/cutselsubscip` for cut selection for sub SCIPs (`a`ge, activity `q`uotient) [default is `a`]
- `separating/disjunctive/maxconsdelay` to delay separation of disjunctive cuts if number of SOS1 constraints is larger than predefined value
- `separating/disjunctive/maxdepth` to define the node depth of separating disjunctive cuts
- `separating/disjunctive/maxinvcuts` to define the maximal number of disjunctive cuts investigated per iteration in a branching node
- `separating/disjunctive/maxinvcutsroot` to define the maximal number of disjunctive cuts investigated per iteration in the root node
- `separating/disjunctive/maxrank` to define the maximal permissible rank of a disjunctive cut that could not be scaled to integral coefficients
- `separating/disjunctive/maxrankintegral` to define the maximal permissible rank of a disjunctive cut that could be scaled
  to integral coefficients
- `separating/disjunctive/maxrounds` to define the maximal number of separation rounds of disjunctive cuts in a branching node
- `separating/disjunctive/maxweightrange` to define the maximal valid range of simplex tableau row weights

### Data structures

- new enum `SCIP_CONFIDENCE_LEVEL` for different levels of confidence for statistical tests.
- new struct `SCIP_DIVESET` that bundles options for SCIP's diving heuristics; all hard diving heuristics (those
  without `obj` at the beginning) include diveset and implement only the scoring callback.
- rename all file `*_vbc.?` to the more generic `*_visual.?`
- moved buffer memory handling to blockmemory/memory.?;
  remove files type_buffer.h, struct_buffer.h buffer.h buffer.c;
  removed functions SCIP*buffer*() from scip.? and replaced them by macros;
  redesigned buffer interface to be similar to block memory; added checks for strange sizes

Testing
-------

- added scripts and targets for testing with xpress (see Makefile section)

Build system
------------

### Makefile

- new parameter `DELHEADERS` for `uninstall`-target: scip headers are only removed when invoking `make uninstall DELHEADERS=true`
- added scripts check_xpress.awk, check_xpress.sh, evalcheck_xpress.sh and check_cluster_xpress.sh and target
  `testclusterxpress` and `testxpress`

Fixed bugs
----------

- fixed bug in primal.c and tree.c by using SCIPinfinity() as a cutoffbound to delete child nodes
- fixed bug in lp.c which leads to wrong primal and dual feasibility
- fixed wrong handling of infinite activities and primal values in sepastore.c and lp.c
- fixed bug that led to an erroneous warning about the clock type
- fix behavior of `make install` which now sets symbolic links and short links to binaries and libraries
- fix bug which lead to wrong global bound tightenings in prop_genvbounds.c
- fix call to random generator for Windows operating systems in misc.c
- fixed again a bug in backward propagation of linear expressions in expression graph
- fixed bug in prop_symmetry.c, where an incorrect weak symmetry handling constraint got added.

- NLP:
  - fixed bug in heur_nlpdiving.c: wrong counting of fix variables
  - fix wrong handling of `SCIP_NLPSOLSTAT_LOCALINFEASIBLE` solution status in nlp.c
  - fix characterization of logic or constraints in SCIP's NLP relaxation

- Branching:
  - fixed wrong comparison when executing branching rule for external branching candidates
  - fix spatial branching on implicit integer variables
  - fix wrong comparisons of values larger/less than +/- SCIPinfinity() in branch.c, lp.c and sol.c
  - fixed problem with lpisrelax flag in probing mode when doing branch-and-price

- Constraint Handlers:
  - try to handle fixings of multi-aggregated variable in cons_sos1 presolving and avoid error
  - fixed bug in pseudoboolean constraint handler about negated variables
  - fixed assert in cons_soc.c: now soc with 1 lhs variable are allowed
  - fixed wrong assert in cons_indicator (slack variables might be replaced by active variables that have nonzero objective)
  - fix late creation of auxiliary LP in cons_nonlinear.c, which lead to a segmentation fault with lpi_spx2.cpp
  - fixed bug in cons_abspower.c: do not generate cuts with infinity right-hand-side anymore
  - fixed setting of enforcement flag for constraints created by reformulation in nonlinear constraint handlers
  - fixed bug in cons_indicator with handling local bounds

- Memory:
  - fix potential memory leak in SoPlex LP interfaces when setting invalid basis
  - fix potential memory leak in method SCIPgetConsCopy()
  - fix potential memory leak in method detectRedundantConstraints() of the knapsack constraint handler

- Interval arithmetic:
  - fix handling of infinite intervals in SCIPintervalIsEmpty()
  - fixed bug in intervalarith.c: bivariate quadratic equations may have been solved wrongly if second variable is unbounded

- Quadratic Constraints:
  - fix wrong sorting of bilinear terms in cons_quadratic
  - fix potentially tightening of LB/UB of a variable to +/- infinity in cons_quadratic
  - fixed bug in cons_quadratic.c which leads to an overflow when SCIP allocates memory for a dense matrix
  - fixed bug in cons_quadratic.c: do not generate linearization cuts for disabled constraints
  - fix missing clean phase of bilinear terms with zero coefficient in cons_quadratic.c

@page RN3_1 Release notes for SCIP 3.1

@section RN311 SCIP 3.1.1
*************************

Features
--------

- use clock average to reduce number of system calls via `timing/rareclockcheck` parameter
- added copy mechanism for conjunction constraints
- added revised lpi_xprs for using XPRESS as LP solver

Performance improvements
------------------------

- improved solving of LPs in OBBT propagator
- improved activity-delta computation and thereby propagation for linear constraints
- improved memory management of proximity heuristic
- disabled statistic timing in all subscips via new parameter `timing/statistictiming`

Interface changes
-----------------

### New and changed callbacks

- rename array arcdatas in digraph to arcdata
- changes in clock type are now transferred to SoPlex
- corrected wrong primal bound in statistics for unbounded problems
- forbid to call SCIPfixVar() in `SCIP_STAGE_PRESOLVED` stage, which is not allowed since it calls SCIPchgVarLb/Ub()

### Deleted and changed API functions

- rename SCIPdigraphGetNodeDatas() to SCIPdigraphGetNodeData();
- rename SCIPdigraphSetNodeDatas() to SCIPdigraphSetNodeData()
- SCIPapplyProximity() has an additional parameter freesubscip, which causes the method to free
  the created subscip automatically at the end.

### New API functions

- SCIPhasPerformedPresolve() to check, e.g., whether LP duals are accessible
- SCIPconvertRealTo[Long]Int() to convert reals that represent integers to [long] ints.
- SCIPisDualfeasEQ() and related to perform checks w.r.t. to the dual feasibility tolerance
- SCIPdeleteSubproblemProximity() to free proximity subproblem manually as external caller

### Command line interface

- added dialog for writing the finite solution (calling SCIPcreateFiniteSolCopy() before writing)

### Interfaces to external software

- AMPL interface now returns dual multipliers if problem is an LP and presolving was turned off

### Changed parameters

- changed default value of parameter `heuristics/proximity/minimprove` to 0.02; previous value was 0.25
- changed default value of parameter `heuristics/proximity/usefinallp` to FALSE

### New parameters

- `timing/rareclockcheck` to call the system time less frequently, based on the current average time interval
  between two calls to SCIPsolveIsStopped(); the default value is FALSE
- `timing/statistictiming` to enable/disable all timers for statistic output of SCIP; the default value is TRUE

### Data structures

- renamed MIP matrix structure to `SCIP_MATRIX`
- changed the numeric values for `PRESOLTIMING` flags

Build system
------------

### Makefile

- added Makefile support for cygwin 64 Bit
- allow to turn off block and buffer memory by the makefile parameters NOBLKMEM, NOBUFMEM, NOBLKBUFMEM;
  also remove the now superfluous makefiles for noblkmem, nobufmem, noblkbufmem

Fixed bugs
----------

- fixed wrong conversion of reals representing negative integer values
- in debug mode, SCIP checks that no NaN's are introduced in SCIPsolSetVal()
- fixed bug 697 (and 699), calling SCIPsolve() after the problem was already solved and SCIPfreeSolve() was called now
  does nothing anymore
- added support for character `#` in variable names in old non-linear CIP format (i.e., names without `<` and `>`)
- fixed bug 702, removed too hard assert when casting too big values into `SCIP_Longint`
- branching for continuous variables with unbounded intervals now takes `branching/clamp` into account
- forbid aggregations with scalar smaller feastol or larger 1/feastol
- fixed bug 683, not recognizing errors/segfaults especially in free stage of SCIP by improving the check scripts
- fixed bug where quieting a message handler also disabled writing to files other than stdout
- fixed bug 708, special case of implications led to a fixing
- fixed bug, variable bounds detected wrong infeasibility
- another bug fix when computing the original variable sum of a given variable in SCIPvarGetOrigvarSum()
- fixed setting solution value of multi-aggregated var in xml-solution case
- fixed bug changing the variable type of an negated variable
- fixed numerical troubles in SCIPcreateFiniteSolCopy()
- fixed bug in SCIPpermuteProb(): if called before transforming the problem, data structures were not initialized yet
- fixed bug in aggregation procedure if two variables were of non-binary type but for one of the variables
  SCIPvarIsBinary() returned true
- treat activities of pseudo solutions as invalid when containing positive and negative infinity contributions
- fixed bug in GMI example: fractionality of slack variable is now computed correctly
- fixed LP interface of CPLEX: functions getBInv* return the correct sign of the coefficients.
- fixed bug in SCIPpermuteProb(), when called in transformed stage and non-active constraints exist

- Dual:
  - use dual feasibility tolerance for comparisons regarding reduced costs
  - fixed bug in prop_dualfixing: don't fix variables to infinite values during solving
  - fixed sign of the dual multipliers returned by AMPL interfaces for maximization

- Objective and Time Limit:
  - fixed wrong output of status when an objective limit was imposed but not reached yet
  - fixed the rare case that branching was performed even though strong branching found global bound changes leading to
    an infeasible/objlimit LP
  - fixed bug that objective limit was not reset correctly during SCIPfreeTransform() for maximization problems
  - fixed bug that hitting the time limit while solving a pure LP and then continuing the solving process lead to
    not solving the LP, but always creating a single child node until maximum depth is reached

- Heuristic:
  - fixed bug leading to an incorrect dual bound when solving probing LPs within a DURINGPRICINGLOOP heuristic
  - fixed bug in proximity heuristic which attempted to enter diving mode even at nodes without a constructed LP
  - fixed wrong pseudo cost updates during diving heuristic execution after backtracking
  - fixed bug in heur_oneopt: avoid bound violations if shift value is negative due to infeasibilities
  - fixed bug that reaching a solution limit by beforenode heuristics lead to disregarding the current node if the
    optimization process was restarted later
  - fixed bug in trysol heuristic not saving the best solution in maximization problems

- Presolve:
  - fixed bug in presolving of abspower constraints that lead to wrong variable locks
  - allow to call SCIPmarkConsPropagate() in INITPRESOLVE stage
  - fixed bug in components presolver with handling of dual fixable variables: unboundedness was not detected,
    better handle components with single variables by dual fixing propagator
  - issues in component solving by presol_components do not lead to stopping the overall process, anymore, the component
    is just disregarded

- Memory:
  - fixed bug with freeing problem: need to reset objective limit
  - fixed memory leaks in case of erroneous parsing of constraints, e.g., non-linear constraints
  - fixed missing memory allocation for node data in digraphs

- Constraints:
  - fixed bug in cons_quadratic which leads to wrong min/max activities
  - removed wrong break in cons_pseudoboolean
  - fixed bug in cons_varbound.c using the wrong constraint side for updating an upper bound
  - fixed bug in presolve of cons_nonlinear: wrong constraint upgrades may have been performed due to outdated bound
    information in expression graph
  - fixed bug in cons_setppc, wrongly aggregating variables if dual-presolving was disabled
  - fixed bug in cons_sos1: locks and events were not initialized if constraint was added to transformed problem
  - fixed bug in cons_setppc with dual presolving disabled
  - corrected copy of disjunction constraints

- Reading:
  - allow to read numbers like `42856.` in lp-format
  - fixed bug(?) in reader_mps: variables are now written in columns section even of they occur in no constraint
    and have an objective coefficient of 0 (otherwise, CPLEX and Gurobi cannot read the file)
  - fixed bug with reading `>=1` indicator constraints in LP-files
  - fixed bug in reader_lp which created two indicator constraints with the same name to trigger an equality
  - fixed bug when reading indicator constraints for linear constraints (equations/ranged rows) from MPS files

@section RN310 SCIP 3.1.0
*************************

Features
--------

- added breadth first search node selection
- new node selection rule UCT which balances exploration and exploitation by considering node visits
- added possibility to not set a cutoff bound in the LP solver (can be enabled by setting `lp/disablecutoff` to TRUE)
- added missing debugging solution check for cliques
- added a data pointer to each node of the `SCIP_DIGRAPH`
- SCIPgetVarCopy() will now copy the original bounds when called for an original variable
- added upgrade of continuous variables to implicit variables for linear equations even if the coefficient is
  not equal to 1
- probing supports implicit binary variables
- added scaling to computation of relative interior point in SCIPcomputeLPRelIntPoint()

- Solution:
  - added two methods to iterate over a sparse solution (`SCIP_SPARSESOLUTION`), see pub_misc.h
  - it is now possible to add an offset for the original problem instance, all original solutions will be initialized with
    this value and updated, when the offset is changed
  - extended and corrected dual feasibility checks for LP solution (controlled by parameter `lp/checkdualfeas`)

- Cuts and Separation:
  - the rank of cuts is now stored and taken into account to improve numerical stability
  - added possibility to separate a cutpool w.r.t. a given solution (instead of LP-solution)

- Branching:
  - new branching rule `cloud branching` that considers several alternative LP optima
  - additional vbc output added: branching information is printed earlier and also for nodes which were cut off
  - added support for strong branching with domain propagation in full strong and reliability pseudo cost branching
  - added strong branching with domain propagation support: in SCIPstartStrongbranch(), support for propagation can
    be enabled (uses the probing mode, some overhead compared to standard strong branching), after that
    SCIPgetVarStrongbranchWithPropagation() can be used to perform strong branching on a variable with previous domain
    propagation; similar to probing, valid bounds for variables are collected
  - strong branching with propagation can be enabled in fullstrong and relpscost branching rule
  - added possibility to store pricing norms of the LP solver (in addition to basis information) to speed up LP solving
    after a backtrack, e.g. in probing or strong branching with domain propagation
  - a pricer can now return that no further pricing should be done but rather early branching, even if it added variables

- LP interface:
  - SoPlex (>= 1.7.0.5) can compute condition number of current basis matrix via LP interface
  - LPI files (lpi*.[h|c]) all moved from src/scip to src/lpi

- Constraints:
  - added propagation method to cons_xor relying on Gaussian elimination, which can also produce feasible solutions
  - added first implication detection in cons_linear
  - cons_indicator can now try to construct feasible solutions from a cover
  - added possibility to forbid upgrading of linear constraints
  - new initial constraints are now added to the LP before solving a probing LP
  - first implementation of parsing for nonlinear constraints in CIP format
  - added upgrade from varbound constraints to set-packing constraints
  - added upgrade from bounddisjunction constraints to set-packing/logicor constraints
  - cumulative constraint handler adds disjunctive constraints (cumulative with capacity 1) for all jobs which cannot
    be processed in parallel
  - added new clique extraction algorithm for linear constraints
  - the slack variables of indicator constraints can now be scaled
  - added redundancy check of sides of ranged row varbound constraint
  - added coefficient tightening for ranged row varbound constraint
  - XOR constraint handler can add two extended formulations (flow/asymmetric, parameter `addflowextended/addextendedform`)
  - added multi-aggregation for binary variables with at most two uplocks and two downlocks, which emerge from set-
    partitioning or set-packing constraints
  - added upgrade from quadratic constraints to set-packing constraints
  - generalized the linking constraint handler

- Reader:
  - can now read and write CIP-files with (multi-)aggregated variables
  - all readers now take the global parameters `reading/dynamic{conss|cols|rows}` and `reading/initialconss` into account
  - added reader_pbm, which writes the constraint-variable incidence matrix in pbm format (possibly scaled to given size)
  - reader_osil can now read SOS1 and SOS2 constraints
  - reader_lp and reader_mps are now able to write and-constraints in form of their (weak/strict) relaxation
  - added reading capability to GAMS reader (if compiling with GAMS=true, requires a GAMS system)
  - added capability of writing SOS1/2 constraints to GAMS reader (introduces extra variables and equations)

- Heuristic:
  - new primal heuristics dual value
  - new LNS heuristic called `proximity`, which solves a problem in which a local branching constraint replaces the
    objective function which in turn is treated as additional constraint
  - new LP-based rounding heuristic (heur_randround) whose randomized rounding is biased towards the LP solution value;
    the heuristic uses the probing mode of SCIP to generate conflict clauses on the fractional variables

- Presolving:
  - added new dual presolving for setppc-constraints
  - changed dualfix presolver to propagator such that dual fixing can also be applied during repropagation of the root node
  - added full-dual presolving step in setppc constraint handler
  - dual solution can now be displayed for pure LPs when no presolving was performed
  - added clique presolving for xor constraints
  - added presolving using pairs of variable bound constraints that use the same variables
  - added more presolving to cons_indicator, checking whether indicator/slack variables are aggregated
  - added presolve.{c,h} which should be used for all preprocessing mechanisms executed from within SCIP, corresponding to
    solve.{c,h} and also for presprocessing methods which can be called from different plugins or from the core to avoid
    code doubling
  - return error if variable should be fixed to infinity after presolving (LP-solvers do not handle this consistently)
  - in verblevel `SCIP_VERBLEVEL_FULL`, the number of non-zeros will be output for the original and presolved model
  - new presolving step for tightening logicor constraints using implication and clique information
  - several new presolving steps for linear and knapsack constraints, using gcd information and many more

- Statistic:
  - added average gap based on primal-dual integral to solution statistics; can be disabled via parameter
    `misc/calcintegral`
  - the statistics now include the value of the first LP solved at the root node (without cuts)
